var memcache = require('memcached');

exports.getCache = function(key,cachedUrl) {
  return new Promise(function(resolve,reject) {
  var client  = new memcache(cachedUrl);
 
  client.get(key, function (error, data) {
   if(error)
      reject('');
   else
     resolve(data);
  });
   });
 };

 exports.getCacheData = function(key,cachedUrl,callback){
  var client  = new memcache(cachedUrl);

  client.get(key, function (error, data) {
    if(error){
     
     return callback(error);
    }else{
      
    return callback(null,data);
    }
  });
 }

 exports.setCache = function(key, cachedUrl,value) {
    var client  = new memcache(cachedUrl,{maxExpiration:172800});
    var json=JSON.stringify(value);
    client.set(key,json, 172800, function (error) { 
        if(error){

        }
    });
   
};