

const coreDB = require('qaq-core-db');
const memcached = require('./memcached');

exports.isTokenValid = function(params) {
     var db = params.db;
     var token = params.token;
     var app = params.app;
     var tokenquery = {};
     tokenquery["app"]=app;
     tokenquery["token"]=token; 
     var isVaild=false;
     return new Promise(function(resolve,reject) {
     coreDB.executeQuery(db,"QAPPLICATIONS",[],tokenquery,{} , function (error, result) {

        if(error){
         resolve(isVaild);
        }else{
            result=result||'';
          if(result.length >0){
            isVaild=true;
            }
        resolve(isVaild);
        }
    
    });
});

}

exports.getClientKey = function(params,cachedUrl,callback) {
    var ds = params.ds ||'';
    var appkey = params.appkey ||'';
    var status="";
    var massage="";
    var clientKey="";
    var appl_idn = "";
    let co_idn = "";
    let dfpool = "";
    memcached.getCacheData("applicationKeys",cachedUrl, function (error, data) {  
        if(error){
            status="FAIL";
            massage="memcached connection issue";
        }else{
            data=data||'';
            if(data!=''){
             var result = JSON.parse(data);
             var key = ds; //+"_"+appkey For dyanamic applcation login
             var clientDtl = result[key] || '';
            if(clientDtl != ''){
                clientKey = clientDtl.client_key;
                appl_idn = clientDtl.appl_idn;
                co_idn = clientDtl.co_idn;
                dfpool = clientDtl.dfpool;
                status="SUCCESS";
                massage="SUCCESS";
            }else{
                status="FAIL";
                massage="Data source is invalid";
            }

            }else{
            status="FAIL";
            massage="Client key is not available";
            }
        }
            var outjson ={
            "status":status,
            "massage":massage,
            "clientKey":clientKey,
            "applIdn":appl_idn,
            "co_idn":co_idn,
            "dfpool":dfpool
             }
       
            return callback(null,outjson);

    });

}

exports.tokenValidation = function(params,cachedUrl,callback) {
    var clientKey = params.clientKey ||'';
    var moduleKey = params.moduleKey ||'';
    var status="";
    var massage="";
    var co_idn="";
    var clientIdn="";
    var moduleIdn = "";
    var ds="";
    var pool="";
    memcached.getCacheData("clientModuleKeys",cachedUrl, function (error, data) {
        if(error){
            status="FAIL";
            massage="memcached connection issue";
        }else{
            data=data||'';
        if(data!=''){
         var result = JSON.parse(data);
          var clientDtl = result[clientKey]||'';
          if(clientDtl!=''){
            clientIdn=clientDtl.client_idn;
            co_idn=clientDtl.co_idn;
            var moduleDtl = result[moduleKey]||'';
            if(moduleDtl!=''){
                status="SUCCESS";
                massage="SUCCESS";
               
                moduleIdn=moduleDtl.client_idn;
                ds = moduleDtl.account_ds;
                pool=moduleDtl.pool;
            }else{
                status="FAIL";
                massage="module key is invalid";
            }

          }else{
            status="FAIL";
            massage="client key is invalid";
          }

         
         }else{
            status="FAIL";
            massage="memcached data not found";
         }
            
        }
    var outjson ={
     "status":status,
     "massage":massage,
     "coIdn":co_idn,
     "moduleIdn":moduleIdn,
     "clientIdn":clientIdn,
     "ds":ds,
     "pool":pool
     }

     return callback(null,outjson);

    });

}

exports.isLogin = function(params,callback){
    var db = params.db ||'';
    var loginid = params.loginid ||'';
    var status="";
    var massage="";
    var username="";
    var client_idn="";
    var category="";
    var userIdn="";
    var appl_idn="";
    var nme_idn="";
    var buyerIdn="";
    var userTyp ="";
    var alterEmpIdn=[];
    var dept = "";
    let client_nme = "";
    if(db!='' && loginid!=''){
        var sql="select a.appl_idn, b.user_idn,b.co_idn,b.nme_idn, status,c.client_idn,b.category,b.username, d.typ,d.alt_emp_idn , d.attr->> 'dept' dept ,c.account_ds "+
        " from appl_login_log a , appl_user b , appl_client c , nme_m d  where  a.log_in_valid_upto > now() and a.user_idn=b.user_idn "+
         " and b.co_idn=c.co_idn  and a.appl_idn=c.appl_idn and b.nme_idn=d.nme_idn  and log_idn=$1 and b.stt=1 and d.stt=1 and d.co_idn=b.co_idn  ";
        coreDB.executeTransSql(db,sql,[loginid],{} , function(error,result){
         if(error){
            
            status="FAIL";
            massage="Error in query excution";
         }else{
             
            var rows = result.rows;
            if(rows.length==1){
            var status = rows[0].status||'LI';
            if(status=='LI'){
                status="SUCCESS";
                massage="SUCCESS";
                username = rows[0].username;
                client_idn= rows[0].client_idn;
                category =  rows[0].category;
                userIdn= rows[0].user_idn;
                appl_idn=rows[0].appl_idn;
                nme_idn=rows[0].co_idn;
                buyerIdn = rows[0].nme_idn;
                userTyp = rows[0].typ;
                dept = rows[0].dept;
                alterEmpIdn = rows[0].alt_emp_idn||[];
                client_nme = rows[0].account_ds;
                alterEmpIdn.push(buyerIdn);
            }else if(status=='LO'){
                status="LOGOUT";
                massage="User logout from current session";
            }else if(status=='TO'){
                status="LOGOUT";
                massage="User time out from current session";
            }
          }else{
            status="LOGOUT";
            massage="User time out from current session";
          }
         }
         var index = alterEmpIdn.indexOf(null);
         if (index > -1) {
            alterEmpIdn.splice(index, 1);
         }
         var outjson ={
            "status":status,
            "massage":massage,
            "logUser":username,
            "clientIdn":client_idn,
            "category":category,
            "userIdn":userIdn,
            "applIdn":appl_idn,
            "coIdn":nme_idn,
            "nmeIdn":buyerIdn,
            "userType":userTyp,
            "groupEmpList":alterEmpIdn,
            "dept":dept,
            "client_nme":client_nme
            }
    
      return callback(null,outjson);
        });
    }else{
        status="FAIL";
        massage="verified input paramters";
    }

   
   
}

exports.isLoginWithModule =  function(params,callback){
    var db = params.db ||'';
    var loginid = params.loginid ||'';
    var moduleKey = params.moduleKey;
    var status="";
    var massage="";
    var username="";
    var client_idn="";
    var category="";
    var userIdn="";
    if(db!='' && loginid!=''){
        var sql='select b.user_idn, status,client_idn,category,username from appl_login_log a , appl_user b where  a.log_in_valid_upto > now() and a.user_idn=b.user_idn '+
                'and log_idn=$1 ';
        coreDB.executeTransSql(db,sql,[loginid],{} , function(error,result){
         if(error){
            status="FAIL";
            massage="Error in query excution";
           }else{
             
            var rows = result.rows;
            if(rows.length==1){
            var status = rows[0].status||'LI';
            if(status=='LI'){
                status="SUCCESS";
                massage="SUCCESS";
                username = rows[0].username;
                client_idn= rows[0].client_idn;
                category =  rows[0].category;
                userIdn= rows[0].user_idn;
               


            }else if(status=='LO'){
                status="FAIL";
                massage="User logout from current session";
            }else if(status=='TO'){
                status="FAIL";
                massage="User time out from current session";
            }
          }else{
            status="FAIL";
            massage="User time out from current session";
          }
         }
         
         if(status=='SUCCESS'){
            var sql='select * from appl_user_module a , appl_module b where a.module_idn=b.module_idn and  a.user_idn=$1 and token=$2';
            coreDB.executeTransSql(db,sql,[userIdn,moduleKey],{} , function(error,result){
               if(error){
                status="FAIL";
                massage="Error in query excution";
                }else{
                    var rows = result.rows;
                    if(rows.length==1){
                   status="SUCCESS";
                   massage="SUCCESS";
                    }else{
                        status="FAIL";
                        massage="Module access not allow to user "+username;
                        username="";
                        client_idn="";
                        category="";
                        userIdn="";
                    }
                }
              
                var outjson ={
                    "status":status,
                    "massage":massage,
                    "logUser":username,
                    "clientIdn":client_idn,
                    "category":category,
                    "userIdn":userIdn
                    }
            
               return callback(null,outjson);
             });

         }else{
         
          var outjson ={
            "status":status,
            "massage":massage,
            "logUser":username,
            "clientIdn":client_idn,
            "category":category,
            "userIdn":userIdn
            }
    
       return callback(null,outjson);
        }
        });
    }else{
        status="FAIL";
        massage="verified input paramters";
    }

   
   
}

exports.splice =  function(arrA,arrB,callback){

    for(let j=0;j<arrB.length;j++){
        var i = arrA.indexOf(arrB[j]);
        if(i != -1) {
            arrA.splice(i, 1);
        }
    }
    return callback(null,arrA);
}

exports.authTokenValidation = function(params,callback){
    var db = params.db ||'';
    var authToken = params.authToken ||'';
    let outJson = {};
    let resultFinal = {};
    if(db != '' && authToken != ''){
        var sql="select a.log_idn,b.appl_idn, b.user_idn,b.co_idn,b.nme_idn,a.status, "+
            "b.category,b.username,c.buyer_terms_idn "+
            "from appl_login_log a , appl_user b ,buyer_terms c where  a.log_in_valid_upto > now() "+
            "and a.user_idn=b.user_idn and b.stt=1 and b.user_idn = any(c.user_idn) "+
            "and a.auth_token= $1 and c.status='cnf' and c.stt=1 ";
        let param=[];
        param.push(authToken);

        coreDB.executeTransSql(db,sql,param,{} , function(error,result){
            if(error){
                outJson["status"] = "FAIL";
                outJson["message"] = "apiTokenValidation Fail To Execute Query!";
                callback(null, outJson);
            }else{            
                var rows = result.rows;
                if(rows.length == 1){
                    var status = rows[0].status||'LI';
                    if(status=='LI'){
                        resultFinal["logUser"] = rows[0].username || '';
                        resultFinal["coIdn"]= rows[0].co_idn || '';
                        resultFinal["category"] =  rows[0].category || '';
                        resultFinal["userIdn"]= rows[0].user_idn || '';
                        resultFinal["applIdn"]=rows[0].appl_idn || '';
                        resultFinal["nmeIdn"] = rows[0].nme_idn || '';
                        resultFinal["loginid"] = rows[0].log_idn || '';
                        resultFinal["buyer_terms_idn"] = rows[0].buyer_terms_idn || '';

                        outJson["result"]=resultFinal;
                        outJson["status"] ="SUCCESS";
                        outJson["message"] ="SUCCESS";
                        callback(null, outJson);
                    }else if(status=='LO'){
                        outJson["status"] ="LOGOUT";
                        outJson["message"] ="User logout from current session";
                        callback(null, outJson);
                    }else if(status=='TO'){
                        outJson["status"] ="LOGOUT";
                        outJson["message"] ="User time out from current session";
                        callback(null, outJson);
                    }
                }else{
                    outJson["status"] ="FAIL";
                    outJson["message"] ="Token Invalid, kindly generate new token and retry";
                    callback(null, outJson);
                }
            }
        })
    }else if(authToken == ''){
        outJson["status"] = "FAIL";
        outJson["message"] = "Please Verify Authentication Token Parameter,it is not valid";
        callback(null, outJson);
    }else if(db == ''){
        outJson["status"] = "FAIL";
        outJson["message"] = "Please Verify DB";
        callback(null, outJson);
    }  
}

exports.inputValidation = function(params,callback){
    var inputData = params.inputData || {};
    let outJson = {};
    inputData = JSON.stringify(inputData) || '';
    if(inputData != ''){
        inputData = inputData.toLowerCase();
        if(inputData.indexOf("drop ")> -1 || inputData.indexOf("delete ")> -1 || inputData.indexOf("update ")> -1 || inputData.indexOf("truncate ")> -1 || inputData.indexOf("alter ")> -1 || inputData.indexOf("create ")> -1){   //inputData.indexOf("select ")> -1 || 
            outJson["status"]="FAIL";
            outJson["message"]="Invalid Input";
            callback(null,outJson);
        } else {
            outJson["status"]="SUCCESS";
            outJson["message"]="SUCCESS";
            callback(null,outJson);
        }
    } else if(inputData == ''){
        outJson["status"]="FAIL";
        outJson["message"]="Input parameter can not be blank!";
        callback(null,outJson);
    } 
}
