const coreDB = require('qaq-core-db');
const coreUtil = require('qaq-core-util');
var excel = require('excel4node');
var dateFormat = require('dateformat');
var AWS = require("aws-sdk");

exports.saveToExcels = function(tpoolconn,redirectParam,callback) { 
    var packetIdnList = redirectParam.packetIdnList || [];
    var packetDtl = redirectParam.packetDtl || {};
    var userIdn = redirectParam.userIdn || '';
    var coIdn = redirectParam.coIdn || '';
    var pvtConfigure = redirectParam.pvtConfigure || '';
    let source = redirectParam.source || '';
    let outJson = {};
    let methodParam={};
    var resultFinal = {};
    let formNme = redirectParam.formNme || '';
    let nmeIdn = redirectParam.nmeIdn || '';
    let imageDtl = redirectParam.imageDtl || '';
    let clientkey = redirectParam.clientkey || '';
    var header = redirectParam.header || 'N';
    var total = redirectParam.total || 'N';
    var mailSend = redirectParam.mailSend || 'N';
    var subject = redirectParam.subject || '';
    var cc = redirectParam.cc || [];
    var bcc = redirectParam.bcc || [];
    var emailIds = redirectParam.emailIds || [];
    var message =  redirectParam.message || '';
    var formatName = redirectParam.formatName || null;
    let buyerIdn = redirectParam.buyerIdn || '';
    let termsIdn = redirectParam.termsIdn || '';
    let buyerDetails = redirectParam.headerDetails || {};
    let loyaltyDisplay = redirectParam.loyaltyDisplay || 'N';
    let transactionIdn = redirectParam.transactionIdn || '';
    let prefix = redirectParam.prefix || '';
    let priceFormula = redirectParam.priceFormula || 'Y';
    let cutlock = redirectParam.cutlock || 'N';

    if(packetIdnList.length > 0){
        //console.log("In Util Start");
        let resultView = [];
        methodParam["formName"]=formNme;
        methodParam["display_key"]="excel";
        methodParam["nme"]=formatName;
        methodParam["userIdn"]=userIdn;
        methodParam["coIdn"]=coIdn;
        methodParam["db"]=tpoolconn;
        methodParam["userCtg"]=pvtConfigure;
        methodParam["prefix"]=prefix;
        coreUtil.pageDisplay(methodParam).then(attrresult =>{
            resultView=attrresult.attr || [];
            //console.log(resultView);
            resultFinal["attrDtl"]=resultView;

            methodParam={};
            methodParam["coIdn"]=coIdn;  
            methodParam["resultView"]=resultView; 
            methodParam["source"]=source;
            methodParam["packetIdnList"]=packetIdnList;
            methodParam["formatName"]=formatName;
            methodParam["formNme"]=formNme;
            methodParam["loyaltypct"] = buyerDetails.loyaltypct;
            methodParam["lmemberdiscount"] = buyerDetails.lmemberdiscount;
            methodParam["packetDtl"] = packetDtl;
            methodParam["prefix"]=prefix;
            methodParam["cutlock"] = cutlock;
            getPacketDetails(tpoolconn,methodParam,function(error,getPktDtl){
                if(error){
                    outJson["result"]=resultFinal;
                    outJson["status"]="FAIL";
                    outJson["message"]="Error In getPacketDetails Method!";
                    callback(null,outJson);
                }else{
                    //console.log("In Util packet Details");
                    let pktDetails = {};
                    let attrDisplayDtl = [];
                    let statusList = [];
                    if(getPktDtl.status == "SUCCESS"){
                        pktDetails=getPktDtl.result || {};
                        let stockIdnList = getPktDtl.stockIdnList || [];
                        let newpacketDtl = getPktDtl.newpacketDtl || {};
                        //console.log("newpacketDtl",newpacketDtl)
                        attrDisplayDtl = getPktDtl.attrDisplayDtl;

                        if(loyaltyDisplay == 'Y'){
                            let index = resultView.indexOf("quot_amount");
                            resultView.splice((index+1), 0, "new_price");
                            resultView.splice((index+2), 0, "new_dis");
                            resultView.splice((index+3), 0, "new_amt");
                        }

                        methodParam={};
                        methodParam["coIdn"]=coIdn;   
                        methodParam["pktDetails"]=pktDetails;
                        methodParam["attrDisplayDtl"]=attrDisplayDtl;
                        methodParam["attrDisplayType"]=getPktDtl.attrDisplayType;
                        methodParam["attrDtl"]=resultView;
                        methodParam["packetIdnList"]=stockIdnList;
                        methodParam["packetDtl"]=newpacketDtl;
                        methodParam["buyerDetails"]=buyerDetails;
                        methodParam["imageDtl"]=imageDtl;
                        methodParam["clientkey"]=clientkey;
                        methodParam["header"]=header;
                        methodParam["total"]=total;
                        methodParam["source"]=source;
                        methodParam["formNme"] = formNme;
                        methodParam["transactionIdn"] = transactionIdn;
                        methodParam["prefix"] = prefix;
                        methodParam["priceFormula"] = priceFormula;
                        //console.log("In Util Excel Start");
                        saveExcel(tpoolconn,methodParam,function(error,excelDetails){
                            if(error){
                                console.log(error);
                                outJson["result"]='';
                                outJson["status"]="FAIL";
                                outJson["message"]="Fail To Download Excel!";
                                callback(null,outJson);
                            }else{
                                //console.log("In Util Excel End");
                                if(mailSend == 'Y'){
                                    var fileName = "";
                                    let filePath = "";
                                    //console.log(excelDetails);
                                    if(excelDetails.status == 'SUCCESS')
                                        fileName =excelDetails.result; 
                                        filePath = excelDetails.link;
                                        
                                        methodParam["formatNme"]="MAIL_EXCL";
                                        methodParam["coIdn"]=coIdn;
                                        methodParam["buyer"]=buyerDetails.buyer;
                                        methodParam["filename"]=fileName;
                                        methodParam["source"]=source;
                                        methodParam["byridn"]=buyerDetails.byridn;
                                        methodParam["empidn"]=buyerDetails.empidn;
                                        methodParam["subject"]=subject; 
                                        methodParam["cc"]=cc; 
                                        methodParam["bcc"]=bcc; 
                                        methodParam["emailIds"]=emailIds; 
                                        methodParam["message"]=message;
                                        methodParam["prefix"] = prefix;
                                        methodParam["filePath"] = filePath;
                                        //console.log("mailSend");
                                        coreUtil.sendExcelMail(tpoolconn,methodParam).then(mailDetails =>{
                                            mailDetails["downloadExcelCount"]=packetIdnList.length;
                                            callback(null,mailDetails);
                                        })  
                                }else{
                                    callback(null,excelDetails);
                                } 
                            }
                        })       
                    }  else {
                        callback(null,getPktDtl);
                    } 
                }
            })       
        })
    }else if(packetIdnList.length == 0){
        outJson["result"]=resultFinal;
        outJson["status"]="FAIL";
        outJson["message"]="Please Verify packetIdnList Can not be blank!";
        callback(null,outJson);
    }
}

async function saveExcel(connection,paramJson,callback){
    var coIdn = paramJson.coIdn || '';
    var pktDetails = paramJson.pktDetails || '';
    var attrDisplayDtl = paramJson.attrDisplayDtl || '';
    var attrDtl = paramJson.attrDtl;
    let packetIdnList =paramJson.packetIdnList;
    let attrDisplayType = paramJson.attrDisplayType;
    let packetDtl =paramJson.packetDtl || {};
    let buyerDetails =paramJson.buyerDetails;
    let imageDtl = paramJson.imageDtl;
    let clientkey =paramJson.clientkey;
    let header = paramJson.header;
    let total =paramJson.total;
    var source = paramJson.source;
    let formNme = paramJson.formNme;
    let transactionIdn = paramJson.transactionIdn;
    let prefix = paramJson.prefix || '';
    let priceFormula = paramJson.priceFormula || 'Y';
    var outJson = {};
    var now = new Date();
    var dte=dateFormat(now, "ddmmmyyyydh.MM.ss");
    //console.log("HI In excel");
    var workbook = new excel.Workbook();
    var cachedUrl = require('qaq-core-util').cachedUrl;
    let dbmsDtldata = await coreUtil.getCache(prefix+"dbms_"+coIdn,cachedUrl); 
    dbmsDtldata = JSON.parse(dbmsDtldata); 
    let statusDtldata = await coreUtil.getCache(prefix+"status_"+coIdn,cachedUrl); 
    statusDtldata = JSON.parse(statusDtldata); 
    //console.log(dbmsDtldata);
    var dnaUrl = dbmsDtldata["dna_link"] || '';
    var certImageUrl =   dbmsDtldata["cert_image"] || '';
    var stockImageUrl =   dbmsDtldata["stock_image"] || '';
    var videoUrl =   dbmsDtldata["videos_url"] || '';
    var giaUrl = "https://www.gia.edu/report-check?reportno=";
    var hrdUrl = "http://my.hrdantwerp.com/?record_number=";
    var igiUrl = "http://www.igiworldwide.com/verify.php?r=";
    let files_url = dbmsDtldata["files_url"] || '';
   
    var worksheet = workbook.addWorksheet('Sheet 1');
    var style = workbook.createStyle({
        font: {
            color: '00000000',
            bold: true,
            name: 'Calibri',
            size: 12
        },
        fill: {
            type: 'pattern',
            patternType: 'solid',
            bgColor: '#ccc4d4',
            fgColor: '#ccc4d4',
          },
          alignment: {
            wrapText: true,
            horizontal: 'center',
            readingOrder:'contextDependent'
          }     
    });
    var style1 = workbook.createStyle({
        font: {
            color: '00000000',
            bold: true,
            name: 'Calibri',
            size: 12
        },
        fill: {
            type: 'pattern',
            patternType: 'solid',
            fgColor: '#ccc4d4',
          },
          alignment: {
            wrapText: true,
            horizontal: 'center',
          }      
    });
    var style2 = workbook.createStyle({
        font: {
            color: '00000000',
            name: 'Calibri',
            size: 11
        },
          alignment: {
            wrapText: false,
            horizontal: 'center',
          },
             
    });

    var style3 = workbook.createStyle({
        font: {
            color: '00000000',
            bold: true,
            name: 'Calibri',
            size: 11
        },
        fill: {
            type: 'pattern',
            patternType: 'solid',
            fgColor: '#ccc4d4'
          },
          alignment: {
            wrapText: false,
            horizontal: 'center',
            vertical: 'center'
          },  
          border: { // §18.8.4 border (Border)
            left: {
                style: 'thin', //§18.18.3 ST_BorderStyle (Border Line Styles) ['none', 'thin', 'medium', 'dashed', 'dotted', 'thick', 'double', 'hair', 'mediumDashed', 'dashDot', 'mediumDashDot', 'dashDotDot', 'mediumDashDotDot', 'slantDashDot']
                color: '00000000' // HTML style hex value
            },
            right: {
                style: 'thin',
                color: '00000000'
            },
            top: {
                style: 'thin',
                color: '00000000'
            },
            bottom: {
                style: 'thin',
                color: '00000000'
            }
        }    
    });

    var styleRed = workbook.createStyle({
        font: {
            color: '#eb0c1e',
            name: 'Calibri',
            size: 11
        },
          alignment: {
            wrapText: false,
            horizontal: 'center',
          },
             
    });


    var headerVals = 1;
 
    if((total == 'Y' || total == 'y') && header == 'N')
        headerVals = 5;

    if(header == 'Y' || header == 'y'){
        headerVals = 9;

        worksheet.addImage({
            path: './images/KG1.jpg',
            type: 'picture',
            position: {
              type: 'twoCellAnchor',
              from: {
                col: 1,
                colOff: 0,
                row: 1,
                rowOff: 0,
              },
              to: {
                col: 3,
                colOff: 0,
                row: 7,
                rowOff: 0,
              },
            },
          });
       
        worksheet.cell(1, 5, 1, 7 , true).string('Company Name').style(style1);
        worksheet.cell(1, 8, 1, 11, true).string(buyerDetails.buyer||'').style(style2);
        worksheet.cell(2, 5, 2, 7 , true).string('Email Id').style(style1);
        worksheet.cell(2, 8, 2, 11, true).string(buyerDetails.email||'').style(style2);
        worksheet.cell(3, 5, 3, 7 , true).string('Terms').style(style1);
        worksheet.cell(3, 8, 3, 11, true).string(buyerDetails.terms  || '').style(style2);
    
        worksheet.cell(1, 12, 1, 15 , true).string('Loyalty Level').style(style1);
        worksheet.cell(1, 16, 1, 17, true).string(buyerDetails.loy_ctg||'').style(style2);
        worksheet.cell(2, 12, 2, 15 , true).string('Last 365 Days Purchase').style(style1);
        worksheet.cell(2, 16, 2, 17, true).string(buyerDetails.sale_365||'').style(style2);
        worksheet.cell(3, 12, 3, 15 , true).string('Min Buy To Loyalty Upgrade').style(style1);
        worksheet.cell(3, 16, 3, 17, true).string(buyerDetails.ldiff||'').style(style2);
    }  

    var rowVals = headerVals + 1;

    worksheet.cell(headerVals,1).string('Sr No').style(style);
    worksheet.cell(headerVals,2).string('Id').style(style);
    worksheet.cell(headerVals,3).string('Status').style(style);

    var cnt = 0;
    var columnmList={};
    let columnD = {};
    for(var i=0;i<attrDtl.length;i++){
        var attr = attrDtl[i];
        var attrDs = attrDisplayDtl[attr]||'';
        var vals = 4+cnt;

        if(attr == 'crtwt' || attr == 'rap_rte' || attr == 'quot' || attr == 'quot_dis' || attr == 'quot_amount' || attr == 'sal_rte' || attr == 'sal_dis' || attr == 'sal_amount' || attr == 'rap_vlu' || attr == 'amount'  || attr == 'rte'  || attr == 'rap_dis'){
           var attrd= excel.getExcelAlpha(vals);
           columnD[attr]=attrd;
        }
         
        worksheet.cell(headerVals,vals).string(attrDs).style(style);
        let maxLen = attrDs.toString().length+3;
        columnmList[vals]=parseInt(maxLen);
        if(attr == 'dna_link'){  
            worksheet.cell(headerVals,vals).string('View DNA').style(style);
            columnmList[vals]=10;
        }
        //if(attr=='rap_rte'){
        //    cnt++;
        //    vals = 4+cnt;
        //    worksheet.cell(headerVals,vals).string('Base Value').style(style);
        //    columnmList[vals]=10;
        //    columnD['rap_vlu']= excel.getExcelAlpha(vals);
        //}
        if(attr=='cert_image'){
            worksheet.cell(headerVals,vals).string('View Cert').style(style);
            columnmList[vals]=12;
        }
        if(attr=='stock_image'){
            worksheet.cell(headerVals,vals).string('View Image').style(style);
            columnmList[vals]=12;
        }
        if(attr=='videos_url'){
            worksheet.cell(headerVals,vals).string('View Video').style(style);
            columnmList[vals]=12;
        }
        cnt++;
    }
    //console.log(columnD);

    for(var i=0;i<packetIdnList.length;i++){
        var packetIdn = packetIdnList[i];
        var pktDtl = packetDtl[packetIdn] || {};
        var pktDtls = pktDetails[packetIdn];
        var sr = i+1;
        let pkt_code = pktDtl['pkt_code'] || pktDtls['packet']
        worksheet.cell(rowVals,1).number(sr).style(style2);
        worksheet.cell(rowVals,2).string(pkt_code).style(style2);
        let status = pktDtl['status'] || pktDtls['status'];
        if(formNme != "packetLookup"){
            let sttMap = statusDtldata[status] || {}; 
            if(source != 'qs' && source != 'qsol'){
                status = sttMap["web_display"] || status;
            }else{
                status = sttMap["sys_display"]||status;
            }
        }
      
        worksheet.cell(rowVals,3).string(status).style(style2);
        var cert = certImageUrl+""+pktDtls['cert_image'];
        var stock = stockImageUrl+""+pktDtls['stock_image'];
        var video = videoUrl+""+pktDtls['videos_url'];
       //var dna = dnaUrl+""+packetIdn+"?key="+clientkey;
       var dna = dnaUrl.replace("STOCK_IDN",packetIdn);
        var cnts=0;
        for(var k=0;k<attrDtl.length;k++){
            var attr = attrDtl[k];
            var dataTyp = attrDisplayType[attr]||'t';
            var vals = 4+cnts;
            var attrVal =coreUtil.nvl(pktDtls[attr],'')||'';
            var pktDtlKeys=Object.keys(pktDtl) || [];
            if(attr == 'quot' || attr == 'quot_dis' || attr == 'quot_amount'  || attr == 'sal_rte' || attr == 'sal_dis' || attr == 'sal_amount' || attr == 'alt_rap_dis'){
                attrVal =coreUtil.nvl(pktDtl[attr],'')||'';

                if(attrVal == '' && attr == 'alt_rap_dis')
                    attrVal =coreUtil.nvl(pktDtls[attr],'')||'';

                if(pktDtlKeys.indexOf('exh_rte') > 0 && (attr == 'quot_amount' || attr == 'sal_amount')){
                    rowcol = excel.getExcelRowCol('CZ'+rowVals);
                    row = rowcol['row'];
                    col = rowcol['col'];
                    let exh_rte = pktDtl.exh_rte || 1;
                    let amountVal = pktDtl[attr] || 1;
                    //worksheet.cell(row, col).number(parseFloat(amountVal)/parseFloat(exh_rte));  
                    if(attr == 'quot_amount')
                        worksheet.cell(row,col).formula('trunc(('+columnD['quot_amount']+row+'/CY'+row+'),2)').style(style3);
                    if(attr == 'sal_amount')
                        worksheet.cell(row,col).formula('trunc(('+columnD['sal_amount']+row+'/CY'+row+'),2)').style(style3);
                }                
            }
            if(attrVal=='NA')
            attrVal='';

            if(pktDtlKeys.indexOf('exh_rte') > 0){
                let rowcol = excel.getExcelRowCol('CY'+rowVals);
                var row = rowcol['row'];
                var col = rowcol['col'];
                let exh_rte = pktDtl.exh_rte || 1;
                worksheet.cell(row, col).number(parseFloat(exh_rte));
            }

            let rapRteVal = coreUtil.nvl(pktDtls["rap_rte"],'')||'';

            if(attr == 'lab'){
                if(certImageUrl != '' &&  attrVal != 'N')
                    worksheet.cell(rowVals,vals).link(cert,attrVal).style(style2);
                else
                    worksheet.cell(rowVals,vals).string(attrVal).style(style2);
            } else if(attr == 'dna_link'){
                if(dnaUrl != '')
                    worksheet.cell(rowVals,vals).link(dna,"DNA").style(style2);
                else
                    worksheet.cell(rowVals,vals).string("DNA").style(style2);
            } else if(attr == 'cert_image'){
                    if(certImageUrl != ''  &&  attrVal != 'N')
                        worksheet.cell(rowVals,vals).link(cert,"Cert").style(style2);
                    else
                        worksheet.cell(rowVals,vals).string("-").style(style2);
            }  else if(attr == 'stock_image'){
                if(stockImageUrl != ''  &&  attrVal != 'N')
                    worksheet.cell(rowVals,vals).link(stock,"Image").style(style2);
                else
                    worksheet.cell(rowVals,vals).string("-").style(style2);
            }  else if(attr == 'videos_url'){
                if(videoUrl != ''  &&  attrVal != 'N')
                    worksheet.cell(rowVals,vals).link(video,"Video").style(style2);
                else
                    worksheet.cell(rowVals,vals).string("-").style(style2);
            }  else if(attr == 'certno'){
                var labVal =coreUtil.nvl(pktDtls['lab'],'')||'';
                if(attrVal != 'N'){
                    if(labVal == 'GIA')
                        worksheet.cell(rowVals,vals).link(giaUrl+""+attrVal,attrVal).style(style2);
                    if(labVal == 'IGI')
                        worksheet.cell(rowVals,vals).link(igiUrl+""+attrVal,attrVal).style(style2);
                    if(labVal == 'HRD')
                        worksheet.cell(rowVals,vals).link(hrdUrl+""+attrVal,attrVal).style(style2);
                }else
                    worksheet.cell(rowVals,vals).string("-").style(style2);
            } else if(attr == 'alt_rap_dis'){
                if(attrVal=='')
                worksheet.cell(rowVals,vals).string(attrVal).style(styleRed);
                else
                worksheet.cell(rowVals,vals).number(parseFloat(attrVal)).style(styleRed); 
            } //else if(attr == 'rap_dis' || attr == 'quot_dis' || attr == 'sal_dis'){
                //trunc(((cast(attr ->> 'rte' as numeric) * 100)/cast(attr ->> 'rap_rte' as numeric))-100,2) rapdis
                //console.log(attr);
             //   if(attr == 'quot_dis')
              //      worksheet.cell(rowVals,vals).formula('round((('+columnD['quot']+rowVals+'*100)/'+columnD['rap_rte']+rowVals+')-100,2)').style(style3);
             //   else if(attr == 'sal_dis')
             //       worksheet.cell(rowVals,vals).formula('round(((('+columnD['sal_rte']+rowVals+'/CY'+rowVals+')*100)/'+columnD['rap_rte']+rowVals+')-100,2)').style(style3);
             //   else
            //        worksheet.cell(rowVals,vals).formula('round((('+columnD['rte']+rowVals+'*100)/'+columnD['rap_rte']+rowVals+')-100,2)').style(style3);
            //}
             else if((attr == 'rte' || attr == 'quot' || attr == 'sal_rte') && rapRteVal != 1 && rapRteVal != '' && priceFormula == 'Y') {
                    //newRte = coreUtil.floorFigure((rap_rte*(100+parseFloat(disVal))/100), 2) || 0;
                    if(attr == 'quot')
                        worksheet.cell(rowVals,vals).formula('trunc((('+columnD['rap_rte']+rowVals+'*(100+'+columnD['quot_dis']+rowVals+'))/100)*CY'+rowVals+',2)').style(style3);
                    else if(attr == 'sal_rte')
                        worksheet.cell(rowVals,vals).formula('trunc((('+columnD['rap_rte']+rowVals+'*(100+'+columnD['sal_dis']+rowVals+'))/100)*CY'+rowVals+',2)').style(style3);
                    else
                        worksheet.cell(rowVals,vals).formula('trunc(('+columnD['rap_rte']+rowVals+'*(100+'+columnD['rap_dis']+rowVals+'))/100,2)').style(style3);
            } else if((attr == 'amount' || attr == 'quot_amount' || attr == 'sal_amount') && rapRteVal != 1 && rapRteVal != ''  && priceFormula == 'Y'){
                //newRte = coreUtil.floorFigure((rap_rte*(100+parseFloat(disVal))/100), 2) || 0;
                if(attr == 'quot_amount')
                    worksheet.cell(rowVals,vals).formula('trunc(('+columnD['quot']+rowVals+'*'+columnD['crtwt']+rowVals+'),2)').style(style3);
                else if(attr == 'sal_amount')
                    worksheet.cell(rowVals,vals).formula('trunc(('+columnD['sal_rte']+rowVals+'*'+columnD['crtwt']+rowVals+'),2)').style(style3);
                else
                    worksheet.cell(rowVals,vals).formula('trunc(('+columnD['rte']+rowVals+'*'+columnD['crtwt']+rowVals+'),2)').style(style3);
            }  else{
                if(dataTyp!='n' && dataTyp!='f')
                    worksheet.cell(rowVals,vals).string(attrVal).style(style2);
                else{
                    if(attrVal=='' || attrVal == null)
                        worksheet.cell(rowVals,vals).string(attrVal).style(style2);
                    else
                        worksheet.cell(rowVals,vals).number(parseFloat(attrVal)).style(style2);    
                }
            }
            if(attrVal != ''){
                let curLent = columnmList[vals]||'';
                let colmaxLen = parseInt(attrVal.toString().length+3);
                let maxLen =  Math.max(curLent, colmaxLen);

                
                columnmList[vals]=maxLen;
            }
            //if(attr == 'rap_rte'){
            //    attrVal =coreUtil.nvl(pktDtls['rap_vlu'],'')||'';
            //    cnts++;
            //    vals = 4+cnts;
            //    if(attrVal=='')
           //     worksheet.cell(rowVals,vals).string(attrVal).style(style2);
            //    else
            //    worksheet.cell(rowVals,vals).number(parseFloat(attrVal)).style(style2);

            //    let curLent = columnmList['rap_vlu']||'';
            //    let colmaxLen = parseInt(attrVal.toString().length+3);
            //    let maxLen =  Math.max(curLent, colmaxLen);
              
            //    columnmList[vals]=maxLen;
            //}
            cnts++;
        }
        rowVals++;       
    }

    let totalPcs = packetIdnList.length;
    let start = headerVals+1;
    let end = headerVals+totalPcs;

    var columnDKeys=Object.keys(columnD) || [];
    var columnDKeyslen=columnDKeys.length;

    if((total == 'Y' || total == 'y') && columnDKeyslen >0){
        worksheet.row(headerVals).filter();
        var startRow = 5;
        var startCol = 5;
        if(header == 'N'){
            startRow = 1;
            startCol = 3;
        }
        
        
        worksheet.cell(startRow, startCol, startRow, (startCol+1), true).string('').style(style3);
        worksheet.cell(startRow, (startCol+2), startRow, (startCol+2) , true).string('Pcs').style(style3);
        if(columnDKeys.indexOf('crtwt') > -1)
             worksheet.cell(startRow, (startCol+3), startRow, (startCol+3) , true).string('Carat').style(style3);
        
        if(columnDKeys.indexOf('crtwt') > -1 && (columnDKeys.indexOf('quot_amount') > -1 || columnDKeys.indexOf('sal_amount') > -1 || columnDKeys.indexOf('amount') > -1) && columnDKeys.indexOf('rap_vlu') > -1){ 
            worksheet.cell(startRow, (startCol+4), startRow, (startCol+5) , true).string('Pr/Crt').style(style3);
            //worksheet.cell(startRow, (startCol+6), startRow, (startCol+7) , true).string('Amount').style(style3);
            worksheet.cell(startRow, (startCol+6), startRow, (startCol+7) , true).string('Base(%)').style(style3);
            worksheet.cell(startRow, (startCol+8), startRow, (startCol+9) , true).string('Amount').style(style3);
            worksheet.cell(startRow, (startCol+10), startRow, (startCol+11) , true).string('Base Value').style(style3);
        }

        worksheet.cell((startRow+1), startCol, (startRow+1), (startCol+1) , true).string('Grand Total').style(style3);
        worksheet.cell((startRow+1), (startCol+2), (startRow+1), (startCol+2) , true).formula('count(A'+start+' : A'+end+')').style(style3);
        if(columnDKeys.indexOf('crtwt') > -1)
            worksheet.cell((startRow+1), (startCol+3), (startRow+1), (startCol+3), true).formula('round(sum('+columnD['crtwt']+''+start+' : '+columnD['crtwt']+''+end+'),2)').style(style3);
        
        if(columnDKeys.indexOf('crtwt') > -1 && (columnDKeys.indexOf('quot_amount') > -1 || columnDKeys.indexOf('sal_amount') > -1 || columnDKeys.indexOf('amount') > -1) && columnDKeys.indexOf('rap_vlu') > -1){  
            let columnNme = '';
            if(columnDKeys.indexOf('quot_amount') > -1)
                columnNme = 'quot_amount';
            if(columnDKeys.indexOf('sal_amount') > -1)
                columnNme = 'sal_amount';
            if(columnDKeys.indexOf('amount') > -1)
                columnNme = 'amount';
            worksheet.cell((startRow+1), (startCol+4), (startRow+1), (startCol+5) , true).formula("round((SUM("+columnD[columnNme]+start+":"+columnD[columnNme]+end+"))/(SUM("+columnD['crtwt']+start+":"+columnD['crtwt']+end+")),2)").style(style3);
            //worksheet.cell((startRow+1), (startCol+6), (startRow+1), (startCol+7) , true).formula('sum('+columnD[columnNme]+''+start+' : '+columnD[columnNme]+''+end+')').style(style3);
            worksheet.cell((startRow+1), (startCol+6), (startRow+1), (startCol+7) , true).formula('round(SUM(((SUM(CZ'+start+":CZ"+end+'))/(SUM('+columnD['rap_vlu']+start+':'+columnD['rap_vlu']+end+')))*100)-100,2)').style(style3);
            worksheet.cell((startRow+1), (startCol+8), (startRow+1), (startCol+9) , true).formula('sum('+columnD[columnNme]+''+start+' : '+columnD[columnNme]+''+end+')').style(style3);
            worksheet.cell((startRow+1), (startCol+10), (startRow+1), (startCol+11) , true).formula('sum('+columnD['rap_vlu']+''+start+' : '+columnD['rap_vlu']+''+end+')').style(style3);
        }

        worksheet.cell((startRow+2), startCol, (startRow+2), (startCol+1) , true).string('Sub Total').style(style3);
        worksheet.cell((startRow+2), (startCol+2), (startRow+2), (startCol+2) , true).formula('subtotal(2, A'+start+' : A'+end+')').style(style3);
        if(columnDKeys.indexOf('crtwt') > -1)
            worksheet.cell((startRow+2), (startCol+3), (startRow+2), (startCol+3) , true).formula('round(subtotal(9, '+columnD['crtwt']+''+start+' : '+columnD['crtwt']+''+end+'),2)').style(style3);
        
        if(columnDKeys.indexOf('crtwt') > -1 && (columnDKeys.indexOf('quot_amount') > -1 || columnDKeys.indexOf('sal_amount') > -1 || columnDKeys.indexOf('amount') > -1) && columnDKeys.indexOf('rap_vlu') > -1){ 
            let columnNme = '';
            if(columnDKeys.indexOf('quot_amount') > -1)
                columnNme = 'quot_amount';
            if(columnDKeys.indexOf('sal_amount') > -1)
                columnNme = 'sal_amount';
            if(columnDKeys.indexOf('amount') > -1)
                columnNme = 'amount';
            worksheet.cell((startRow+2), (startCol+4), (startRow+2), (startCol+5) , true).formula("round((subtotal(9,"+columnD[columnNme]+start+":"+columnD[columnNme]+end+"))/(subtotal(9,"+columnD['crtwt']+start+":"+columnD['crtwt']+end+")),2)").style(style3);
            //worksheet.cell((startRow+2), (startCol+6), (startRow+2), (startCol+7) , true).formula('subtotal(9, '+columnD[columnNme]+''+start+' : '+columnD[columnNme]+''+end+')').style(style3);
            worksheet.cell((startRow+2), (startCol+6), (startRow+2), (startCol+7), true).formula("round(SUM(((SUBTOTAL(9,CZ"+start+":CZ"+end+"))/(SUBTOTAL(9,"+columnD['rap_vlu']+start+":"+columnD['rap_vlu']+end+")))*100)-100,2)").style(style3);
            worksheet.cell((startRow+2), (startCol+8), (startRow+2), (startCol+9) , true).formula('subtotal(9, '+columnD[columnNme]+''+start+' : '+columnD[columnNme]+''+end+')').style(style3);
            worksheet.cell((startRow+2), (startCol+10), (startRow+2), (startCol+11) , true).formula('subtotal(9, '+columnD['rap_vlu']+''+start+' : '+columnD['rap_vlu']+''+end+')').style(style3);
        }
    }
    
    var colLst=Object.keys(columnmList) ;
    worksheet.column(1).setWidth(10);
    worksheet.column(2).setWidth(12);
    worksheet.column(3).setWidth(12);
    for(let i=0;i < colLst.length;i++){
           var col = parseInt(colLst[i]);
           var maxWd = columnmList[col]||10;
              worksheet.column(col).setWidth(maxWd);
    }
    worksheet.column(2).freeze();
    worksheet.row(headerVals).freeze();
    
    
    //workbook.write('files/'+fileName, function(err, stats) {
    //   if (err) {
    //        console.error(err);
    //        outJson["result"]='';
    //        outJson["link"]= '';
    //        outJson["status"]="FAIL";
    ///        outJson["message"]="Excel Save Failed!";
    //        outJson["downloadExcelCount"]=0;
    //        callback(null,outJson);
    //    } else {
    //        outJson["result"]=fileName;
    //        outJson["link"]= filePath;
    //        outJson["status"]="SUCCESS";
    //        outJson["message"]="Excel Saved Successfully!";
    //        outJson["downloadExcelCount"]=totalPcs;
    //        callback(null,outJson);
    //    }
    //})
    let params = {};
    params["accessKeyId"]=dbmsDtldata.s3key;
    params["secretAccessKey"]=dbmsDtldata.s3val;
    AWS.config.update(params);
    let s3FileSetup = dbmsDtldata.s3FileSetup;
    let arrObj = s3FileSetup;
    arrObj = arrObj.split(",");
    //console.log(arrObj);
    let map = {};
    for(let i=0;i<arrObj.length;i++){
        let obj = arrObj[i];
        let data = obj.split("#");
        map[data[0]] = data[1];
    }
    var secretName = map["secretName"];
    var client = new AWS.SecretsManager({ region: map["region"] });
    client.getSecretValue({ SecretId: secretName }, async function (err, data) {
        if (err) {
            console.log("Error Obtaining Credentials", err);
        } else {
            if ("SecretString" in data) {
                secret = data.SecretString;
                secret = JSON.parse(secret)
;
                params = {};
                params["accessKeyId"] = secret.id;
                params["secretAccessKey"] = secret.key;
                params["region"] = map["region"];
                AWS.config.update(params);
                let s3 = new AWS.S3();
                const buffer = await workbook.writeToBuffer();
                    // Do something with buffer
                 
                let fileName = 'report_'+transactionIdn+'_'+dte+'.xlsx';
                let filePath = files_url +""+fileName;
                var params = {
                Bucket: map["bucketName"], 
                Key: fileName, 
                Body: buffer
                };
                s3.upload(params, function(err, data) {
                    if (err) {
                        // console.log(err)
                        outJson["status"] = "FAIL";
                        outJson["message"] = "File Upload To AWS S3 Failed";
                        outJson["downloadExcelCount"]=0;
                        callback(null, outJson);
                    } else {
                        console.log(data);
                        outJson["result"]=fileName;
                        outJson["link"]= data.Location;
                        outJson["status"]="SUCCESS";
                        outJson["message"]="Excel Saved Successfully!";
                        outJson["downloadExcelCount"]=totalPcs;
                        callback(null,outJson);
                    }
                });
            }
        }
    })
}

function getPacketDetails(connection,paramJson,callback) {
    var coIdn = paramJson.coIdn;
    let resultView = paramJson.resultView;
    let source = paramJson.source;
    let packetIdnList = paramJson.packetIdnList;
    let formNme = paramJson.formNme || '';
    let formatName = paramJson.formatName || '';
    let loyaltypct = paramJson.loyaltypct;
    let lmemberdiscount = paramJson.lmemberdiscount;
    let packetDtl = paramJson.packetDtl || {};
    let prefix = paramJson.prefix || '';
    let cutlock = paramJson.cutlock || 'N';
    let outJson = {};
    var map = {};
    let resultViewlen=resultView.length;
    let dataTypeFormatDtl={};
    let attrDisplayDtl={};
    let attrDisplayType={};
    let formulaAttr=[];
    var cachedUrl = require('qaq-core-util').cachedUrl;
    coreUtil.getCache(prefix+"productAttributeM_"+coIdn,cachedUrl).then(productAttributeM =>{
        if(productAttributeM == null){
            outJson["status"]="FAIL";
            outJson["message"]="Fail to get Product Attribute";
            callback(null,outJson);
        }else{
            productAttributeM = JSON.parse(productAttributeM);
    
            for(let j=0;j<resultViewlen;j++){
                let attr=resultView[j];
                let data_typ=productAttributeM[attr+"#T"] || '';
                let display=productAttributeM[attr+"#DS"] || '';
                let web=productAttributeM[attr+"#W"] || '';
                let format=productAttributeM[attr+"#F"] || '';
                let formula=productAttributeM[attr+"#FL"] || '';
                dataTypeFormatDtl[attr]=data_typ;
                dataTypeFormatDtl[attr+"#F"]=format;
                dataTypeFormatDtl[attr+"#FL"]=formula;
                if(data_typ=='f'){
                    formulaAttr.push(attr);
                    if(formula!='')
                    dataTypeFormatDtl[attr+"#FL#ATTR"]=coreUtil.getDependAttrList(formula);
                }
                attrDisplayDtl[attr]=display;
                attrDisplayType[attr]=data_typ;
                // if(source=='qsol' || source=='qs')
                // attrDisplayDtl[attr]=display;
                // else
                // attrDisplayDtl[attr]=web;
            }
            attrDisplayDtl["new_price"]="Final Price";
            attrDisplayType["new_price"]="n";
            attrDisplayDtl["new_dis"]="Final Dis";
            attrDisplayType["new_dis"]="n";
            attrDisplayDtl["new_amt"]="Final Amount";
            attrDisplayType["new_amt"]="n";
    
            outJson["attrDisplayDtl"]=attrDisplayDtl;
            outJson["attrDisplayType"]=attrDisplayType;
            coreUtil.getCache(prefix+"productAttributeDtl_"+coIdn,cachedUrl).then(productAttributeDtl =>{
                if(productAttributeDtl == null){
                    outJson["status"]="FAIL";
                    outJson["message"]="Fail to get Product Sub Attribute";
                    callback(null,outJson);
                }else{
                    productAttributeDtl = JSON.parse(productAttributeDtl);

                    let fmt = {};
                    let params=[];
                    let orderQ = " order by sort ";
                   // if(formNme == 'packetLookup' && formatName == 'STOCK_FORMAT'){
                   //     orderQ = " order by  lpad(attr ->> 'sh', 4, '0') ||lpad((CAST(coalesce(attr ->> 'gsz', attr ->> 'sz') as NUMERIC))::text, 4, '0') "+
                   //      " ||lpad(get_bse_srt(co_idn, 'pu', attr ->> 'pu'), 4, '0') "+
                    //      " ||lpad(get_bse_srt(co_idn, 'co', attr ->> 'co'), 4, '0') "+
                   //     " ||lpad(coalesce(attr ->> 'ct', '0'), 4, '0') "+
                    //    " ||lpad((CAST(attr ->> 'rte' as Numeric)*1000)::TEXT, 4, '0')";
                   // }

                    var sql="select stock_idn,pkt_code,stock_type,attr ->> 'certno' certno,attr ->> 'cert_image' cert_image "+
                        ",trunc(((cast(str_to_num(attr ->> 'rte',1) as numeric) * 100)/cast(coalesce(attr ->> 'rap_rte','1') as numeric))-100,2) rapdis,trunc((cast(str_to_num(attr ->> 'rte',1) as numeric) * Cast(attr ->> 'crtwt' as numeric)),2) amounts,  "+
                        "trunc(((cast(str_to_num(coalesce(attr ->> 'quot', attr ->> 'rte'),1) as numeric)*100)/cast(attr ->> 'alt_rap_rte' as numeric)) - 100, 2) altrapdis,\n"+
                        " attr->> 'rap_rte' raprte , attr ->> 'fancy_co' fancyco ,sort,  trunc(Cast(attr ->> 'crtwt' as numeric), 2) crtwts,attr,status ";
                       
                    //for (let i = 0; i < resultViewlen; i++){
                    //    let attr= resultView[i];
                     //   if(attr == 'crtwt')
                      //      sql += ",  trunc(Cast(attr ->> 'crtwt' as numeric), 2) crtwt ";
                      //  else
                     //       sql+=", attr ->> '"+attr+"' "+attr;
                    //}
                    sql+=" from stock_m  where  "+
                        "co_idn=$1 and stt=1 and stock_idn = ANY(ARRAY["+packetIdnList.join(",")+"]) " ;

                        if(source!='qsol' && source!='qs' && formNme!='viewPbbShortList'){
                            sql+=" and status not in ('MKOS','MKOS_IS') ";
                        }

                        sql+=orderQ;
                  
                    params.push(coIdn);

                    //console.log(sql);
                    //console.log(params);
                    coreDB.executeTransSql(connection,sql,params,fmt,async function(error,result){
                        if(error){
                            console.log(error);
                            outJson["status"]="FAIL";
                            outJson["message"]="Error In getPacketDetails Method!";
                            callback(null,outJson);
                        }else{
                            var len=result.rows.length;
                            var statusList = [];
                            //console.log("len",len);

                            let methodParam = {};
                            methodParam["coIdn"] = coIdn;
                            methodParam["prefix"] = prefix;
                            let pbbResult = await coreUtil.execGetPbbXrte(methodParam, connection);
                            let pbbxrte = '';
                            if(pbbResult.status == 'SUCCESS'){
                                pbbxrte = pbbResult["result"] || '';
                            }
                            //console.log("pbbxrte",pbbxrte);
                    
                            if(len>0){
                                var prvPacketStatus = '';
                                var dataMap = [];
                                var stockIdnList = [];
                                let newpacketDtl = {};
                                for(let i =0 ;i<len;i++){                                   
                                    let data = result.rows[i];   
                                    var k = {};
                                    k["packet"]=data.pkt_code;
                                    k["certno"]=data.certno;   
                                    k["cert_image"]=data.cert_image;                            
                                    let stock_type=data.stock_type;
                                    stockIdnList.push(data.stock_idn);
                                    let attrs = data["attr"];
                                    let rapValue = "";
                                    let shSort = 0;
                                    for(let j=0;j<resultViewlen;j++){
                                        let attr=resultView[j];
                                        let data_typ=dataTypeFormatDtl[attr] || '';
                                        let attrVal=attrs[attr] || '';  
                                        if(attr == 'sh')  
                                            shSort = parseInt(attrVal);
                                        if(data_typ=='c' && attrVal!='' && attrVal!=0){
                                            let prpSort=productAttributeDtl[attr+"#S"] || [];
                                            let prpDisplay=productAttributeDtl[attr+"#P"] || [];
                                            let prpWeb=productAttributeDtl[attr+"#W"] || [];
                                            if(source=='qsol' || source=='qs'){
                                                attrVal=prpDisplay[prpSort.indexOf(parseInt(attrVal))] || '';
                                            }else{
                                                attrVal=prpWeb[prpSort.indexOf(parseInt(attrVal))] || '';
                                            }
                                        }else if(data_typ=='d' && attrVal!='' && attrVal!=0 && attrVal!=null){
                                            attrVal=coreUtil.getDateyyyymmddToExpected(attrVal,'dd-mmm-yyyy');
                                        }else if(data_typ=='n'&& attrVal!='' && attrVal!=0){
                                            let format=dataTypeFormatDtl[attr+"#F"] || 'N';
                                            if(format!='N'){
                                                if(stock_type!='NR' && attr=="crtwt"){
                                                    format=3;
                                                }
                                                attrVal=attrVal || 0;
                                                attrVal=coreUtil.floorFigure(attrVal,format);
                                            }
                                        }
                                        k[attr]=attrVal;

                                        if(attr=="crtwt"){
                                            var rapRte=parseInt(attrs['rap_rte']);
                                            rapValue = rapRte * parseFloat(data.crtwts);
                                        }  
                                        let status = data.status || ''; 
                                        if(attr=="quot"){
                                            let obj = packetDtl[data.stock_idn] || {};
                                            let rte = attrs["rte"] || '1';
                                            rte = parseFloat(rte);
                                            let quot=parseFloat(obj['quot']) || rte;
                                            let exh_rte=parseFloat(obj['exh_rte']) || 1;
                                            //console.log("source",source);
                                            //console.log("status",status);
                                            //console.log("exh_rte",exh_rte);
                                            if(source=='qsol' || source=='qs'){
                                                if ((status=='MKOS' || status=='MKOS_IS') && pbbxrte != ''  && exh_rte > 1){
                                                    exh_rte = pbbxrte;
                                                    obj["exh_rte"] =  exh_rte;
                                                }       
                                            }
                                            newpacketDtl[data.stock_idn] = obj;

                                            let rapRte=parseInt(attrs['rap_rte']);
                                            let new_price = quot*((100-parseFloat(lmemberdiscount))/100)*(100-parseFloat(loyaltypct))/100;
                                            if(status == 'MKBD' || status == 'MKBDIS')
                                                new_price = quot*(100-parseFloat(loyaltypct))/100;
                                            let new_dis = (((parseFloat(new_price)/parseFloat(exh_rte))*100/rapRte)- 100);
                                            let new_amt = parseFloat(new_price) * parseFloat(data.crtwts);
                                            k["new_price"] = coreUtil.floorFigure(new_price,2);
                                            k["new_dis"] = coreUtil.floorFigure(new_dis,2);
                                            k["new_amt"] = coreUtil.floorFigure(new_amt,2);
                                        }    
                                    }
                                    let raprte = data.raprte; 
                                    let co = k.co || ''; 
                                    //console.log("co",co);                                    
                                    if(co == 'FANCY'){
                                        attrVal = data.fancyco; 
                                        k['co'] = attrVal;
                                    }
                                    if(cutlock == 'Y' && shSort != 10){
                                        k["ct"] = "";
                                    }
                                    k["crtwt"] = data.crtwts;
                                    k["rap_dis"] = data.rapdis; 
                                    k["alt_rap_dis"] = data.altrapdis;
                                    k["status"]=data.status;  
                                    k["rap_vlu"] =  rapValue; 
                                    k["amount"] = data.amounts || ''
                                    //console.log(k)     
                                    map[data.stock_idn]=k;                                      
                                }
                                var newpacketDtlKeys=Object.keys(newpacketDtl) || [];
                                //console.log("len",newpacketDtlKeys.length);

                                outJson["status"]="SUCCESS";
                                outJson["message"]="SUCCESS";
                                outJson["result"]=map;
                                outJson["stockIdnList"]=stockIdnList;
                                if(newpacketDtlKeys.length > 0)
                                    outJson["newpacketDtl"] = newpacketDtl;
                                else 
                                    outJson["newpacketDtl"] = packetDtl;
                                callback(null,outJson);
                            }else{
                                outJson["status"]="FAIL";
                                outJson["message"]="Sorry result not found";
                                outJson["result"]=map;
                                callback(null,outJson);
                            }
                        }
                    }) 
                }
            })
        }
    })
}




exports.getComparisionExcel= async function(paramJson,callback){
    var summaryList = paramJson['summaryList']||[];
    var prefix = paramJson['prefix']||'';
	 var coIdn = paramJson['coIdn']||'';

    var summaryLength=summaryList.length;
    var resultView=paramJson['resultView']||[];
    var viewLength= resultView.length;
    var resultViewAttrDtl=paramJson['resultViewAttrDtl']||[];
   var outJson={};
    var now = new Date();
    var dte=dateFormat(now, "ddmmmyyyydh.MM.ss");
    //console.log("HI"+attrDtl);
    var workbook = new excel.Workbook();

    var worksheet = workbook.addWorksheet('Sheet 1');
    var style = workbook.createStyle({
        font: {
            color: '00000000',
            bold: true,
            name: 'Calibri',
            size: 12
        },
        fill: {
            type: 'pattern',
            patternType: 'solid',
            bgColor: '#ccc4d4',
            fgColor: '#ccc4d4',
          },
          alignment: {
            wrapText: true,
            horizontal: 'center',
            readingOrder:'contextDependent'
          }     
    });
    var style1 = workbook.createStyle({
        font: {
            color: '00000000',
            bold: true,
            name: 'Calibri',
            size: 12
        },
        fill: {
            type: 'pattern',
            patternType: 'solid',
            fgColor: '#ccc4d4',
          },
          alignment: {
            wrapText: true,
            horizontal: 'center',
          }      
    });
    var style3 = workbook.createStyle({
        font: {
            color: '00000000',
            name: 'Calibri',
            size: 11
        },
          alignment: {
            wrapText: false,
            horizontal: 'center',
          },
             
    });
    var cachedUrl = require('qaq-core-util').cachedUrl;

    let dbmsDtldata = await coreUtil.getCache(prefix+"dbms_"+coIdn,cachedUrl); 
    dbmsDtldata = JSON.parse(dbmsDtldata); 
    let files_url = dbmsDtldata["files_url"] || '';

    var rowVals = 1

    worksheet.cell(rowVals,1).string('Sr No').style(style);
    worksheet.cell(rowVals,2).string('Exp. Sr No').style(style);
    worksheet.cell(rowVals,3).string('Report No').style(style);
    worksheet.cell(rowVals,4).string('Client Ref').style(style);
    worksheet.cell(rowVals,5).string('Memo No').style(style);
    worksheet.cell(rowVals,6).string('Export Dia mx').style(style);
    worksheet.cell(rowVals,7).string('Import Dia mx').style(style);
    worksheet.cell(rowVals,8).string('diff').style(style);

    worksheet.cell(rowVals,9).string('Export Dia mm').style(style);
    worksheet.cell(rowVals,10).string('Import Dia mm').style(style);
    worksheet.cell(rowVals,11).string('diff').style(style);

    worksheet.cell(rowVals,12).string('Export Dia ht').style(style);
    worksheet.cell(rowVals,13).string('Import Dia ht').style(style);
    worksheet.cell(rowVals,14).string('diff').style(style);

    worksheet.cell(rowVals,15).string('Export wt').style(style);
    worksheet.cell(rowVals,16).string('Import wt').style(style);
    worksheet.cell(rowVals,17).string('diff').style(style);
     let cellcnt=17;

    for (let j = 0; j < viewLength; j++) {
    let attr = resultView[j];

    worksheet.cell(rowVals,++cellcnt).string(resultViewAttrDtl[attr]).style(style);

    }
    worksheet.cell(rowVals,++cellcnt).string('Rate Per Carat').style(style);
    worksheet.cell(rowVals,++cellcnt).string('Total Value US$').style(style);
    worksheet.cell(rowVals,++cellcnt).string('LAB CHARGES US$').style(style);


    for (let i = 0; i < summaryLength; i++) {
    let summaryDtl = summaryList[i];
    rowVals++;
    let srno=(i+1)+" ";
    worksheet.cell(rowVals,1).string(srno).style(style3);
    worksheet.cell(rowVals,2).string(summaryDtl['srl']||'').style(style3);
    worksheet.cell(rowVals,3).string(summaryDtl['cert_no']||'').style(style3);
    worksheet.cell(rowVals,4).string(summaryDtl['pkt_code']||'').style(style3);
    worksheet.cell(rowVals,5).string(summaryDtl['entry_title']||'').style(style3);
    worksheet.cell(rowVals,6).string(summaryDtl['mx']||'').style(style3);
    worksheet.cell(rowVals,7).string(summaryDtl['rt_mx']||'').style(style3);
    worksheet.cell(rowVals,8).string((summaryDtl['mxdiff']||'0')=='0'?"-":summaryDtl['mxdiff']).style(style3);

    worksheet.cell(rowVals,9).string(summaryDtl['mn']||'').style(style3);
    worksheet.cell(rowVals,10).string(summaryDtl['rt_mn']||'').style(style3);
    worksheet.cell(rowVals,11).string((summaryDtl['mndiff']||'0')=='0'?"-":summaryDtl['mndiff']).style(style3);

    worksheet.cell(rowVals,12).string(summaryDtl['ht']||'').style(style3);
    worksheet.cell(rowVals,13).string(summaryDtl['rt_ht']||'').style(style3);
    worksheet.cell(rowVals,14).string((summaryDtl['htdiff']||'0')=='0'?"-":summaryDtl['htdiff']).style(style3);

    worksheet.cell(rowVals,15).string(summaryDtl['wt']||'').style(style3);
    worksheet.cell(rowVals,16).string(summaryDtl['rt_wt']||'').style(style3);
    worksheet.cell(rowVals,17).string((summaryDtl['wtdiff']||'0')=='0'?"-":summaryDtl['wtdiff']).style(style3);
     let cellcnt=17;

    for (let j = 0; j < viewLength; j++) {
    let attr = resultView[j];

    worksheet.cell(rowVals,++cellcnt).string(summaryDtl[attr]||'').style(style3);

    }
    worksheet.cell(rowVals,++cellcnt).string(summaryDtl['rte']||'').style(style3);
    worksheet.cell(rowVals,++cellcnt).string(summaryDtl['amount']||'').style(style3);
    worksheet.cell(rowVals,++cellcnt).string(summaryDtl['lab_charges']||'').style(style3);
    }

    let params = {};
    params["accessKeyId"]=dbmsDtldata.s3key;
    params["secretAccessKey"]=dbmsDtldata.s3val;
    AWS.config.update(params);
    let s3FileSetup = dbmsDtldata.s3FileSetup;
    let arrObj = s3FileSetup;
    arrObj = arrObj.split(",");
    //console.log(arrObj);
    let map = {};
    for(let i=0;i<arrObj.length;i++){
        let obj = arrObj[i];
        let data = obj.split("#");
        map[data[0]] = data[1];
    }
    var secretName = map["secretName"];
    var client = new AWS.SecretsManager({ region: map["region"] });
    client.getSecretValue({ SecretId: secretName }, async function (err, data) {
        if (err) {
            console.log("Error Obtaining Credentials", err);
        } else {
            if ("SecretString" in data) {
                secret = data.SecretString;
                secret = JSON.parse(secret)
;
                params = {};
                params["accessKeyId"] = secret.id;
                params["secretAccessKey"] = secret.key;
                params["region"] = map["region"];
                AWS.config.update(params);
                let s3 = new AWS.S3();
                const buffer = await workbook.writeToBuffer();
                    // Do something with buffer
                 
                let fileName = 'LabConsignment_comparision'+dte+'.xlsx';
                let filePath = files_url +""+fileName;
                var params = {
                Bucket: map["bucketName"], 
                Key: fileName, 
                Body: buffer
                };
                s3.upload(params, function(err, data) {
                    if (err) {
                        console.error(err);
                        outJson["result"]='';
                        outJson["link"]= '';
                        outJson["status"]="FAIL";
                        outJson["message"]="Excel Save Failed!";
                        callback(null,outJson);
                    } else {
                        outJson["result"]=fileName;
                        outJson["link"]= data.Location;
                        outJson["status"]="SUCCESS";
                        outJson["message"]="Excel Saved Successfully!";
                        callback(null,outJson);
                    }
                });
            }
        }
    })

    //workbook.write('files/'+fileName, function(err, stats) {
    //    if (err) {
    //        console.error(err);
    //        outJson["result"]='';
    //        outJson["link"]= filePath;
    //        outJson["status"]="FAIL";
    //        outJson["message"]="Excel Save Failed!";
    //        callback(null,outJson);
    //    } else {
    //        outJson["result"]=fileName;
    //        outJson["link"]= filePath;
    //        outJson["status"]="SUCCESS";
    //        outJson["message"]="Excel Saved Successfully!";
    //        callback(null,outJson);
    //    }
    //})
}


exports.getShipingBillExcel=async function(paramJson,callback){
    var summaryList = paramJson['summaryList']||[];
    var prefix = paramJson['prefix']||'';
	 var coIdn = paramJson['coIdn']||'';
     var authorizedNme = paramJson['authorizedNme']||'';
     var authorizedTitle = paramJson['authorizedTitle']||'';
    var summaryLength=summaryList.length;

   var outJson={};
    var now = new Date();
    var dte=dateFormat(now, "ddmmmyyyydh.MM.ss");
    //console.log("HI"+attrDtl);
    var workbook = new excel.Workbook();

    var worksheet = workbook.addWorksheet('Sheet 1');
    var style = workbook.createStyle({
        font: {
            color: '00000000',
            bold: true,
            name: 'Calibri',
            size: 12
        },
        fill: {
            type: 'pattern',
            patternType: 'solid',
            bgColor: '#ccc4d4',
            fgColor: '#ccc4d4',
          },
          alignment: {
            wrapText: true,
            horizontal: 'center',
            readingOrder:'contextDependent'
          }     
    });
    var style2 = workbook.createStyle({
        font: {
            color: '00000000',
            name: 'Calibri',
            bold: true,

            size: 11
        },
          alignment: {
            wrapText: false,
            horizontal: 'center',
          },
             
    });
    var style3 = workbook.createStyle({
        font: {
            color: '00000000',
            name: 'Calibri',
            size: 11
        },
          alignment: {
            wrapText: false,
            horizontal: 'center',
          },
             
    });
    var cachedUrl = require('qaq-core-util').cachedUrl;

    let dbmsDtldata = await coreUtil.getCache(prefix+"dbms_"+coIdn,cachedUrl); 
    dbmsDtldata = JSON.parse(dbmsDtldata); 
    let files_url = dbmsDtldata["files_url"] || '';

    var rowVals = 1

    worksheet.cell(rowVals,1).string('SR NO').style(style);
    worksheet.cell(rowVals,2).string('INV NO').style(style);
    worksheet.cell(rowVals,3).string('NO OF STONE').style(style);
    worksheet.cell(rowVals,4).string('Wt. CTS').style(style);
    worksheet.cell(rowVals,5).string('USD$').style(style);
    worksheet.cell(rowVals,6).string('SB NO').style(style);
    worksheet.cell(rowVals,7).string('DATE').style(style);

    let ttlQty=0;
    let ttlCts=0;
    let ttlVlu =0;
    for (let i = 0; i < summaryLength; i++) {
    let summaryDtl = summaryList[i];
    rowVals++;
    let srno=(i+1)+" ";
    worksheet.cell(rowVals,1).string(srno).style(style3);
    worksheet.cell(rowVals,2).string(summaryDtl['entry_title']||'').style(style3);
    worksheet.cell(rowVals,3).string(summaryDtl['qty']||'').style(style3);
    worksheet.cell(rowVals,4).string(summaryDtl['rt_crtwt']||'').style(style3);
    worksheet.cell(rowVals,5).string(summaryDtl['rt_vlu']||'').style(style3);
    worksheet.cell(rowVals,6).string(summaryDtl['sbno']||'').style(style3);
    worksheet.cell(rowVals,7).string(summaryDtl['trns_dt']||'').style(style3);
    ttlQty=ttlQty+parseInt(summaryDtl['qty']||'0');
    ttlCts=ttlCts+parseFloat(summaryDtl['rt_crtwt']||'0');
    ttlVlu=ttlVlu+parseInt(summaryDtl['rt_vlu']||'0');
    }
    ttlCts = coreUtil.floorFigure(ttlCts,2);
    ttlVlu = coreUtil.floorFigure(ttlVlu,2);
    
    rowVals++;

    worksheet.cell(rowVals,1).string("").style(style2);
    worksheet.cell(rowVals,2).string("").style(style2);
    worksheet.cell(rowVals,3).string(ttlQty+"").style(style2);
    worksheet.cell(rowVals,4).string(ttlCts+"").style(style2);
    worksheet.cell(rowVals,5).string(ttlVlu+"").style(style2);
    worksheet.cell(rowVals,6).string("").style(style2);
    worksheet.cell(rowVals,7).string("").style(style2);

    rowVals=rowVals+2;

    worksheet.cell(rowVals,1).string("").style(style2);
    worksheet.cell(rowVals,2).string("").style(style2);
    worksheet.cell(rowVals,3).string("").style(style2);
    worksheet.cell(rowVals,4).string("").style(style2);
    worksheet.cell(rowVals,5,rowVals,7,true).string("For M/s Kapu Gems LLP").style(style2);


    rowVals=rowVals+2;

    worksheet.cell(rowVals,1).string("").style(style2);
    worksheet.cell(rowVals,2).string("").style(style2);
    worksheet.cell(rowVals,3).string("").style(style2);
    worksheet.cell(rowVals,4).string("").style(style2);
    worksheet.cell(rowVals,5,rowVals,7,true).string(authorizedNme).style(style2);

    rowVals=rowVals+1;

    worksheet.cell(rowVals,1).string("").style(style2);
    worksheet.cell(rowVals,2).string("").style(style2);
    worksheet.cell(rowVals,3).string("").style(style2);
    worksheet.cell(rowVals,4).string("").style(style2);
    worksheet.cell(rowVals,5,rowVals,7,true).string(authorizedTitle).style(style2);

    let params = {};
    params["accessKeyId"]=dbmsDtldata.s3key;
    params["secretAccessKey"]=dbmsDtldata.s3val;
    AWS.config.update(params);
    let s3FileSetup = dbmsDtldata.s3FileSetup;
    let arrObj = s3FileSetup;
    arrObj = arrObj.split(",");
    //console.log(arrObj);
    let map = {};
    for(let i=0;i<arrObj.length;i++){
        let obj = arrObj[i];
        let data = obj.split("#");
        map[data[0]] = data[1];
    }
    var secretName = map["secretName"];
    var client = new AWS.SecretsManager({ region: map["region"] });
    client.getSecretValue({ SecretId: secretName }, async function (err, data) {
        if (err) {
            console.log("Error Obtaining Credentials", err);
        } else {
            if ("SecretString" in data) {
                secret = data.SecretString;
                secret = JSON.parse(secret)
;
                params = {};
                params["accessKeyId"] = secret.id;
                params["secretAccessKey"] = secret.key;
                params["region"] = map["region"];
                AWS.config.update(params);
                let s3 = new AWS.S3();
                const buffer = await workbook.writeToBuffer();
                    // Do something with buffer
                 
                let fileName = 'Shippingbill'+dte+'.xlsx';
                let filePath = files_url +""+fileName;
                var params = {
                Bucket:  map["bucketName"], 
                Key: fileName, 
                Body: buffer
                };
                s3.upload(params, function(err, data) {
                    if (err) {
                        console.error(err);
                        outJson["result"]='';
                        outJson["link"]= '';
                        outJson["status"]="FAIL";
                        outJson["message"]="Excel Save Failed!";
                        callback(null,outJson);
                    } else {
                        outJson["result"]=fileName;
                        outJson["link"]= data.Location;
                        outJson["status"]="SUCCESS";
                        outJson["message"]="Excel Saved Successfully!";
                        callback(null,outJson);
                    }
                });
            }
        }
    })
  

  
    //workbook.write('files/'+fileName, function(err, stats) {
    //    if (err) {
    //        console.error(err);
    //        outJson["result"]='';
    //        outJson["link"]= '';
    //       outJson["status"]="FAIL";
    //        outJson["message"]="Excel Save Failed!";
    //        callback(null,outJson);
    //    } else {
    //        outJson["result"]=fileName;
    //        outJson["link"]= filePath;
    //        outJson["status"]="SUCCESS";
    //        outJson["message"]="Excel Saved Successfully!";
    //        callback(null,outJson);
    //    }
    //})





}


exports.getCertificationStatmentExcel= async function (paramJson,callback){
    var summaryList = paramJson['summaryList']||[];
    var prefix = paramJson['prefix']||'';
     var coIdn = paramJson['coIdn']||'';
     var date = paramJson['date']||'';
     let authorizedTitle = paramJson.authorizedTitle;
     let authorizedNme = paramJson.authorizedNme;
    var summaryLength=summaryList.length;

   var outJson={};
    var now = new Date();
    var dte=dateFormat(now, "ddmmmyyyydh.MM.ss");
    var dteexce=dateFormat(now, "dd-mm-yyyy");
    //console.log("HI"+attrDtl);
    var workbook = new excel.Workbook();

    var worksheet = workbook.addWorksheet('Sheet 1');
    var style = workbook.createStyle({
        font: {
            color: '00000000',
            bold: true,
            name: 'Calibri',
            size: 12
        },
        fill: {
            type: 'pattern',
            patternType: 'solid',
            bgColor: '#ccc4d4',
            fgColor: '#ccc4d4',
          },
          alignment: {
            wrapText: true,
            horizontal: 'center',
            readingOrder:'contextDependent'
          }     
    });
    var style2 = workbook.createStyle({
        font: {
            color: '00000000',
            name: 'Calibri',
            bold: true,

            size: 11
        },
          alignment: {
            wrapText: false,
            horizontal: 'center',
          },
             
    });
    var style3 = workbook.createStyle({
        font: {
            color: '00000000',
            name: 'Calibri',
            size: 11
        },
          alignment: {
            wrapText: false,
            horizontal: 'center',
          },
             
    });
    var cachedUrl = require('qaq-core-util').cachedUrl;

    let dbmsDtldata = await coreUtil.getCache(prefix+"dbms_"+coIdn,cachedUrl); 
    dbmsDtldata = JSON.parse(dbmsDtldata); 
    let files_url = dbmsDtldata["files_url"] || '';

    var rowVals = 1
    worksheet.cell(rowVals,1,rowVals,17,true).string('Register No. /Page No.').style(style2);

    rowVals++;
    worksheet.cell(rowVals,1,rowVals,3,true).string('KAPU GEMS LLP').style(style2);
    worksheet.cell(rowVals,12,rowVals,14,true).string('DT.'+dteexce).style(style2);


    rowVals++;
    worksheet.cell(rowVals,1,rowVals,3,true).string('EC-3021, BDB').style(style2);
    rowVals++;
    worksheet.cell(rowVals,1,rowVals,3,true).string('BANDRA KURLA COMPLEX').style(style2);
    rowVals++;
    worksheet.cell(rowVals,1,rowVals,3,true).string('BANDRA (E), MUMBAI - 400 051.').style(style2);


    rowVals++;
    rowVals++;
    worksheet.cell(rowVals,1,rowVals,17,true).string('TO WHOMSOEVER IT MAY CONCERN').style(style2);

    
    rowVals++;
    worksheet.cell(rowVals,1,rowVals,17,true).string('We KAPU GEMS LLP Mumbai , have sent the following goods for Certification pupose  and detail of Return and Balance goods of GIA LABORATORY.').style(style2);

    rowVals++;
    rowVals++;

    worksheet.cell(rowVals,1).string('SR NO').style(style);
    worksheet.cell(rowVals,2).string('SB No').style(style);
    worksheet.cell(rowVals,3).string('SB Date').style(style);
    worksheet.cell(rowVals,4).string('Inv No').style(style);
    worksheet.cell(rowVals,5).string('Inv Date').style(style);
    worksheet.cell(rowVals,6,rowVals,8,true).string('send for Certification').style(style);
    worksheet.cell(rowVals,9,rowVals,11,true).string('Previous Returned ').style(style);
    worksheet.cell(rowVals,12,rowVals,14,true).string('Today Returned').style(style);
    worksheet.cell(rowVals,15,rowVals,17,true).string('Balance of Consignment').style(style);

    rowVals++;

    worksheet.cell(rowVals,1).string('').style(style2);
    worksheet.cell(rowVals,2).string('').style(style2);
    worksheet.cell(rowVals,3).string('').style(style2);
    worksheet.cell(rowVals,4).string('').style(style2);
    worksheet.cell(rowVals,5).string('').style(style2);
    worksheet.cell(rowVals,6).string('Carats').style(style2);
    worksheet.cell(rowVals,7).string('RateUS$').style(style2);
    worksheet.cell(rowVals,8).string('Amt. US$').style(style2);
    worksheet.cell(rowVals,9).string('Carats').style(style2);
    worksheet.cell(rowVals,10).string('RateUS$').style(style2);
    worksheet.cell(rowVals,11).string('Amt. US$').style(style2);
    worksheet.cell(rowVals,12).string('Carats').style(style2);
    worksheet.cell(rowVals,13).string('RateUS$').style(style2);
    worksheet.cell(rowVals,14).string('Amt. US$').style(style2);
    worksheet.cell(rowVals,15).string('Carats').style(style2);
    worksheet.cell(rowVals,16).string('RateUS$').style(style2);
    worksheet.cell(rowVals,17).string('Amt. US$').style(style2);
    
    

    let ttlAvg=0;
    let ttlCts=0;
    let ttlVlu =0;
    let ttlRtAvg=0;
    let ttlRtCts=0;
    let ttlRtVlu =0;
    let RtAvg=0;
    let RtCts=0;
    let RtVlu =0;
    let brcCts=0;
    let brcAvg=0;
    let brcVlu =0;
    for (let i = 0; i < summaryLength; i++) {
    let summaryDtl = summaryList[i] || {};
    rowVals++;
    let srno=(i+1)+" ";
    worksheet.cell(rowVals,1).string(srno).style(style3);
    worksheet.cell(rowVals,2).string(summaryDtl['sbno']||'').style(style3);
    worksheet.cell(rowVals,3).string(summaryDtl['sbdate']||'').style(style3);
    worksheet.cell(rowVals,4).string(summaryDtl['entry_title']||'').style(style3);
    worksheet.cell(rowVals,5).string(summaryDtl['trns_dt']||'').style(style3);
    worksheet.cell(rowVals,6).string(summaryDtl['ttl_crtwt']||'').style(style3);
    worksheet.cell(rowVals,7).string(summaryDtl['ttl_avg']||'').style(style3);
    worksheet.cell(rowVals,8).string(summaryDtl['ttl_vlu']||'').style(style3);
    worksheet.cell(rowVals,9).string(summaryDtl['ttl_rt_crtwt']||'').style(style3);
    worksheet.cell(rowVals,10).string(summaryDtl['ttl_rt_avg']||'').style(style3);
    worksheet.cell(rowVals,11).string(summaryDtl['ttl_rt_vlu']||'').style(style3);
    worksheet.cell(rowVals,12).string(summaryDtl['rt_crtwt']||'').style(style3);
    worksheet.cell(rowVals,13).string(summaryDtl['rt_avg']||'').style(style3);
    worksheet.cell(rowVals,14).string(summaryDtl['rt_vlu']||'').style(style3);
    worksheet.cell(rowVals,15).string(summaryDtl['brc_crtwt']||'').style(style3);
    worksheet.cell(rowVals,16).string(summaryDtl['brc_avg']||'').style(style3);
    worksheet.cell(rowVals,17).string(summaryDtl['brc_vlu']||'').style(style3);

    ttlCts=coreUtil.floorFigure(parseFloat(ttlCts)+parseFloat(summaryDtl['ttl_crtwt']||'0'),2);
    ttlVlu=coreUtil.floorFigure(parseFloat(ttlVlu)+parseInt(summaryDtl['ttl_vlu']||'0'),2);
    ttlAvg=coreUtil.floorFigure(parseFloat(ttlVlu)/parseFloat(ttlCts),2);

    ttlRtCts=coreUtil.floorFigure(parseFloat(ttlRtCts)+parseFloat(summaryDtl['ttl_rt_crtwt']||'0'),2);
    ttlRtVlu=coreUtil.floorFigure(parseFloat(ttlRtVlu)+parseInt(summaryDtl['ttl_rt_vlu']||'0'),2);
    ttlRtAvg=coreUtil.floorFigure(parseFloat(ttlRtVlu)/parseFloat(ttlRtCts),2);

    RtCts=coreUtil.floorFigure(parseFloat(RtCts)+parseFloat(summaryDtl['rt_crtwt']||'0'),2);
    RtVlu=coreUtil.floorFigure(parseFloat(RtVlu)+parseInt(summaryDtl['rt_vlu']||'0'),2);
    RtAvg=coreUtil.floorFigure(parseFloat(RtVlu)/parseFloat(RtCts),2);

    brcCts=coreUtil.floorFigure(parseFloat(brcCts)+parseFloat(summaryDtl['brc_crtwt']||'0'),2);
    brcVlu=coreUtil.floorFigure(parseFloat(brcVlu)+parseInt(summaryDtl['brc_vlu']||'0'),2);
    brcAvg=coreUtil.floorFigure(parseFloat(brcVlu)/parseFloat(brcCts),2);

    }

    rowVals++;

    worksheet.cell(rowVals,1).string('').style(style2);
    worksheet.cell(rowVals,2).string('').style(style2);
    worksheet.cell(rowVals,3).string('').style(style2);
    worksheet.cell(rowVals,4).string('').style(style2);
    worksheet.cell(rowVals,5).string('').style(style2);
    worksheet.cell(rowVals,6).string(ttlCts+"").style(style2);
    worksheet.cell(rowVals,7).string(ttlVlu+"").style(style2);
    worksheet.cell(rowVals,8).string(ttlAvg+"").style(style2);
    worksheet.cell(rowVals,9).string(ttlRtCts+"").style(style2);
    worksheet.cell(rowVals,10).string(ttlRtVlu+"").style(style2);
    worksheet.cell(rowVals,11).string(ttlRtAvg+"").style(style2);
    worksheet.cell(rowVals,12).string(RtCts+"").style(style2);
    worksheet.cell(rowVals,13).string(RtVlu+"").style(style2);
    worksheet.cell(rowVals,14).string(RtAvg+"").style(style2);
    worksheet.cell(rowVals,15).string(brcCts+"").style(style2);
    worksheet.cell(rowVals,16).string(brcVlu+"").style(style2);
    worksheet.cell(rowVals,17).string(brcAvg+"").style(style2);

    rowVals++;
    rowVals++;
    worksheet.cell(rowVals,1).string('').style(style2);
    worksheet.cell(rowVals,2).string('').style(style2);
    worksheet.cell(rowVals,3).string('').style(style2);
    worksheet.cell(rowVals,4).string('').style(style2);
    worksheet.cell(rowVals,5).string('').style(style2);
    worksheet.cell(rowVals,6).string('').style(style2);
    worksheet.cell(rowVals,7).string('').style(style2);
    worksheet.cell(rowVals,8).string('').style(style2);
    worksheet.cell(rowVals,9).string('').style(style2);
    worksheet.cell(rowVals,10).string('').style(style2);
    worksheet.cell(rowVals,10,rowVals,14,true).string('KAPU GEMS LLP').style(style2);

    rowVals++;
    rowVals++;
    rowVals++;
    worksheet.cell(rowVals,1).string('').style(style2);
    worksheet.cell(rowVals,2).string('').style(style2);
    worksheet.cell(rowVals,3).string('').style(style2);
    worksheet.cell(rowVals,4).string('').style(style2);
    worksheet.cell(rowVals,5).string('').style(style2);
    worksheet.cell(rowVals,6).string('').style(style2);
    worksheet.cell(rowVals,7).string('').style(style2);
    worksheet.cell(rowVals,8).string('').style(style2);
    worksheet.cell(rowVals,9).string('').style(style2);
    worksheet.cell(rowVals,10).string('').style(style2);
    worksheet.cell(rowVals,10,rowVals,14,true).string(authorizedNme).style(style2);

    rowVals++;
    worksheet.cell(rowVals,1).string('').style(style2);
    worksheet.cell(rowVals,2).string('').style(style2);
    worksheet.cell(rowVals,3).string('').style(style2);
    worksheet.cell(rowVals,4).string('').style(style2);
    worksheet.cell(rowVals,5).string('').style(style2);
    worksheet.cell(rowVals,6).string('').style(style2);
    worksheet.cell(rowVals,7).string('').style(style2);
    worksheet.cell(rowVals,8).string('').style(style2);
    worksheet.cell(rowVals,9).string('').style(style2);
    worksheet.cell(rowVals,10).string('').style(style2);
    worksheet.cell(rowVals,10,rowVals,14,true).string(authorizedTitle).style(style2);

    let params = {};
    params["accessKeyId"]=dbmsDtldata.s3key;
    params["secretAccessKey"]=dbmsDtldata.s3val;
    AWS.config.update(params);
    let s3FileSetup = dbmsDtldata.s3FileSetup;
    let arrObj = s3FileSetup;
    arrObj = arrObj.split(",");
    //console.log(arrObj);
    let map = {};
    for(let i=0;i<arrObj.length;i++){
        let obj = arrObj[i];
        let data = obj.split("#");
        map[data[0]] = data[1];
    }
    var secretName = map["secretName"];
    var client = new AWS.SecretsManager({ region: map["region"] });
    client.getSecretValue({ SecretId: secretName }, async function (err, data) {
        if (err) {
            console.log("Error Obtaining Credentials", err);
        } else {
            if ("SecretString" in data) {
                secret = data.SecretString;
                secret = JSON.parse(secret)
;
                params = {};
                params["accessKeyId"] = secret.id;
                params["secretAccessKey"] = secret.key;
                params["region"] = map["region"];
                AWS.config.update(params);
                let s3 = new AWS.S3();
                const buffer = await workbook.writeToBuffer();
                    // Do something with buffer
                 
                let fileName = 'CertificationStatmentExcel'+dte+'.xlsx';
                let filePath = files_url +""+fileName;
                var params = {
                Bucket: map["bucketName"], 
                Key: fileName, 
                Body: buffer
                };
                s3.upload(params, function(err, data) {
                    if (err) {
                        console.error(err);
                        outJson["result"]='';
                        outJson["link"]= '';
                        outJson["status"]="FAIL";
                        outJson["message"]="Excel Save Failed!";
                        callback(null,outJson); 
                    } else {
                        outJson["result"]=fileName;
                        outJson["link"]= data.Location;
                        outJson["status"]="SUCCESS";
                        outJson["message"]="Excel Saved Successfully!";
                        callback(null,outJson);
                    }
                });
            }
        }
    })


  

   
    //workbook.write('files/'+fileName, function(err, stats) {
    ///    if (err) {
    //        console.error(err);
    //        outJson["result"]='';
    //        outJson["link"]= '';
    //        outJson["status"]="FAIL";
    //        outJson["message"]="Excel Save Failed!";
    //        callback(null,outJson);
    //    } else {
    //        outJson["result"]=fileName;
    //        outJson["link"]= filePath;
    //        outJson["status"]="SUCCESS";
    //        outJson["message"]="Excel Saved Successfully!";
    //        callback(null,outJson);
    //    }
    ///})





}



exports.getBVCAgentExcel= async function (paramJson,callback){
    var summaryList = paramJson['BVCAgentDetails']||[];
    var prefix = paramJson['prefix']||'';
     var coIdn = paramJson['coIdn']||'';
    
    var summaryLength=summaryList.length;

   var outJson={};
    var now = new Date();
    var dte=dateFormat(now, "ddmmmyyyydh.MM.ss");
    var dteexce=dateFormat(now, "dd-mm-yyyy");
    //console.log("HI"+attrDtl);
    var workbook = new excel.Workbook();

    var worksheet = workbook.addWorksheet('Sheet 1');
    var style = workbook.createStyle({
        font: {
            color: '00000000',
            bold: true,
            name: 'Calibri',
            size: 12
        },
        fill: {
            type: 'pattern',
            patternType: 'solid',
            bgColor: '#ccc4d4',
            fgColor: '#ccc4d4',
          },
          alignment: {
            wrapText: true,
            horizontal: 'center',
            readingOrder:'contextDependent'
          }     
    });
    var style2 = workbook.createStyle({
        font: {
            color: '00000000',
            name: 'Calibri',
            bold: true,

            size: 11
        },
          alignment: {
            wrapText: false,
            horizontal: 'center',
          },
             
    });
    var style3 = workbook.createStyle({
        font: {
            color: '00000000',
            name: 'Calibri',
            size: 11
        },
          alignment: {
            wrapText: false,
            horizontal: 'center',
          },
             
    });
    var cachedUrl = require('qaq-core-util').cachedUrl;

    let dbmsDtldata = await coreUtil.getCache(prefix+"dbms_"+coIdn,cachedUrl); 
    dbmsDtldata = JSON.parse(dbmsDtldata); 
    let files_url = dbmsDtldata["files_url"] || '';

    var rowVals = 1
  
  

    worksheet.cell(rowVals,1).string('Invoice No.').style(style2);
    worksheet.cell(rowVals,2).string('Item No.').style(style2);
    worksheet.cell(rowVals,3).string('RITC').style(style2);
    worksheet.cell(rowVals,4).string('Item Description').style(style2);
    worksheet.cell(rowVals,5).string('Qty.').style(style2);
    worksheet.cell(rowVals,6).string('Unit of Qty').style(style2);
    worksheet.cell(rowVals,7).string('Unit Price').style(style2);
    worksheet.cell(rowVals,8).string('Per').style(style2);
    worksheet.cell(rowVals,9).string('PMV Unit Price').style(style2);
    worksheet.cell(rowVals,10).string('Scheme Code').style(style2);
    worksheet.cell(rowVals,11).string('Drawback Sr. No.').style(style2);
    worksheet.cell(rowVals,12).string('DBK Qty').style(style2);
    worksheet.cell(rowVals,13).string('DBK Qty Unit').style(style2);
    worksheet.cell(rowVals,14).string('Reward Item').style(style2);
    worksheet.cell(rowVals,15).string('STR Code').style(style2);
    worksheet.cell(rowVals,16).string('End Use').style(style2);
    worksheet.cell(rowVals,17).string('IGST Payment Status').style(style2);
    worksheet.cell(rowVals,18).string('Taxable Value').style(style2);
    worksheet.cell(rowVals,19).string('IGST Amount').style(style2);
    worksheet.cell(rowVals,20).string('IGST Rate').style(style2);
    worksheet.cell(rowVals,21).string('Compensation Cess Amount').style(style2);
    worksheet.cell(rowVals,22).string('State Code').style(style2);
    worksheet.cell(rowVals,23).string('District Code').style(style2);
    worksheet.cell(rowVals,24).string('Standard Qty').style(style2);
    worksheet.cell(rowVals,25).string('Standard Qty Unit').style(style2);
    worksheet.cell(rowVals,26).string('FTA Code').style(style2);
    worksheet.cell(rowVals,27).string('Accessory Status​').style(style2);
    worksheet.cell(rowVals,28).string('RODTEP').style(style2);
    worksheet.cell(rowVals,29).string('STATEMENT CODE').style(style2);
   


    
    

    let srNo = 0;
    for (let i = 0; i < summaryLength; i++) {
    let summaryDtl = summaryList[i];
    srNo++;
    rowVals++;
    let srno =srNo+"";
    worksheet.cell(rowVals,1).string(summaryDtl['entry_title']).style(style3);
    worksheet.cell(rowVals,2).string(srno).style(style3);
    worksheet.cell(rowVals,3).string(summaryDtl['RITC']).style(style3);
    worksheet.cell(rowVals,4).string(summaryDtl['descs']).style(style3);
    worksheet.cell(rowVals,5).string(summaryDtl['qty']).style(style3);
    worksheet.cell(rowVals,6).string(summaryDtl['UnitQty']).style(style3);
    worksheet.cell(rowVals,7).string(summaryDtl['rte']).style(style3);
    worksheet.cell(rowVals,8).string(summaryDtl['per']).style(style3);
    worksheet.cell(rowVals,9).string(summaryDtl['PMVPrice']).style(style3);
    worksheet.cell(rowVals,10).string(summaryDtl['SchemeCode']).style(style3);
    worksheet.cell(rowVals,11).string(summaryDtl['DrawbackSrNo']).style(style3);
    worksheet.cell(rowVals,12).string(summaryDtl['DBKQty']).style(style3);
    worksheet.cell(rowVals,13).string(summaryDtl['DBKQtyUnit']).style(style3);
    worksheet.cell(rowVals,14).string(summaryDtl['RewardItem']).style(style3);
    worksheet.cell(rowVals,15).string(summaryDtl['STRCode']).style(style3);
    worksheet.cell(rowVals,16).string(summaryDtl['EndUse']).style(style3);
    worksheet.cell(rowVals,17).string(summaryDtl['IGSTPaymentStatus']).style(style3);
    worksheet.cell(rowVals,18).string(summaryDtl['TaxableValue']).style(style3);
    worksheet.cell(rowVals,19).string(summaryDtl['IGSTAmount']).style(style3);
    worksheet.cell(rowVals,20).string(summaryDtl['IGSTRate']).style(style3);
    worksheet.cell(rowVals,21).string(summaryDtl['CompensationCessAmount']).style(style3);
    worksheet.cell(rowVals,22).string(summaryDtl['StateCode']).style(style3);
    worksheet.cell(rowVals,23).string(summaryDtl['DistrictCode']).style(style3);
    worksheet.cell(rowVals,24).string(summaryDtl['StandardQty']).style(style3);
    worksheet.cell(rowVals,25).string(summaryDtl['StandardQtyUnit']).style(style3);
    worksheet.cell(rowVals,26).string(summaryDtl['FTACode']).style(style3);
    worksheet.cell(rowVals,27).string(summaryDtl['AccessoryStatus​']).style(style3);
    worksheet.cell(rowVals,28).string(summaryDtl['RODTEP']).style(style3);
    worksheet.cell(rowVals,29).string(summaryDtl['STATEMENTCODE']).style(style3);
   
    }
   
    let params = {};
    params["accessKeyId"]=dbmsDtldata.s3key;
    params["secretAccessKey"]=dbmsDtldata.s3val;
    AWS.config.update(params);
    let s3FileSetup = dbmsDtldata.s3FileSetup;
    let arrObj = s3FileSetup;
    arrObj = arrObj.split(",");
    //console.log(arrObj);
    let map = {};
    for(let i=0;i<arrObj.length;i++){
        let obj = arrObj[i];
        let data = obj.split("#");
        map[data[0]] = data[1];
    }

    var secretName =map["secretName"];
    var client = new AWS.SecretsManager({ region: map["region"] });
    client.getSecretValue({ SecretId: secretName }, async function (err, data) {
        if (err) {
            console.log("Error Obtaining Credentials", err);
        } else {
            if ("SecretString" in data) {
                secret = data.SecretString;
                secret = JSON.parse(secret)
;
                params = {};
                params["accessKeyId"] = secret.id;
                params["secretAccessKey"] = secret.key;
                params["region"] = map["region"];
                AWS.config.update(params);
                let s3 = new AWS.S3();
                const buffer = await workbook.writeToBuffer();
                    // Do something with buffer
                 
                let fileName = 'BVC_Agent_ExportExcel'+dte+'.xlsx';
                let filePath = files_url +""+fileName;
                var params = {
                Bucket: map["bucketName"], 
                Key: fileName, 
                Body: buffer
                };
                s3.upload(params, function(err, data) {
                    if (err) {
                        outJson["result"]='';
                        outJson["link"]= '';
                        outJson["status"]="FAIL";
                        outJson["message"]="Excel Save Failed!";
                        callback(null,outJson);
                    } else {
                        outJson["result"]=fileName;
                        outJson["link"]= data.Location;
                        outJson["status"]="SUCCESS";
                        outJson["message"]="Excel Saved Successfully!";
                        callback(null,outJson);
                    }
                });
            }
        }
    })
    
    //workbook.write('files/'+fileName, function(err, stats) {
    ///    if (err) {
    //        console.error(err);
    //        outJson["result"]='';
    //        outJson["link"]= '';
    //        outJson["status"]="FAIL";
    //        outJson["message"]="Excel Save Failed!";
    //        callback(null,outJson);
    //    } else {
    //        outJson["result"]=fileName;
    //        outJson["link"]= filePath;
    //        outJson["status"]="SUCCESS";
    //        outJson["message"]="Excel Saved Successfully!";
    //        callback(null,outJson);
    //    }
    //})

}



exports.getJKAgentExcel= async function (paramJson,callback){
    var mainDetails = paramJson['mainDetails']||[];
    var invoiceDetails = paramJson['invoiceDetails']||[];
    var productDetails = paramJson['productDetails']||[];
    var prefix = paramJson['prefix']||'';
     var coIdn = paramJson['coIdn']||'';
    

   var outJson={};
    var now = new Date();
    var dte=dateFormat(now, "ddmmmyyyydh.MM.ss");
    var dteexce=dateFormat(now, "dd-mm-yyyy");
    //console.log("HI"+attrDtl);
    var workbook = new excel.Workbook();

    var mainsheet = workbook.addWorksheet('mainDetails');
    var invoicesheet = workbook.addWorksheet('Invoice details');
    var productsheet = workbook.addWorksheet('Product details');


    var style = workbook.createStyle({
        font: {
            color: '00000000',
            bold: true,
            name: 'Calibri',
            size: 12
        },
        fill: {
            type: 'pattern',
            patternType: 'solid',
            bgColor: '#ccc4d4',
            fgColor: '#ccc4d4',
          },
          alignment: {
            wrapText: true,
            horizontal: 'center',
            readingOrder:'contextDependent'
          }     
    });
    var style2 = workbook.createStyle({
        font: {
            color: '00000000',
            name: 'Calibri',
            bold: true,

            size: 11
        },
          alignment: {
            wrapText: false,
            horizontal: 'center',
          },
             
    });
    var style3 = workbook.createStyle({
        font: {
            color: '00000000',
            name: 'Calibri',
            size: 11
        },
          alignment: {
            wrapText: false,
            horizontal: 'center',
          },
             
    });
    var cachedUrl = require('qaq-core-util').cachedUrl;

    let dbmsDtldata = await coreUtil.getCache(prefix+"dbms_"+coIdn,cachedUrl); 
    dbmsDtldata = JSON.parse(dbmsDtldata); 
    let files_url = dbmsDtldata["files_url"] || '';

    var rowVals = 1
    mainsheet.cell(rowVals,1).string('Shipment Type').style(style2);
    mainsheet.cell(rowVals,2).string('Vessel').style(style2);
    mainsheet.cell(rowVals,3).string('Packages').style(style2);
    mainsheet.cell(rowVals,4).string('Unit of Packages').style(style2);
    mainsheet.cell(rowVals,5).string('Loose Packages').style(style2);
    mainsheet.cell(rowVals,6).string('Shipping Bill Type').style(style2);
    mainsheet.cell(rowVals,7).string('Clearance Port').style(style2);
    mainsheet.cell(rowVals,8).string('Branch Sr No').style(style2);
    mainsheet.cell(rowVals,9).string('Bank AD Code').style(style2);
    mainsheet.cell(rowVals,10).string('Consignee Code').style(style2);
    mainsheet.cell(rowVals,11).string('Consignee Bank Code').style(style2);
    mainsheet.cell(rowVals,12).string('Buyer Code').style(style2);

    for (let i = 0; i < mainDetails.length; i++) {
        let mainDtls = mainDetails[i];
        rowVals++;
        let srno =i+"";
        mainsheet.cell(rowVals,1).string(mainDtls['shipment_type']).style(style3);
        mainsheet.cell(rowVals,2).string(mainDtls['vessel']).style(style3);
        mainsheet.cell(rowVals,3).number(mainDtls['pktcount']).style(style3);
        mainsheet.cell(rowVals,4).string(mainDtls['unit_of_packages']).style(style3);
        mainsheet.cell(rowVals,5).string(mainDtls['loose_packages']).style(style3);
        mainsheet.cell(rowVals,6).string(mainDtls['shipping_bill_type']).style(style3);
        mainsheet.cell(rowVals,7).string(mainDtls['clearance_port']).style(style3);
        mainsheet.cell(rowVals,8).string(mainDtls['branch_sr_no']).style(style3);
        mainsheet.cell(rowVals,9).string(mainDtls['bank_ad_code']).style(style3);
        mainsheet.cell(rowVals,10).string(mainDtls['consignee_code']).style(style3);
        mainsheet.cell(rowVals,11).string(mainDtls['consignee_bank_code']).style(style3);
        mainsheet.cell(rowVals,12).string(mainDtls['buyer_code']).style(style3);
    }
   
    rowVals = 1
    invoicesheet.cell(rowVals,1).string('Invoice No').style(style2);
    invoicesheet.cell(rowVals,2).string('Date').style(style2);
    invoicesheet.cell(rowVals,3).string('Invoice Term').style(style2);
    invoicesheet.cell(rowVals,4).string('Currency').style(style2);
    invoicesheet.cell(rowVals,5).string('Net Quantity').style(style2);
    invoicesheet.cell(rowVals,6).string('Unit').style(style2);
    invoicesheet.cell(rowVals,7).string('Exchange Rate').style(style2);
    invoicesheet.cell(rowVals,8).string('Invoice Amount').style(style2);
    invoicesheet.cell(rowVals,9).string('Nature of transaction').style(style2);
    invoicesheet.cell(rowVals,10).string('Nature of payment').style(style2);
    invoicesheet.cell(rowVals,11).string('Payment Days').style(style2);
    invoicesheet.cell(rowVals,12).string('Unit Price Include').style(style2);
    invoicesheet.cell(rowVals,13).string('Freight Currency').style(style2);
    invoicesheet.cell(rowVals,14).string('Freight Amount').style(style2);
    invoicesheet.cell(rowVals,15).string('Insurance Currency').style(style2);
    invoicesheet.cell(rowVals,16).string('Insurance Amount').style(style2);
    invoicesheet.cell(rowVals,17).string('Commission Currency').style(style2);
    invoicesheet.cell(rowVals,18).string('Commission Amount').style(style2);
    invoicesheet.cell(rowVals,19).string('Discount Currency').style(style2);
    invoicesheet.cell(rowVals,20).string('Discount Amount').style(style2);
    invoicesheet.cell(rowVals,21).string('Other Deduction Currency').style(style2);
    invoicesheet.cell(rowVals,22).string('Other Deduction Amount').style(style2);
    invoicesheet.cell(rowVals,23).string('Other Addition Currency').style(style2);
    invoicesheet.cell(rowVals,24).string('Other Addition Amount').style(style2);
    invoicesheet.cell(rowVals,25).string('GrossWeight').style(style2);
    invoicesheet.cell(rowVals,26).string('GrossWeightUOM').style(style2);



    for (let i = 0; i < invoiceDetails.length; i++) {
    let invoiceDtls = invoiceDetails[i];
    rowVals++;
    let srno =i+"";
    invoicesheet.cell(rowVals,1).string(invoiceDtls['entry_title']).style(style3);
    invoicesheet.cell(rowVals,2).string(invoiceDtls['trns_dt']).style(style3);
    invoicesheet.cell(rowVals,3).string(invoiceDtls['invoice_term']).style(style3);
    invoicesheet.cell(rowVals,4).string(invoiceDtls['currency']).style(style3);
    invoicesheet.cell(rowVals,5).string(invoiceDtls['net_quantity']).style(style3);
    invoicesheet.cell(rowVals,6).string(invoiceDtls['Unit']).style(style3);
    invoicesheet.cell(rowVals,7).string(invoiceDtls['exh_rte']).style(style3);
    invoicesheet.cell(rowVals,8).string(invoiceDtls['invoice_amount']).style(style3);
    invoicesheet.cell(rowVals,9).string(invoiceDtls['nature_of_transaction']).style(style3);
    invoicesheet.cell(rowVals,10).string(invoiceDtls['nature_of_payment']).style(style3);
    invoicesheet.cell(rowVals,11).string(invoiceDtls['payment_days']).style(style3);
    invoicesheet.cell(rowVals,12).string(invoiceDtls['unit_price_includes']).style(style3);
    invoicesheet.cell(rowVals,13).string(invoiceDtls['freight_currency']).style(style3);
    invoicesheet.cell(rowVals,14).string(invoiceDtls['freight_amount']).style(style3);
    invoicesheet.cell(rowVals,15).string(invoiceDtls['insurance_currency']).style(style3);
    invoicesheet.cell(rowVals,16).string(invoiceDtls['insurance_amount']).style(style3);
    invoicesheet.cell(rowVals,17).string(invoiceDtls['commissiont_currency']).style(style3);
    invoicesheet.cell(rowVals,18).string(invoiceDtls['commissiont_amount']).style(style3);
    invoicesheet.cell(rowVals,19).string(invoiceDtls['discount_currency']).style(style3);
    invoicesheet.cell(rowVals,20).string(invoiceDtls['discount_amount']).style(style3);
    invoicesheet.cell(rowVals,21).string(invoiceDtls['other_deduction_currency']).style(style3);
    invoicesheet.cell(rowVals,22).string(invoiceDtls['other_deduction_amount']).style(style3);
    invoicesheet.cell(rowVals,23).string(invoiceDtls['other_addtion_currency']).style(style3);
    invoicesheet.cell(rowVals,24).string(invoiceDtls['other_addtion_amount']).style(style3);
    invoicesheet.cell(rowVals,25).string(invoiceDtls['gross_wt']).style(style3);
    invoicesheet.cell(rowVals,26).string(invoiceDtls['grossweightuom']).style(style3);
    }

    rowVals = 1
    productsheet.cell(rowVals,1).string('Invoice No').style(style2);
    productsheet.cell(rowVals,2).string('Product Sr No').style(style2);
    productsheet.cell(rowVals,3).string('RITC Code').style(style2);
    productsheet.cell(rowVals,4).string('Product Description').style(style2);
    productsheet.cell(rowVals,5).string('Quantity').style(style2);
    productsheet.cell(rowVals,6).string('Unit').style(style2);
    productsheet.cell(rowVals,7).string('Product Amount').style(style2);
    productsheet.cell(rowVals,8).string('End Use of Item').style(style2);
    productsheet.cell(rowVals,9).string('IGST Payment Status').style(style2);
    productsheet.cell(rowVals,10).string('Taxable Value').style(style2);
    productsheet.cell(rowVals,11).string('IGST Amount').style(style2);
    productsheet.cell(rowVals,12).string('Compensation Cess Amount').style(style2);
    productsheet.cell(rowVals,13).string('State Code').style(style2);
    productsheet.cell(rowVals,14).string('District Code').style(style2);
    productsheet.cell(rowVals,15).string('Standard Qty').style(style2);
    productsheet.cell(rowVals,16).string('Standard Qty Unit').style(style2);
    productsheet.cell(rowVals,17).string('FTA Code').style(style2);

    let srNo = 0;
    for (let i = 0; i < productDetails.length; i++) {
        let productDtls = productDetails[i];
        rowVals++;
        srNo++;
        let srno =srNo+"";
        productsheet.cell(rowVals,1).string(productDtls['entry_title']).style(style3);
        productsheet.cell(rowVals,2).string(srno).style(style3);
        productsheet.cell(rowVals,3).string(productDtls['RITC_Code']).style(style3);
        productsheet.cell(rowVals,4).string(productDtls['descs']).style(style3);
        productsheet.cell(rowVals,5).string(productDtls['qty']).style(style3);
        productsheet.cell(rowVals,6).string(productDtls['unit']).style(style3);
        productsheet.cell(rowVals,7).string(productDtls['amount']).style(style3);
        productsheet.cell(rowVals,8).string(productDtls['end_use_of_Item']).style(style3);
        productsheet.cell(rowVals,9).string(productDtls['IGST_pay_status']).style(style3);
        productsheet.cell(rowVals,10).string(productDtls['taxable_value']).style(style3);
        productsheet.cell(rowVals,11).string(productDtls['IGST_amount']).style(style3);
        productsheet.cell(rowVals,12).string(productDtls['compensation_cess_amount']).style(style3);
        productsheet.cell(rowVals,13).string(productDtls['state_code']).style(style3);
        productsheet.cell(rowVals,14).string(productDtls['district_code']).style(style3);
        productsheet.cell(rowVals,15).string(productDtls['qty']).style(style3);
        productsheet.cell(rowVals,16).string(productDtls['standard_qty_unit']).style(style3);
        productsheet.cell(rowVals,17).string(productDtls['FTA_code']).style(style3);


        }

        let params = {};
        params["accessKeyId"]=dbmsDtldata.s3key;
        params["secretAccessKey"]=dbmsDtldata.s3val;
        AWS.config.update(params);
        let s3FileSetup = dbmsDtldata.s3FileSetup;
        let arrObj = s3FileSetup;
        arrObj = arrObj.split(",");
        //console.log(arrObj);
        let map = {};
        for(let i=0;i<arrObj.length;i++){
            let obj = arrObj[i];
            let data = obj.split("#");
            map[data[0]] = data[1];
        }
        var secretName = map["secretName"];
        var client = new AWS.SecretsManager({ region: map["region"] });
        client.getSecretValue({ SecretId: secretName }, async function (err, data) {
            if (err) {
                console.log("Error Obtaining Credentials", err);
            } else {
                if ("SecretString" in data) {
                    secret = data.SecretString;
                    secret = JSON.parse(secret)
    ;
                    params = {};
                    params["accessKeyId"] = secret.id;
                    params["secretAccessKey"] = secret.key;
                    params["region"] = map["region"];
                    AWS.config.update(params);
                    let s3 = new AWS.S3();
                    const buffer = await workbook.writeToBuffer();
                        // Do something with buffer
                    
                    let fileName = 'JK_Agent_ExportExcel'+dte+'.xlsx';
                    let filePath = files_url +""+fileName;
                    var params = {
                    Bucket: map["bucketName"], 
                    Key: fileName, 
                    Body: buffer
                    };
                    s3.upload(params, function(err, data) {
                        if (err) {
                            console.error(err);
                            outJson["result"]='';
                            outJson["link"]= '';
                            outJson["status"]="FAIL";
                            outJson["message"]="Excel Save Failed!";
                            callback(null,outJson);
                        } else {
                            outJson["result"]=fileName;
                            outJson["link"]= data.Location;
                            outJson["status"]="SUCCESS";
                            outJson["message"]="Excel Saved Successfully!";
                            callback(null,outJson);
                        }
                    });
                }
            }
        })

  
    //workbook.write('files/'+fileName, function(err, stats) {
     //   if (err) {
    //        console.error(err);
    //        outJson["result"]='';
    //        outJson["link"]= '';
    //        outJson["status"]="FAIL";
    //        outJson["message"]="Excel Save Failed!";
    //        callback(null,outJson);
     //   } else {
    //        outJson["result"]=fileName;
    //        outJson["link"]= filePath;
    ///        outJson["status"]="SUCCESS";
    ///        outJson["message"]="Excel Saved Successfully!";
    //        callback(null,outJson);
     //   }
    //})

}

exports.getInvoiceJsonExcel= async function (paramJson,callback){
    var eInviceJson = paramJson['eInviceJson']||{};
    var prefix = paramJson['prefix']||'';
     var coIdn = paramJson['coIdn']||'';
     let fileName = paramJson["fileName"] || '';
    

   var outJson={};
    var now = new Date();
    var dte=dateFormat(now, "ddmmmyyyydh.MM.ss");
    var dteexce=dateFormat(now, "dd-mm-yyyy");
    //console.log("HI"+attrDtl);
    var workbook = new excel.Workbook();
    var worksheet = workbook.addWorksheet('Sheet 1');
    var style3 = workbook.createStyle({
        font: {
            color: '00000000',
            bold: true,
            name: 'Calibri',
            size: 12
        },
        fill: {
            type: 'pattern',
            patternType: 'solid',
            //bgColor: '#ccc4d4',
            fgColor: '#ccc4d4',
          },
          alignment: {
            wrapText: true,
            horizontal: 'center',
            readingOrder:'contextDependent'
          }     
    });
    var style2 = workbook.createStyle({
        font: {
            color: '00000000',
            name: 'Calibri',
            bold: true,

            size: 11
        },
          alignment: {
            wrapText: true,
            horizontal: 'center',
          },
             
    });
    var style = workbook.createStyle({
        font: {
            color: '00000000',
            name: 'Calibri',
            size: 11
        },
          alignment: {
            wrapText: false,
            horizontal: 'center',
          },
             
    });
    var styleHdr = workbook.createStyle({
        font: {
            color: '00000000',
            name: 'Calibri',
            bold: true,

            size: 18
        },
          alignment: {
            wrapText: true,
            horizontal: 'center',
          },
             
    });
    var styleGreen = workbook.createStyle({
        font: {
            color: '00000000',
            bold: true,
            name: 'Calibri',
            size: 12
        },
        fill: {
            type: 'pattern',
            patternType: 'solid',
            //bgColor: '#ccc4d4',
            fgColor: '#90EE90',
          },
          alignment: {
            wrapText: true,
            horizontal: 'center',
            readingOrder:'contextDependent'
          }     
    });
    var styleBlue = workbook.createStyle({
        font: {
            color: '00000000',
            bold: true,
            name: 'Calibri',
            size: 12
        },
        fill: {
            type: 'pattern',
            patternType: 'solid',
            //bgColor: '#ccc4d4',
            fgColor: '#ADD8E6',
          },
          alignment: {
            wrapText: true,
            horizontal: 'center',
            readingOrder:'contextDependent'
          }     
    });
    var stylePink = workbook.createStyle({
        font: {
            color: '00000000',
            bold: true,
            name: 'Calibri',
            size: 12
        },
        fill: {
            type: 'pattern',
            patternType: 'solid',
            //bgColor: '#ccc4d4',
            fgColor: '#ffb6c1',
          },
          alignment: {
            wrapText: true,
            horizontal: 'center',
            readingOrder:'contextDependent'
          }     
    });
    var cachedUrl = require('qaq-core-util').cachedUrl;

    let dbmsDtldata = await coreUtil.getCache(prefix+"dbms_"+coIdn,cachedUrl); 
    dbmsDtldata = JSON.parse(dbmsDtldata); 
    let files_url = dbmsDtldata["files_url"] || '';

    var rowVals = 1
    worksheet.cell(rowVals,1,rowVals,20,true).string('E-Invoice System').style(styleHdr);
    //worksheet.cell(rowVals,2).string(eInviceJson["Version"]).style(style2);
    worksheet.cell(rowVals,21,rowVals,40,true).string('*  Indicates Mandatory Fields').style(style2);

    rowVals++;
    worksheet.cell(rowVals,1,rowVals,4,true).string('').style(style2);
    worksheet.cell(rowVals,5,rowVals,7,true).string('Document Details').style(style3);
    worksheet.cell(rowVals,8,rowVals,18,true).string('Buyer Details').style(styleGreen);
    worksheet.cell(rowVals,19,rowVals,24,true).string('Dispatch Details').style(styleBlue);
    worksheet.cell(rowVals,25,rowVals,32,true).string('Shipping Details').style(stylePink);
    worksheet.cell(rowVals,33,rowVals,57,true).string('Product Details').style(style3);
    worksheet.cell(rowVals,58,rowVals,60,true).string('Batch Details').style(styleGreen);
    worksheet.cell(rowVals,61,rowVals,70,true).string('Value Details').style(stylePink);
    worksheet.cell(rowVals,71,rowVals,77,true).string('Export Details').style(style3);
    worksheet.cell(rowVals,78,rowVals,85,true).string('E-way-bill Details').style(styleGreen);

    rowVals++;
    worksheet.cell(rowVals,1).string('Supply Type Code *').style(stylePink);
    worksheet.cell(rowVals,2).string('Reverse Charge').style(stylePink);
    worksheet.cell(rowVals,3).string('e-Comm GSTIN').style(stylePink);
    worksheet.cell(rowVals,4).string('Igst On Intra').style(stylePink);

    worksheet.cell(rowVals,5).string('Document Type *').style(style3);
    worksheet.cell(rowVals,6).string('Document Number *').style(style3);
    worksheet.cell(rowVals,7).string('Document Date (DD/MM/YYYY) *').style(style3);

    worksheet.cell(rowVals,8).string('Buyer GSTIN *').style(styleGreen);
    worksheet.cell(rowVals,9).string('Buyer Legal Name *').style(styleGreen);
    worksheet.cell(rowVals,10).string('Buyer Trade Name ').style(styleGreen);
    worksheet.cell(rowVals,11).string('Buyer POS *').style(styleGreen);
    worksheet.cell(rowVals,12).string('Buyer Addr1 *').style(styleGreen);
    worksheet.cell(rowVals,13).string('Buyer Addr2').style(styleGreen);
    worksheet.cell(rowVals,14).string('Buyer Location *').style(styleGreen);
    worksheet.cell(rowVals,15).string('Buyer Pin Code').style(styleGreen);
    worksheet.cell(rowVals,16).string('Buyer State *').style(styleGreen);
    worksheet.cell(rowVals,17).string('Buyer Phone Number').style(styleGreen);
    worksheet.cell(rowVals,18).string('Buyer Email Id').style(styleGreen);

    worksheet.cell(rowVals,19).string('Dispatch Name ').style(styleBlue);
    worksheet.cell(rowVals,20).string('Dispatch Addr1 ').style(styleBlue);
    worksheet.cell(rowVals,21).string('Dispatch Addr2').style(styleBlue);
    worksheet.cell(rowVals,22).string('Dispatch Location ').style(styleBlue);
    worksheet.cell(rowVals,23).string('Dispatch Pin Code').style(styleBlue);
    worksheet.cell(rowVals,24).string('Dispatch State ').style(styleBlue);

    worksheet.cell(rowVals,25).string('Shipping GSTIN ').style(stylePink);
    worksheet.cell(rowVals,26).string('Shipping Legal Name').style(stylePink);
    worksheet.cell(rowVals,27).string('Shipping Trade Name').style(stylePink);
    worksheet.cell(rowVals,28).string('Shipping Addr1').style(stylePink);
    worksheet.cell(rowVals,29).string('Shipping Addr2').style(stylePink);
    worksheet.cell(rowVals,30).string('Shipping Location').style(stylePink);
    worksheet.cell(rowVals,31).string('Shipping Pin Code').style(stylePink);
    worksheet.cell(rowVals,32).string('Shipping State').style(stylePink);

    worksheet.cell(rowVals,33).string('Sl.No. *').style(style3);
    worksheet.cell(rowVals,34).string('Product Description').style(style3);
    worksheet.cell(rowVals,35).string('Is_Service *').style(style3);
    worksheet.cell(rowVals,36).string('HSN code *').style(style3);
    worksheet.cell(rowVals,37).string('Bar code ').style(style3);
    worksheet.cell(rowVals,38).string('Quantity *').style(style3);
    worksheet.cell(rowVals,39).string('Free Quantity').style(style3);
    worksheet.cell(rowVals,40).string('Unit *').style(style3);
    worksheet.cell(rowVals,41).string('Unit Price *').style(style3);
    worksheet.cell(rowVals,42).string('Gross Amount *').style(style3);
    worksheet.cell(rowVals,43).string('Discount').style(style3);
    worksheet.cell(rowVals,44).string('Pre Tax Value').style(style3);
    worksheet.cell(rowVals,45).string('Taxable value *').style(style3);
    worksheet.cell(rowVals,46).string('GST Rate (%) *').style(style3);
    worksheet.cell(rowVals,47).string('Sgst Amt(Rs)').style(style3);
    worksheet.cell(rowVals,48).string('Cgst Amt (Rs)').style(style3);
    worksheet.cell(rowVals,49).string('Igst Amt (Rs)').style(style3);
    worksheet.cell(rowVals,50).string('Cess Rate (%)').style(style3);
    worksheet.cell(rowVals,51).string('Cess Amt Adval (Rs)').style(style3);
    worksheet.cell(rowVals,52).string('Cess Non Adval Amt (Rs)').style(style3);
    worksheet.cell(rowVals,53).string('State Cess Rate (%)').style(style3);
    worksheet.cell(rowVals,54).string('State Cess Adval Amt (Rs)').style(style3);
    worksheet.cell(rowVals,55).string('State Cess Non-Adval Amt (Rs)').style(style3);
    worksheet.cell(rowVals,56).string('Other Charges').style(style3);
    worksheet.cell(rowVals,57).string('Item Total *').style(style3);

    worksheet.cell(rowVals,58).string('Batch Name').style(styleGreen);
    worksheet.cell(rowVals,59).string('Batch Expiry Dt').style(styleGreen);
    worksheet.cell(rowVals,60).string('Warranty Dt').style(styleGreen);

    worksheet.cell(rowVals,61).string('Total Taxable value ').style(stylePink);
    worksheet.cell(rowVals,62).string('Sgst Amt').style(stylePink);
    worksheet.cell(rowVals,63).string('Cgst Amt').style(stylePink);
    worksheet.cell(rowVals,64).string('Igst Amt').style(stylePink);
    worksheet.cell(rowVals,65).string('Cess Amt').style(stylePink);
    worksheet.cell(rowVals,66).string('State Cess Amt').style(stylePink);
    worksheet.cell(rowVals,67).string('Discount').style(stylePink);
    worksheet.cell(rowVals,68).string('Other charges').style(stylePink);
    worksheet.cell(rowVals,69).string('Round off').style(stylePink);
    worksheet.cell(rowVals,70).string('Total Invoice value *').style(stylePink);

    worksheet.cell(rowVals,71).string('Shipping Bill No').style(style3);
    worksheet.cell(rowVals,72).string('Shipping Bill Dt').style(style3);
    worksheet.cell(rowVals,73).string('Port').style(style3);
    worksheet.cell(rowVals,74).string('Refund claim').style(style3);
    worksheet.cell(rowVals,75).string('Foreign Currency').style(style3);
    worksheet.cell(rowVals,76).string('Country Code').style(style3);
    worksheet.cell(rowVals,77).string('Export Duty Amount').style(style3);

    worksheet.cell(rowVals,78).string('Trans ID').style(styleGreen);
    worksheet.cell(rowVals,79).string('Trans Name').style(styleGreen);
    worksheet.cell(rowVals,80).string('Trans Mode').style(styleGreen);
    worksheet.cell(rowVals,81).string('Distance ').style(styleGreen);
    worksheet.cell(rowVals,82).string('Trans Doc No.').style(styleGreen);
    worksheet.cell(rowVals,83).string('Trans Doc Date').style(styleGreen);
    worksheet.cell(rowVals,84).string('Vehicle No.').style(styleGreen);
    worksheet.cell(rowVals,85).string('Vehicle Type').style(styleGreen);

    rowVals++;
    let TranDtls = eInviceJson["TranDtls"] || {};
    worksheet.cell(rowVals,1).string(TranDtls["SupTyp"]).style(style);
    worksheet.cell(rowVals,2).string(TranDtls["RegRev"]).style(style);
    worksheet.cell(rowVals,3).string(TranDtls["EcmGstin"] || '').style(style);
    worksheet.cell(rowVals,4).string(TranDtls["IgstOnIntra"]).style(style);

    let DocDtls = eInviceJson["DocDtls"] || {};
    worksheet.cell(rowVals,5).string(DocDtls["Typ"]).style(style);
    worksheet.cell(rowVals,6).string(DocDtls["No"]).style(style);
    worksheet.cell(rowVals,7).string(DocDtls["Dt"]).style(style);

    let BuyerDtls = eInviceJson["BuyerDtls"] || {};
    worksheet.cell(rowVals,8).string(BuyerDtls["Gstin"]).style(style);
    worksheet.cell(rowVals,9).string(BuyerDtls["LglNm"]).style(style);
    worksheet.cell(rowVals,10).string(BuyerDtls["TrdNm"]).style(style);
    worksheet.cell(rowVals,11).string(BuyerDtls["Pos"]).style(style);
    worksheet.cell(rowVals,12).string(BuyerDtls["Addr1"]).style(style);
    worksheet.cell(rowVals,13).string(BuyerDtls["Addr2"]||'').style(style);
    worksheet.cell(rowVals,14).string(BuyerDtls["Loc"]).style(style);
    worksheet.cell(rowVals,15).string(BuyerDtls["Pin"]).style(style);
    worksheet.cell(rowVals,16).string(BuyerDtls["Stcd"]).style(style);
    worksheet.cell(rowVals,17).string(BuyerDtls["Ph"]||'').style(style);
    worksheet.cell(rowVals,18).string(BuyerDtls["Em"]).style(style);

    worksheet.cell(rowVals,19).string(eInviceJson['DispDtls']||'').style(style);
    worksheet.cell(rowVals,20).string(eInviceJson['DispDtls']||'').style(style);
    worksheet.cell(rowVals,21).string(eInviceJson['DispDtls']||'').style(style);
    worksheet.cell(rowVals,22).string(eInviceJson['DispDtls']||'').style(style);
    worksheet.cell(rowVals,23).string(eInviceJson['DispDtls']||'').style(style);
    worksheet.cell(rowVals,24).string(eInviceJson['DispDtls']||'').style(style);

    worksheet.cell(rowVals,25).string(eInviceJson['ShipDtls']||'').style(style);
    worksheet.cell(rowVals,26).string(eInviceJson['ShipDtls']||'').style(style);
    worksheet.cell(rowVals,27).string(eInviceJson['ShipDtls']||'').style(style);
    worksheet.cell(rowVals,28).string(eInviceJson['ShipDtls']||'').style(style);
    worksheet.cell(rowVals,29).string(eInviceJson['ShipDtls']||'').style(style);
    worksheet.cell(rowVals,30).string(eInviceJson['ShipDtls']||'').style(style);
    worksheet.cell(rowVals,31).string(eInviceJson['ShipDtls']||'').style(style);
    worksheet.cell(rowVals,32).string(eInviceJson['ShipDtls']||'').style(style);

    let ItemList = eInviceJson["ItemList"] || [];
    let itemObj = ItemList[0] ||{}
    worksheet.cell(rowVals,33).string(itemObj["SlNo"]).style(style);
    worksheet.cell(rowVals,34).string(itemObj["PrdDesc"]).style(style);
    worksheet.cell(rowVals,35).string(itemObj["IsServc"]).style(style);
    worksheet.cell(rowVals,36).string(itemObj["HsnCd"]).style(style);
    worksheet.cell(rowVals,37).string(itemObj["Barcde"] ||'').style(style);
    worksheet.cell(rowVals,38).number(itemObj["Qty"]).style(style);
    worksheet.cell(rowVals,39).string(itemObj["FreeQty"]).style(style);
    worksheet.cell(rowVals,40).string(itemObj["Unit"]).style(style);
    worksheet.cell(rowVals,41).number(itemObj["UnitPrice"]).style(style);
    worksheet.cell(rowVals,42).number(itemObj["TotAmt"]).style(style);
    worksheet.cell(rowVals,43).string(itemObj["Discount"]).style(style);
    worksheet.cell(rowVals,44).string(itemObj["PreTaxVal"]).style(style);
    worksheet.cell(rowVals,45).number(itemObj["AssAmt"]).style(style);
    worksheet.cell(rowVals,46).number(itemObj["GstRt"]).style(style);
    worksheet.cell(rowVals,47).number(itemObj["SgstAmt"]).style(style);
    worksheet.cell(rowVals,48).number(itemObj["CgstAmt"]).style(style);
    worksheet.cell(rowVals,49).number(itemObj["IgstAmt"]).style(style);
    worksheet.cell(rowVals,50).string(itemObj["CesRt"]).style(style);
    worksheet.cell(rowVals,51).string(itemObj["CesAmt"]).style(style);
    worksheet.cell(rowVals,52).string(itemObj["CesNonAdvlAmt"]).style(style);
    worksheet.cell(rowVals,53).string(itemObj["StateCesRt"]).style(style);
    worksheet.cell(rowVals,54).string(itemObj["StateCesAmt"]).style(style);
    worksheet.cell(rowVals,55).string(itemObj["StateCesNonAdvlAmt"]).style(style);
    worksheet.cell(rowVals,56).string(itemObj["OthChrg"]).style(style);
    worksheet.cell(rowVals,57).number(itemObj["TotItemVal"]).style(style);

    worksheet.cell(rowVals,58).string(itemObj["BchDtls"] || '').style(style);
    worksheet.cell(rowVals,59).string(itemObj["BchDtls"] || '').style(style);
    worksheet.cell(rowVals,60).string(itemObj["BchDtls"] || '').style(style);

    let ValDtls = eInviceJson["ValDtls"] || {};
    worksheet.cell(rowVals,61).number(ValDtls["AssVal"]).style(style);
    worksheet.cell(rowVals,62).number(ValDtls["SgstVal"] || 0).style(style);
    worksheet.cell(rowVals,63).number(ValDtls["CgstVal"] || 0).style(style);
    worksheet.cell(rowVals,64).number(ValDtls["IgstVal"] || 0).style(style);
    worksheet.cell(rowVals,65).string(ValDtls["CesVal"]).style(style);
    worksheet.cell(rowVals,66).string(ValDtls["StCesVal"]).style(style);
    worksheet.cell(rowVals,67).string(ValDtls["Discount"]).style(style);
    worksheet.cell(rowVals,68).string(ValDtls["OthChrg"]).style(style);
    worksheet.cell(rowVals,69).string(ValDtls["RndOffAmt"]).style(style);
    worksheet.cell(rowVals,70).number(ValDtls["TotInvVal"]).style(style);

    let ExpDtls = eInviceJson["ExpDtls"] || {};
    worksheet.cell(rowVals,71).string(ExpDtls['ShipBNo'] || '').style(style);
    worksheet.cell(rowVals,72).string(ExpDtls['ShipBDt'] || '').style(style);
    worksheet.cell(rowVals,73).string(ExpDtls['Port'] || '').style(style);
    worksheet.cell(rowVals,74).string(ExpDtls['RefClm'] || '').style(style);
    worksheet.cell(rowVals,75).string(ExpDtls['ForCur'] || '').style(style);
    worksheet.cell(rowVals,76).string(ExpDtls['CntCode'] || '').style(style);
    worksheet.cell(rowVals,77).string(ExpDtls['ExpDuty']).style(style);

    worksheet.cell(rowVals,78).string(eInviceJson['EwbDtls'] || '').style(style);
    worksheet.cell(rowVals,79).string(eInviceJson['EwbDtls'] || '').style(style);
    worksheet.cell(rowVals,80).string(eInviceJson['EwbDtls'] || '').style(style);
    worksheet.cell(rowVals,81).string(eInviceJson['EwbDtls'] || '').style(style);
    worksheet.cell(rowVals,82).string(eInviceJson['EwbDtls'] || '').style(style);
    worksheet.cell(rowVals,83).string(eInviceJson['EwbDtls'] || '').style(style);
    worksheet.cell(rowVals,84).string(eInviceJson['EwbDtls'] || '').style(style);
    worksheet.cell(rowVals,85).string(eInviceJson['EwbDtls'] || '').style(style);

    //rowVals++;
    //let TranDtls = eInviceJson["TranDtls"] || {};
    //var TranDtlsKeys=Object.keys(TranDtls) || [];
    //for(let i = 0;i<TranDtlsKeys.length;i++){
    //     let key = TranDtlsKeys[i];
    //     let colVals = i+1;
    //     worksheet.cell(rowVals,colVals).string(key).style(style);
    //     worksheet.cell((rowVals+1),colVals).string(TranDtls[key] || 'null').style(style3);
    // }

    // rowVals++;
    // rowVals++;
    // rowVals++;
    // worksheet.cell(rowVals,1).string('DocDtls').style(style2);
    // rowVals++;
    // let DocDtls = eInviceJson["DocDtls"] || {};
    // var DocDtlsKeys=Object.keys(DocDtls) || [];
    // for(let i = 0;i<DocDtlsKeys.length;i++){
    //     let key = DocDtlsKeys[i];
    //     let colVals = i+1;
    //     worksheet.cell(rowVals,colVals).string(key).style(style);
    //     worksheet.cell((rowVals+1),colVals).string(DocDtls[key] || 'null').style(style3);
    // }

    // rowVals++;
    // rowVals++;
    // rowVals++;
    // worksheet.cell(rowVals,1).string('SellerDtls').style(style2);
    // rowVals++;
    // let SellerDtls = eInviceJson["SellerDtls"] || {};
    // var SellerDtlsKeys=Object.keys(SellerDtls) || [];
    // for(let i = 0;i<SellerDtlsKeys.length;i++){
    //     let key = SellerDtlsKeys[i];
    //     let colVals = i+1;
    //     worksheet.cell(rowVals,colVals).string(key).style(style);
    //     worksheet.cell((rowVals+1),colVals).string(SellerDtls[key] || 'null').style(style3);

    // }
    
    // rowVals++;
    // rowVals++;
    // rowVals++;
    // worksheet.cell(rowVals,1).string('BuyerDtls').style(style2);
    // rowVals++;
    // let BuyerDtls = eInviceJson["BuyerDtls"] || {};
    // var BuyerDtlsKeys=Object.keys(BuyerDtls) || [];
    // for(let i = 0;i<BuyerDtlsKeys.length;i++){
    //     let key = BuyerDtlsKeys[i];
    //     let colVals = i+1;
    //     worksheet.cell(rowVals,colVals).string(key).style(style);
    //     worksheet.cell((rowVals+1),colVals).string(BuyerDtls[key] || 'null').style(style3);

    // }
    // rowVals++;
    // rowVals++;
    // rowVals++;
    // worksheet.cell(rowVals,1).string('DispDtls').style(style2);
    // worksheet.cell(rowVals,2).string(eInviceJson["DispDtls"] || 'null').style(style2);

    // rowVals++;
    // rowVals++;
    // worksheet.cell(rowVals,1).string('ShipDtls').style(style2);
    // worksheet.cell(rowVals,2).string(eInviceJson["ShipDtls"] || 'null').style(style2);

    // rowVals++;
    // rowVals++;
    // worksheet.cell(rowVals,1).string('ValDtls').style(style2);
    // rowVals++;
    // let ValDtls = eInviceJson["ValDtls"] || {};
    // var ValDtlsKeys=Object.keys(ValDtls) || [];
    // for(let i = 0;i<ValDtlsKeys.length;i++){
    //     let key = ValDtlsKeys[i];
    //     let colVals = i+1;
    //     worksheet.cell(rowVals,colVals).string(key).style(style);
    //     worksheet.cell((rowVals+1),colVals).number(ValDtls[key] || 0).style(style3);

    // }

    // rowVals++;
    // rowVals++;
    // rowVals++;
    // worksheet.cell(rowVals,1).string('ExpDtls').style(style2);
    // rowVals++;
    // let ExpDtls = eInviceJson["ExpDtls"] || {};
    // var ExpDtlsKeys=Object.keys(ExpDtls) || [];
    // for(let i = 0;i<ExpDtlsKeys.length;i++){
    //     let key = ExpDtlsKeys[i];
    //     let colVals = i+1;
    //     worksheet.cell(rowVals,colVals).string(key).style(style);
    //     let keyVal = ExpDtls[key];
    //     if(parseFloat(keyVal) || keyVal == 0){
    //         worksheet.cell((rowVals+1),colVals).number(parseFloat(keyVal) || 0).style(style3);
    //     } else
    //         worksheet.cell((rowVals+1),colVals).string(keyVal || 'null').style(style3);

    // }

    // rowVals++;
    // rowVals++;
    // rowVals++;
    // worksheet.cell(rowVals,1).string('EwbDtls').style(style2);
    // worksheet.cell(rowVals,2).string(eInviceJson["EwbDtls"] || 'null').style(style2);

    // rowVals++;
    // rowVals++;
    // worksheet.cell(rowVals,1).string('ItemList').style(style2);
    // rowVals++;
    // let ItemList = eInviceJson["ItemList"] || {};
    // for(let j=0;j<ItemList.length;j++){
    //     let obj = ItemList[j];
    //     var objKeys=Object.keys(obj) || [];
    //     for(let i = 0;i<objKeys.length;i++){
    //         let key = objKeys[i];
    //         let colVals = i+1;
    //         worksheet.cell(rowVals,colVals).string(key).style(style);
    //         let keyVal = obj[key];
    //         if(parseFloat(keyVal) || keyVal == 0){
    //             worksheet.cell((rowVals+1),colVals).number(parseFloat(keyVal) || 0).style(style3);
    //         } else 
    //             worksheet.cell((rowVals+1),colVals).string(keyVal || 'null').style(style3);
    //     }
    // }
    

        let params = {};
        params["accessKeyId"]=dbmsDtldata.s3key;
        params["secretAccessKey"]=dbmsDtldata.s3val;
        AWS.config.update(params);
        let s3FileSetup = dbmsDtldata.s3FileSetup;
        let arrObj = s3FileSetup;
        arrObj = arrObj.split(",");
        //console.log(arrObj);
        let map = {};
        for(let i=0;i<arrObj.length;i++){
            let obj = arrObj[i];
            let data = obj.split("#");
            map[data[0]] = data[1];
        }
        var secretName = map["secretName"];
        var client = new AWS.SecretsManager({ region: map["region"] });
        client.getSecretValue({ SecretId: secretName }, async function (err, data) {
            if (err) {
                console.log("Error Obtaining Credentials", err);
            } else {
                if ("SecretString" in data) {
                    secret = data.SecretString;
                    secret = JSON.parse(secret)
    ;
                    params = {};
                    params["accessKeyId"] = secret.id;
                    params["secretAccessKey"] = secret.key;
                    params["region"] = map["region"];
                    AWS.config.update(params);
                    let s3 = new AWS.S3();
                    const buffer = await workbook.writeToBuffer();
                        // Do something with buffer
                    
                    let filePath = files_url +""+fileName;
                    var params = {
                    Bucket: map["bucketName"], 
                    Key: fileName, 
                    Body: buffer
                    };
                    s3.upload(params, function(err, data) {
                        if (err) {
                            console.error(err);
                            outJson["result"]='';
                            outJson["link"]= '';
                            outJson["status"]="FAIL";
                            outJson["message"]="Excel Save Failed!";
                            callback(null,outJson);
                        } else {
                            outJson["result"]=fileName;
                            outJson["link"]= data.Location;
                            outJson["status"]="SUCCESS";
                            outJson["message"]="Excel Saved Successfully!";
                            callback(null,outJson);
                        }
                    });
                }
            }
        })

  
    //workbook.write('files/'+fileName, function(err, stats) {
     //   if (err) {
    //        console.error(err);
    //        outJson["result"]='';
    //        outJson["link"]= '';
    //        outJson["status"]="FAIL";
    //        outJson["message"]="Excel Save Failed!";
    //        callback(null,outJson);
     //   } else {
    //        outJson["result"]=fileName;
    //        outJson["link"]= filePath;
    ///        outJson["status"]="SUCCESS";
    ///        outJson["message"]="Excel Saved Successfully!";
    //        callback(null,outJson);
     //   }
    //})

}

















