const coreDB = require('qaq-core-db');
const coreUtil = require('qaq-core-util');
var excel = require('excel4node');
var dateFormat = require('dateformat');

exports.saveToExcels = function(tpoolconn,redirectParam,callback) { 
    var packetIdnList = redirectParam.packetIdnList || '';
    var packetDtl = redirectParam.packetDtl || '';
    var userIdn = redirectParam.userIdn || '';
    var coIdn = redirectParam.coIdn || '';
    var pvtConfigure = redirectParam.pvtConfigure || '';
    let source = redirectParam.source || '';
    let outJson = {};
    let methodParam={};
    var resultFinal = {};
    let formNme = redirectParam.formNme || '';
    let nmeIdn = redirectParam.nmeIdn || '';
    let imageDtl = redirectParam.imageDtl || '';
    let clientkey = redirectParam.clientkey || '';
    var header = redirectParam.header || 'N';
    var total = redirectParam.total || 'N';
    var mailSend = redirectParam.mailSend || 'N';
    var subject = redirectParam.subject || '';
    var cc = redirectParam.cc || [];
    var bcc = redirectParam.bcc || [];
    var emailIds = redirectParam.emailIds || [];
    var message =  redirectParam.message || '';
    var formatName = redirectParam.formatName || null;
    let prefix =redirectParam.prefix || '';

    if(packetIdnList !='' && packetDtl != ''){
        let resultView = [];
        methodParam["formName"]=formNme;
        methodParam["display_key"]="excel";
        methodParam["nme"]=formatName;
        methodParam["userIdn"]=userIdn;
        methodParam["coIdn"]=coIdn;
        methodParam["db"]=tpoolconn;
        methodParam["userCtg"]=pvtConfigure;
        methodParam["prefix"] = prefix;
        coreUtil.pageDisplay(methodParam).then(attrresult =>{
            resultView=attrresult.attr || [];
            //console.log(resultView);
            resultFinal["attrDtl"]=resultView;

            methodParam={};
            methodParam["coIdn"]=coIdn;  
            methodParam["userIdn"]=userIdn; 
            methodParam["nmeIdn"]=nmeIdn;
            getBuyerDetails(tpoolconn,methodParam,function(error,getBuyerDtl){
                if(error){
                    outJson["result"]=resultFinal;
                    outJson["status"]="FAIL";
                    outJson["message"]="Error In getBuyerDetails Method!";
                    callback(null,outJson);
                }else{
                    let buyerDetails = [];
                    if(getBuyerDtl.status == "SUCCESS"){
                        buyerDetails=getBuyerDtl.result || [];                
                    }

                    methodParam={};
                    methodParam["coIdn"]=coIdn;  
                    methodParam["resultView"]=resultView; 
                    methodParam["source"]=source;
                    methodParam["packetIdnList"]=packetIdnList;
                    methodParam["prefix"] = prefix;
                    getPacketDetails(tpoolconn,methodParam,function(error,getPktDtl){
                        if(error){
                            outJson["result"]=resultFinal;
                            outJson["status"]="FAIL";
                            outJson["message"]="Error In getPacketDetails Method!";
                            callback(null,outJson);
                        }else{
                            let pktDetails = {};
                            let attrDisplayDtl = [];
                            let statusList = [];
                            if(getPktDtl.status == "SUCCESS"){
                                pktDetails=getPktDtl.result || {};
                                let stockIdnList = getPktDtl.stockIdnList || [];
                                //console.log(stockIdnList)
                                attrDisplayDtl = getPktDtl.attrDisplayDtl;
        
                                methodParam={};
                                methodParam["coIdn"]=coIdn;   
                                methodParam["pktDetails"]=pktDetails;
                                methodParam["attrDisplayDtl"]=attrDisplayDtl;
                                methodParam["attrDisplayType"]=getPktDtl.attrDisplayType;
                                methodParam["attrDtl"]=resultView;
                                methodParam["packetIdnList"]=stockIdnList;
                                methodParam["packetDtl"]=packetDtl;
                                methodParam["buyerDetails"]=buyerDetails;
                                methodParam["imageDtl"]=imageDtl;
                                methodParam["clientkey"]=clientkey;
                                methodParam["header"]=header;
                                methodParam["total"]=total;
                                methodParam["source"]=source;
                                saveExcel(tpoolconn,methodParam,function(error,excelDetails){
                                    if(error){
                                        console.log(error);
                                        outJson["result"]='';
                                        outJson["status"]="FAIL";
                                        outJson["message"]="Fail To Download Excel!";
                                        callback(null,outJson);
                                    }else{
                                        if(mailSend == 'Y'){
                                            var fileName = "";
                                            //console.log(excelDetails);
                                            if(excelDetails.status == 'SUCCESS')
                                                fileName =excelDetails.result; 
                                                
                                                methodParam["formatNme"]="MAIL_EXCL";
                                                methodParam["coIdn"]=coIdn;
                                                methodParam["buyer"]=buyerDetails.buyer;
                                                methodParam["filename"]=fileName;
                                                methodParam["source"]=source;
                                                methodParam["byridn"]=buyerDetails.byridn;
                                                methodParam["empidn"]=buyerDetails.empidn;
                                                methodParam["subject"]=subject; 
                                                methodParam["cc"]=cc; 
                                                methodParam["bcc"]=bcc; 
                                                methodParam["emailIds"]=emailIds; 
                                                methodParam["message"]=message;
                                                methodParam["prefix"] = prefix;
                                                //console.log("mailSend");
                                                coreUtil.sendExcelMail(tpoolconn,methodParam).then(mailDetails =>{
                                                    mailDetails["downloadExcelCount"]=packetIdnList.length;
                                                    callback(null,mailDetails);
                                                })  
                                        }else{
                                            callback(null,excelDetails);
                                        } 
                                    }
                                })       
                            }   
                        }
                    })
                }
            })
        })
    }else if(packetIdnList ==''){
        outJson["result"]=resultFinal;
        outJson["status"]="FAIL";
        outJson["message"]="Please Verify packetIdnList Can not be blank!";
        callback(null,outJson);
    }else if(packetDtl ==''){
        outJson["result"]=resultFinal;
        outJson["status"]="FAIL";
        outJson["message"]="Please Verify packetDtl Can not be blank!";
        callback(null,outJson);
    }
}

function saveExcel(connection,paramJson,callback){
    var coIdn = paramJson.coIdn || '';
    var pktDetails = paramJson.pktDetails || '';
    var attrDisplayDtl = paramJson.attrDisplayDtl || '';
    var attrDtl = paramJson.attrDtl;
    let packetIdnList =paramJson.packetIdnList;
    let attrDisplayType = paramJson.attrDisplayType;
    let packetDtl =paramJson.packetDtl;
    let buyerDetails =paramJson.buyerDetails;
    let imageDtl = paramJson.imageDtl;
    let clientkey =paramJson.clientkey;
    let header = paramJson.header;
    let total =paramJson.total;
    var source = paramJson.source;
    var outJson = {};
    var now = new Date();
    var dte=dateFormat(now, "ddmmmyyyydh.MM.ss");
   // console.log(attrDtl);
    var workbook = new excel.Workbook();
    var certImageUrl = "http://d6z2uq3gvx7kk.cloudfront.net/Images/";
    var dnaUrl="https://kapugems.com/kweb/#/dna/";
   
    var worksheet = workbook.addWorksheet('Sheet 1');
    var style = workbook.createStyle({
        font: {
            color: '00000000',
            bold: true,
            name: 'Calibri',
            size: 12
        },
        fill: {
            type: 'pattern',
            patternType: 'solid',
            bgColor: '#ccc4d4',
            fgColor: '#ccc4d4',
          },
          alignment: {
            wrapText: true,
            horizontal: 'center',
            readingOrder:'contextDependent'
          }     
    });
    var style1 = workbook.createStyle({
        font: {
            color: '00000000',
            bold: true,
            name: 'Calibri',
            size: 12
        },
        fill: {
            type: 'pattern',
            patternType: 'solid',
            fgColor: '#ccc4d4',
          },
          alignment: {
            wrapText: true,
            horizontal: 'center',
          }      
    });
    var style2 = workbook.createStyle({
        font: {
            color: '00000000',
            name: 'Calibri',
            size: 11
        },
          alignment: {
            wrapText: false,
            horizontal: 'center',
          },
             
    });

    var style3 = workbook.createStyle({
        font: {
            color: '00000000',
            bold: true,
            name: 'Calibri',
            size: 11
        },
        fill: {
            type: 'pattern',
            patternType: 'solid',
            fgColor: '#ccc4d4'
          },
          alignment: {
            wrapText: false,
            horizontal: 'center',
            vertical: 'center'
          },  
          border: { // §18.8.4 border (Border)
            left: {
                style: 'thin', //§18.18.3 ST_BorderStyle (Border Line Styles) ['none', 'thin', 'medium', 'dashed', 'dotted', 'thick', 'double', 'hair', 'mediumDashed', 'dashDot', 'mediumDashDot', 'dashDotDot', 'mediumDashDotDot', 'slantDashDot']
                color: '00000000' // HTML style hex value
            },
            right: {
                style: 'thin',
                color: '00000000'
            },
            top: {
                style: 'thin',
                color: '00000000'
            },
            bottom: {
                style: 'thin',
                color: '00000000'
            }
        }    
    });


    var headerVals = 1;
 
    if((total == 'Y' || total == 'y') && header == 'N')
        headerVals = 5;

    if(header == 'Y' || header == 'y'){
        headerVals = 9;

        worksheet.addImage({
            path: './images/KG1.jpg',
            type: 'picture',
            position: {
              type: 'twoCellAnchor',
              from: {
                col: 1,
                colOff: 0,
                row: 1,
                rowOff: 0,
              },
              to: {
                col: 3,
                colOff: 0,
                row: 7,
                rowOff: 0,
              },
            },
          });
       
        worksheet.cell(1, 5, 1, 7 , true).string('Company Name').style(style1);
        worksheet.cell(1, 8, 1, 11, true).string(buyerDetails.buyer||'').style(style2);
        worksheet.cell(2, 5, 2, 7 , true).string('Email Id').style(style1);
        worksheet.cell(2, 8, 2, 11, true).string(buyerDetails.email||'').style(style2);
        worksheet.cell(3, 5, 3, 7 , true).string('Terms').style(style1);
        worksheet.cell(3, 8, 3, 11, true).string(buyerDetails.terms  || '').style(style2);
    
        worksheet.cell(1, 12, 1, 15 , true).string('Loyalty Level').style(style1);
        worksheet.cell(1, 16, 1, 17, true).string(buyerDetails.loy_ctg||'').style(style2);
        worksheet.cell(2, 12, 2, 15 , true).string('Last 365 Days Purchase').style(style1);
        worksheet.cell(2, 16, 2, 17, true).string(buyerDetails.sale_365||'').style(style2);
        worksheet.cell(3, 12, 3, 15 , true).string('Min Buy To Loyalty Upgrade').style(style1);
        worksheet.cell(3, 16, 3, 17, true).string(buyerDetails.ldiff||'').style(style2);
    }  

    let rowcol = excel.getExcelRowCol('CZ1');
    var row = rowcol['row'];
    var col = rowcol['col'];
    worksheet.cell(row, col).number(parseFloat(buyerDetails.xrte) || 1);

    var rowVals = headerVals + 1;

    worksheet.cell(headerVals,1).string('Sr No').style(style);

    var cnt = 0;
    var columnmList={};
    let columnD = {};
    for(var i=0;i<attrDtl.length;i++){
        var attr = attrDtl[i];
        var attrDs = attrDisplayDtl[attr]||'';
        var vals = 2+cnt;

        if(attr == 'crtwt' || attr == 'rap_rte' || attr == 'quot' || attr == 'quot_dis' || attr == 'quot_amount'){
           var attrd= excel.getExcelAlpha(vals);
           columnD[attr]=attrd;
        }
         
        worksheet.cell(headerVals,vals).string(attrDs).style(style);
        let maxLen = attrDs.toString().length+3;
        columnmList[vals]=parseInt(maxLen);
        if(attr == 'lab'){
            cnt++;
            vals = 2+cnt;
            worksheet.cell(headerVals,vals).string('View DNA').style(style);
            columnmList[vals]=10;
        }
        if(attr=='rap_rte'){
            cnt++;
            vals = 2+cnt;
            worksheet.cell(headerVals,vals).string('RAP Vlu').style(style);
            columnmList[vals]=10;
            columnD['rap_vlu']= excel.getExcelAlpha(vals);
        }
        cnt++;
    }

    for(var i=0;i<packetIdnList.length;i++){
        var packetIdn = packetIdnList[i];
        var pktDtl = packetDtl[packetIdn];
        var pktDtls = pktDetails[packetIdn];
        var sr = i+1;
        worksheet.cell(rowVals,1).number(sr).style(style2);
        var cert = certImageUrl+""+pktDtls['cert_image'];
        var dna = dnaUrl+""+packetIdn+"?key="+clientkey;
        var cnts=0;
        for(var k=0;k<attrDtl.length;k++){
            var attr = attrDtl[k];
            var dataTyp = attrDisplayType[attr]||'t';
            var vals = 2+cnts;
            var attrVal =coreUtil.nvl(pktDtls[attr],'')||'';
            if(attr == 'quot' || attr == 'quot_dis' || attr == 'quot_amount'){
                attrVal =coreUtil.nvl(pktDtl[attr],'')||'';
            }
            if(attrVal=='NA')
            attrVal='';
            
            if(attr == 'lab'){
                worksheet.cell(rowVals,vals).link(cert,attrVal).style(style2);
                cnts++;
                vals = 2+cnts;
                worksheet.cell(rowVals,vals).link(dna,"DNA").style(style2);
            }else{
                if(dataTyp!='n' && dataTyp!='f')
                worksheet.cell(rowVals,vals).string(attrVal).style(style2);
                else{
                if(attrVal=='')
                worksheet.cell(rowVals,vals).string(attrVal).style(style2);
                else
                worksheet.cell(rowVals,vals).number(parseFloat(attrVal)).style(style2);    
                }
            }
            if(attrVal != ''){
                let curLent = columnmList[vals]||'';
                let colmaxLen = parseInt(attrVal.toString().length+3);
                let maxLen =  Math.max(curLent, colmaxLen);

                
                columnmList[vals]=maxLen;
            }
            if(attr == 'rap_rte'){
                attrVal =coreUtil.nvl(pktDtls['rap_vlu'],'')||'';
                cnts++;
                vals = 2+cnts;
                if(attrVal=='')
                worksheet.cell(rowVals,vals).string(attrVal).style(style2);
                else
                worksheet.cell(rowVals,vals).number(parseFloat(attrVal)).style(style2);

                let curLent = columnmList['rap_vlu']||'';
                let colmaxLen = parseInt(attrVal.toString().length+3);
                let maxLen =  Math.max(curLent, colmaxLen);
              
                columnmList[vals]=maxLen;
            }
            cnts++;
        }
        rowVals++;       
    }

    let totalPcs = packetIdnList.length;
    let start = headerVals+1;
    let end = headerVals+totalPcs;

    if(total == 'Y' || total == 'y'){
        worksheet.row(headerVals).filter();
        var startRow = 5;
        var startCol = 5;
        if(header == 'N'){
            startRow = 1;
            startCol = 3;
        }
            

        worksheet.cell(startRow, startCol, startRow, (startCol+1), true).string('').style(style3);
        worksheet.cell(startRow, (startCol+2), startRow, (startCol+2) , true).string('Pcs').style(style3);
        worksheet.cell(startRow, (startCol+3), startRow, (startCol+3) , true).string('Carat').style(style3);
        worksheet.cell(startRow, (startCol+4), startRow, (startCol+5) , true).string('Pr/Crt').style(style3);
        worksheet.cell(startRow, (startCol+6), startRow, (startCol+7) , true).string('Rap(%)').style(style3);
        worksheet.cell(startRow, (startCol+8), startRow, (startCol+9) , true).string('Amount').style(style3);
        worksheet.cell(startRow, (startCol+10), startRow, (startCol+11) , true).string('Rap vlu').style(style3);

        worksheet.cell((startRow+1), startCol, (startRow+1), (startCol+1) , true).string('Grand Total').style(style3);
        worksheet.cell((startRow+1), (startCol+2), (startRow+1), (startCol+2) , true).formula('count(A'+start+' : A'+end+')').style(style3);
        worksheet.cell((startRow+1), (startCol+3), (startRow+1), (startCol+3), true).formula('round(sum('+columnD['crtwt']+''+start+' : '+columnD['crtwt']+''+end+'),2)').style(style3);
        worksheet.cell((startRow+1), (startCol+4), (startRow+1), (startCol+5) , true).formula("round((SUM("+columnD['quot_amount']+start+":"+columnD['quot_amount']+end+"))/(SUM("+columnD['crtwt']+start+":"+columnD['crtwt']+end+")),2)").style(style3);
        worksheet.cell((startRow+1), (startCol+6), (startRow+1), (startCol+7) , true).formula('round(SUM(((SUM('+columnD['quot_amount']+start+":"+columnD['quot_amount']+end+'))/(SUM('+columnD['rap_vlu']+start+':'+columnD['rap_vlu']+end+'))/(CZ1))*100)-100,2)').style(style3);
        worksheet.cell((startRow+1), (startCol+8), (startRow+1), (startCol+9) , true).formula('sum('+columnD['quot_amount']+''+start+' : '+columnD['quot_amount']+''+end+')').style(style3);
        worksheet.cell((startRow+1), (startCol+10), (startRow+1), (startCol+11) , true).formula('sum('+columnD['rap_vlu']+''+start+' : '+columnD['rap_vlu']+''+end+')').style(style3);
        
        worksheet.cell((startRow+2), startCol, (startRow+2), (startCol+1) , true).string('Sub Total').style(style3);
        worksheet.cell((startRow+2), (startCol+2), (startRow+2), (startCol+2) , true).formula('subtotal(2, A'+start+' : A'+end+')').style(style3);
        worksheet.cell((startRow+2), (startCol+3), (startRow+2), (startCol+3) , true).formula('round(subtotal(9, '+columnD['crtwt']+''+start+' : '+columnD['crtwt']+''+end+'),2)').style(style3);
        worksheet.cell((startRow+2), (startCol+4), (startRow+2), (startCol+5) , true).formula("round((subtotal(9,"+columnD['quot_amount']+start+":"+columnD['quot_amount']+end+"))/(subtotal(9,"+columnD['crtwt']+start+":"+columnD['crtwt']+end+")),2)").style(style3);
        worksheet.cell((startRow+2), (startCol+6), (startRow+2), (startCol+7), true).formula("round(SUM(((SUBTOTAL(9,"+columnD['quot_amount']+start+":"+columnD['quot_amount']+end+"))/(SUBTOTAL(9,"+columnD['rap_vlu']+start+":"+columnD['rap_vlu']+end+"))/(CZ1))*100)-100,2)").style(style3);
        worksheet.cell((startRow+2), (startCol+8), (startRow+2), (startCol+9) , true).formula('subtotal(9, '+columnD['quot_amount']+''+start+' : '+columnD['quot_amount']+''+end+')').style(style3);
        worksheet.cell((startRow+2), (startCol+10), (startRow+2), (startCol+11) , true).formula('subtotal(9, '+columnD['rap_vlu']+''+start+' : '+columnD['rap_vlu']+''+end+')').style(style3);
    }
    
    var colLst=Object.keys(columnmList) ;
    worksheet.column(1).setWidth(10);
    for(let i=0;i < colLst.length;i++){
           var col = parseInt(colLst[i]);
           var maxWd = columnmList[col]||10;
              worksheet.column(col).setWidth(maxWd);
    }
    worksheet.column(2).freeze();
    worksheet.row(headerVals).freeze();
    
    workbook.write('files/report_'+dte+'.xlsx');

    outJson["result"]='report_'+dte+'.xlsx';
    outJson["status"]="SUCCESS";
    outJson["message"]="Excel Saved Successfully!";
    outJson["downloadExcelCount"]=totalPcs;
    callback(null,outJson);
}

function getBuyerDetails(connection,paramJson,callback) {
    var usrIdn = paramJson.userIdn;
    var coIdn = paramJson.coIdn;
    var nmeIdn = paramJson.nmeIdn
    let outJson = {};
    var map = {};

    let fmt = {};
    let params=[];
    var sql="select initcap(trim(coalesce(nm.nme,'')||' / '||coalesce(nm.person_nme,''))) buyer, "+
            "nm.nme_idn byridn,nm.emp_idn empidn, "+
            "nm.attr ->> 'email' email,b.print terms, "+
            "d.xrte "+
            "from buyer_terms a,terms_m b,nme_m nm,gen_currency c,currency_xrt d "+
            "where a.terms_idn =b.terms_idn  "+
            "and a.nme_idn=nm.nme_idn "+
            "and a.currency_idn=c.currency_idn and c.currency_idn=d.currency_idn "+
            "and $1 =any(a.user_idn) "+
            "and a.status='cnf'		"+
            "and a.stt=1 and b.stt=1 and c.stt=1 and nm.stt=1 "+
            "and d.stt = 1 and b.co_idn=$2  and d.co_idn=$3 "+
            "and nm.nme_idn = $4 and b.co_idn = nm.co_idn ";
    params.push(usrIdn);
    params.push(coIdn);
    params.push(coIdn);
    params.push(nmeIdn);
    //console.log(sql);
   /// console.log(params);
    coreDB.executeTransSql(connection,sql,params,fmt,function(error,result){
        if(error){
            outJson["status"]="FAIL";
            outJson["message"]="Error In getBuyerDetails Method!";
            callback(null,outJson);
        }else{
            var len=result.rows.length;
            if(len>0){
                map = result.rows[0];
                var exh_rte = map.xrte;
                fmt = {};
                params=[];
                params = [nmeIdn,0,exh_rte];
                sql = "select g.finalvlu,g.loyaltyctg, g.loyaltypct, g.ldiff,g.lmemberdiscount,g.totalvalue from get_loyalty_dtls_vlu($1, $2, $3) g\n" ;

               // console.log(sql);
               //  console.log(params);
                coreDB.executeTransSql(connection,sql,params,fmt,function(error,result){
                    if(error){
                        outJson["status"]="FAIL";
                        outJson["message"]="Error In getLoyaltyDetails Method of getBuyerDetails!";
                        callback(null,outJson);
                    }else{
                        var len=result.rows.length;
                        map["ldiff"] = result.rows[0].ldiff;
                        map["loy_ctg"] = result.rows[0].loyaltyctg;
                        map["sale_365"] = result.rows[0].totalvalue;
                       // console.log(map);
                        outJson["status"]="SUCCESS";
                        outJson["message"]="SUCCESS";
                        outJson["result"]=map;
                        callback(null,outJson);                                            
                    }
                });
            }else{
                outJson["status"]="FAIL";
                outJson["message"]="Buyer data not found";
                outJson["result"]=map;
                callback(null,outJson);
            }
           
        }
    })     
}

function getPacketDetails(connection,paramJson,callback) {
    var coIdn = paramJson.coIdn;
    let resultView = paramJson.resultView;
    let source = paramJson.source;
    let packetIdnList = paramJson.packetIdnList; 
    let prefix = paramJson.prefix || '';
    let outJson = {};
    var map = {};
    let resultViewlen=resultView.length;
    let dataTypeFormatDtl={};
    let attrDisplayDtl={};
    let attrDisplayType={};
    let formulaAttr=[];
    var cachedUrl = require('qaq-core-util').cachedUrl;
    coreUtil.getCache(prefix+"productAttributeM_"+coIdn,cachedUrl).then(productAttributeM =>{
        if(productAttributeM == null){
            outJson["status"]="FAIL";
            outJson["message"]="Fail to get Product Attribute";
            callback(null,outJson);
        }else{
            productAttributeM = JSON.parse(productAttributeM);
    
            for(let j=0;j<resultViewlen;j++){
                let attr=resultView[j];
                let data_typ=productAttributeM[attr+"#T"] || '';
                let display=productAttributeM[attr+"#DS"] || '';
                let web=productAttributeM[attr+"#W"] || '';
                let format=productAttributeM[attr+"#F"] || '';
                let formula=productAttributeM[attr+"#FL"] || '';
                dataTypeFormatDtl[attr]=data_typ;
                dataTypeFormatDtl[attr+"#F"]=format;
                dataTypeFormatDtl[attr+"#FL"]=formula;
                if(data_typ=='f'){
                    formulaAttr.push(attr);
                    if(formula!='')
                    dataTypeFormatDtl[attr+"#FL#ATTR"]=coreUtil.getDependAttrList(formula);
                }
                attrDisplayDtl[attr]=display;
                attrDisplayType[attr]=data_typ;
                // if(source=='qsol' || source=='qs')
                // attrDisplayDtl[attr]=display;
                // else
                // attrDisplayDtl[attr]=web;
            }
    
            outJson["attrDisplayDtl"]=attrDisplayDtl;
            outJson["attrDisplayType"]=attrDisplayType;
            coreUtil.getCache(prefix+"productAttributeDtl_"+coIdn,cachedUrl).then(productAttributeDtl =>{
                if(productAttributeDtl == null){
                    outJson["status"]="FAIL";
                    outJson["message"]="Fail to get Product Sub Attribute";
                    callback(null,outJson);
                }else{
                    productAttributeDtl = JSON.parse(productAttributeDtl);

                    let fmt = {};
                    let params=[];

                    var sql="select stock_idn,pkt_code,stock_type,attr ->> 'certno' certno,attr ->> 'cert_image' cert_image ";
                      
                    for (let i = 0; i < resultViewlen; i++){
                        let attr= resultView[i];
                        if (attr == 'crtwt')
                            sql += ", trunc(CAST(attr ->> 'crtwt' as Numeric),2)  " + attr;
                        else
                            sql+=", attr ->> '"+attr+"' "+attr;
                    }
                    sql+=" from stock_m  where  "+
                        "co_idn=$1 and stt=1 and stock_idn = ANY(ARRAY["+packetIdnList.join(",")+"]) order by sort";
                  
                    params.push(coIdn);

                   // console.log(sql);
                   // console.log(params);
                    coreDB.executeTransSql(connection,sql,params,fmt,function(error,result){
                        if(error){
                            outJson["status"]="FAIL";
                            outJson["message"]="Error In getPacketDetails Method!";
                            callback(null,outJson);
                        }else{
                            var len=result.rows.length;
                            var statusList = [];
                            if(len>0){
                                var prvPacketStatus = '';
                                var dataMap = [];
                                var stockIdnList = [];
                                for(let i =0 ;i<len;i++){                                   
                                    let data = result.rows[i];   
                                    var k = {};
                                    k["packet"]=data.pkt_code;
                                    k["certno"]=data.certno;   
                                    k["cert_image"]=data.cert_image;                         
                                    let stock_type=data.stock_type;
                                    stockIdnList.push(data.stock_idn);
                                    for(let j=0;j<resultViewlen;j++){
                                        let attr=resultView[j];
                                        let data_typ=dataTypeFormatDtl[attr] || '';
                                        let attrVal=data[attr];
                                        if(data_typ=='c' && attrVal!='' && attrVal!=0){
                                        let prpSort=productAttributeDtl[attr+"#S"] || [];
                                        let prpDisplay=productAttributeDtl[attr+"#P"] || [];
                                        let prpWeb=productAttributeDtl[attr+"#W"] || [];
                                        if(source=='qsol' || source=='qs'){
                                        attrVal=prpDisplay[prpSort.indexOf(parseInt(attrVal))];
                                        }else{
                                        attrVal=prpWeb[prpSort.indexOf(parseInt(attrVal))];
                                        }
                                        }else if(data_typ=='d' && attrVal!='' && attrVal!=0){
                                        attrVal=coreUtil.getDateyyyymmddToExpected(attrVal,'dd-mmm-yyyy');
                                        }else if(data_typ=='n'&& attrVal!='' && attrVal!=0){
                                        let format=dataTypeFormatDtl[attr+"#F"] || 'N';
                                        if(format!='N'){
                                        if(stock_type!='NR' && attr=="crtwt"){
                                        format=3;
                                        }
                                        attrVal=attrVal || 0;
                                        attrVal=coreUtil.floorFigure(attrVal,format);
                                        }
                                        }
                                        k[attr]=attrVal;

                                        if(attr=="crtwt"){
                                            var rapRte=parseInt(data['rap_rte']);
                                            k["rap_vlu"]= rapRte * parseFloat(attrVal);
                                        }
                                            
                                    }
                                    map[data.stock_idn]=k;                                      
                                }
                                outJson["status"]="SUCCESS";
                                outJson["message"]="SUCCESS";
                                outJson["result"]=map;
                                outJson["stockIdnList"]=stockIdnList;
                                callback(null,outJson);
                            }else{
                                outJson["status"]="FAIL";
                                outJson["message"]="Sorry result not found";
                                outJson["result"]=map;
                                callback(null,outJson);
                            }
                        }
                    });  
                }
            })
        }
    })
}