var nodemailer = require('nodemailer');
var s3Manger = require('./s3.manger');
const coreDB = require('qaq-core-db');
var inlineBase64 = require('nodemailer-plugin-inline-base64');

exports.sendMail = function(mailOptions,callback){
 
    var SMTPHost=mailOptions["smtphost"];
    var SMTPUsr=mailOptions["smtpuser"];
    var SMTPPwd=mailOptions["smtppassword"];
    var SMTPPort=mailOptions["smtpport"];
    var issecure = mailOptions["secure"];
    let outJson = {};
    var  transporter = nodemailer.createTransport({
        host: SMTPHost,
         port:SMTPPort,
         secure:issecure,
         auth: {
             user: SMTPUsr,
             pass: SMTPPwd
         }
    });

    transporter.use('compile', inlineBase64());
    transporter.sendMail(mailOptions, function(error, info){
            if (error) {
              console.log("error",error);
              outJson["status"] = "FAIL";
              outJson["message"] = error;
              callback(null,outJson);
             } else {
              console.log("Success");
              outJson["status"] = "SUCCESS";
              callback(null,outJson);
             }
    })
}

exports.mailFormat = function(params,callback){
  var db = params.db ||'';
  var format =params.format;
  var coIdn = params.coIdn;
  var status="";
    var massage="";
   var subject="";
   var medium="";
   var body="";
    var attachment="";
    var recipient_list="";
    let format_idn = "";
  if(db!='' && format!='' && coIdn!=''){
    var sql='select format_idn,subj,medium,body,attachment,recipient_list from communication_format where nme=$1 and co_idn=$2 and stt=1 ';
       coreDB.executeTransSql(db,sql,[format,coIdn],{} , function(error,result){
        if(error){
         status="FAIL";
         massage="Error in query excution";
         }else{
          var rows = result.rows;
          if(rows.length==1){
            status="SUCCESS";
            massage="SUCCESS";
            subject=rows[0].subj;
            medium=rows[0].medium;
            body=rows[0].body;
            attachment=rows[0].attachment;
            recipient_list=rows[0].recipient_list;
            format_idn = rows[0].format_idn;
          }else{
            status="FAIL";
            massage="Sorry no result found.";
          }
         
        }

        var outjson ={
          "status":status,
          "massage":massage,
          "subject":subject,
          "medium":medium,
          "body":body,
          "attachment":attachment,
          "recipientlist":recipient_list,
          "format_idn":format_idn
          }
  
       return callback(null,outjson);
       });
  }
}




function fireMail(data,mailOptions){
  

}

 