var AWS = require('aws-sdk');
var s3 = new AWS.S3();

exports.readFile = function(params,callback){
   
    s3.getObject(params, function(error, data) {
        if (error){
            callback(error);
        } else{
            var json = JSON.parse(new Buffer(data.Body).toString("utf8"));
            callback(null,json);
        }
    });
}