const coreDB = require('qaq-core-db');
const coreUtil = require('qaq-core-util');
var memcached = require('./memcached');
var dateFormat = require('dateformat');
var replaceall = require("replaceall");
var async = require("async");
var ceil = require('math-ceil');
const crypto = require('crypto');
const algorithm = 'aes-256-cbc';
const ezkey  = process.env.EZ_INIT;
var replaceall = require("replaceall");

exports.formFieldDefination = function (params, callback) {
    var db = params.db || '';
    var coIdn = params.coIdn || '';
    var formName = params.formName || '';
    var userTyp = params.userCtg || 'USER';
    var colList = params.columnList;
    var columnDscList = params.columnDscList;
    var userIdn = params.userIdn || '';
    let orderByVal = params.orderByVal || '';
    let orderingAttr = 'itm_typ';
    //console.log(userIdn);
    var status = "";
    var massage = "";
    var outJson = {};
    var pvt = " a.pvt = 0 ";
    if (userTyp == 'SYS')
        pvt = " a.pvt >= 0 ";

    if (db != '' && coIdn != '' && formName != '') {
        var sql = "select a.itm_typ, a.is_hidden,b.title,a.page_item_idn," +
            "a.itm_location, a.is_database_columnn, a.form_field, a.form_field_icon, " +
            " a.form_field_title, a.table_name, a.table_field, a.field_alias, a.dta_typ, " +
            " a.form_field_typ, a.form_field_size, a.css_column_size, a.form_field_min_length, " +
            " a.form_field_max_length, a.is_compulsory, a.js_scripts, a.validations, " +
            " a.lov_qry, a.short_help, a.help,a.default_value, a.allow_block, a.column_key, a.column_value, a.field_css,a.user_allow_idn,a.user_block_idn " +
            " from page_item a,module_page b where a.page_idn = b.page_idn and b.page_nme=$1 and b.stt=$2 " +
            " and a.stt =$3 and " + pvt + " and COALESCE(co_idn,$4)=$5 " ;
            if(orderByVal == '')
                sql +=" order by a.itm_typ,a.srt ";
            else{
                sql +=" order by a."+orderByVal+" ,a.itm_typ,a.srt ";
                orderingAttr = orderByVal;
            }
                

            //console.log(sql);    
        coreDB.executeTransSql(db, sql, [formName, 1, 1, coIdn, coIdn], {}, function (error, result) {
            if (error) {

                outJson["result"] = '';
                outJson["status"] = "FAIL";
                outJson["massage"] = "Query excution Error " + error;
                return callback(null, outJson);
            } else {
                var rows = result.rows;
                var length = rows.length;
                var title = '';
                var pitm_typ = '';
                var dfMapList = [];
                var dfMap = {};

                for (var i = 0; i < length; i++) {
                    var row = rows[i];
                    var itm_typ = row[orderingAttr];
                    var dfltval = 1;
                    var user_allow_idn = [];
                    var user_block_idn = [];

                    title = row.title;
                    if (pitm_typ == '')
                        pitm_typ = itm_typ;

                    if (pitm_typ != itm_typ) {
                        dfMap[pitm_typ] = dfMapList;
                        dfMapList = [];
                        pitm_typ = itm_typ;
                    }
                    var dfField = {};
                    if (colList != null && colList.length > 0 && columnDscList != null && columnDscList.length > 0) {
                        for (var j = 0; j < colList.length; j++) {
                            var colNme = colList[j];

                            var colDsc = columnDscList[j];
                            dfField[colDsc] = row[colNme];

                        }

                    } else {
                        dfField["is_hidden"] = row.is_hidden;
                        dfField["itm_location"] = row.itm_location;
                        dfField["is_database_columnn"] = row.is_database_columnn;
                        dfField["form_field"] = row.form_field;
                        dfField["form_field_icon"] = row.form_field_icon;
                        dfField["form_field_title"] = row.form_field_title;
                        dfField["field_alias"] = row.field_alias;
                        dfField["dta_typ"] = row.dta_typ;
                        dfField["form_field_typ"] = row.form_field_typ;
                        dfField["form_field_size"] = row.form_field_size;
                        dfField["css_column_size"] = row.css_column_size;
                        dfField["form_field_min_length"] = row.form_field_min_length;
                        dfField["form_field_max_length"] = row.form_field_max_length;
                        dfField["is_compulsory"] = row.is_compulsory;
                        dfField["js_scripts"] = row.js_scripts;
                        dfField["validations"] = row.validations;
                        dfField["lov_qry"] = row.lov_qry;
                        dfField["short_help"] = row.short_help;
                        dfField["help"] = row.help;
                        dfltval = row.allow_block;
                        user_allow_idn = row.user_allow_idn || [];
                        user_block_idn = row.user_block_idn || [];
                        dfField["allow_block"] = dfltval;
                        dfField["default_value"]=row.default_value;
                        dfField["column_key"] = row.column_key;
                        dfField["column_value"] = row.column_value;
                        dfField["field_css"] = row.field_css;
                        dfField["page_item_idn"]=row.page_item_idn;
                    }
                    //dfMapList.push(dfField);
                    if(parseInt(dfltval) == 1 && userIdn !=''){
                        if(user_block_idn.indexOf(parseInt(userIdn)) >= 0){
                        }else
                            dfMapList.push(dfField);
                    } else if (parseInt(dfltval) == 0 && userIdn !=''){
                        if(user_allow_idn.indexOf(parseInt(userIdn)) >= 0)
                            dfMapList.push(dfField);
                    }else if(userIdn == ''){
                        dfMapList.push(dfField);
                    }

                    

                }
                if (pitm_typ != '') {
                    dfMap[pitm_typ] = dfMapList;
                }
                dfMap["title"] = title;
                outJson["result"] = JSON.stringify(dfMap);
                outJson["status"] = "SUCCESS";
                outJson["massage"] = "SUCCESS";
                return callback(null, outJson);


            }
        })
    } else {

        outJson["result"] = "";
        outJson["status"] = "FAIL";
        outJson["massage"] = "Form Defination parameters missing ";
        return callback(null, outJson);
    }

}

exports.pageDisplay = function (mparams, callback) {
    var db = mparams.db;
    var coIdn = mparams.coIdn || '';
    var formName = mparams.formName || '';
    var userTyp = mparams.userCtg || 'USER';
    var nme = mparams.nme || null;
    var display_key = mparams.display_key;
    var userIdn = mparams.userIdn || null;
    var group = mparams.group || 'N';
    var display_idn = mparams.display_idn || null;
    let dbmsDtldata = mparams.dbmsDtldata || null;
    let prefix = mparams.prefix || '';
    var cachedUrl = require('qaq-core-util').cachedUrl;

    var pvt = " a.pvt = 0 ";
    if (userTyp == 'SYS')
        pvt = " a.pvt >= 0 ";


    let fmt = {};
    let params = [];
    var outJson = {};
    //var sql = "with display_attr_v as(\n" +
    //    "with page_display_v as(\n" +
    //    "select display_idn from module_page a ,page_display b \n" +
    //    "where a.page_idn=b.page_idn and a.stt=1 and b.stt=1 \n" +
    //    "and a.form_nme=COALESCE(NULLIF(COALESCE(NULLIF($1 , ''), display_key), null), display_key)\n" +
    //    "and display_key=COALESCE(NULLIF(COALESCE(NULLIF($2, ''), display_key), null), display_key)\n" +
    //    "and nme=COALESCE(NULLIF(COALESCE(NULLIF($3, ''), nme), null), nme)\n" +
    //    "and display_idn=COALESCE(NULLIF(COALESCE(NULLIF($4, 0), display_idn), null), display_idn)\n" +
    //    ")\n" +
    //    "select b.attr,1,b.display_group,b.display_row from page_display_v a,page_display_attr b where a.display_idn=b.display_idn\n" +
    //    "and b.stt=1 and b.user_idn=$5 and b.co_idn=$6\n" +
    //    "union\n" +
    //    "select b.attr,2,b.display_group,b.display_row from page_display_v a,page_display_attr b where a.display_idn=b.display_idn\n" +
    //    "and b.stt=1 and b.user_idn is null and b.co_idn=$7\n" +
    //    "order by 2 LIMIT 1\n" +
    //    ")\n" +
    //    "select attr,display_group,display_row from display_attr_v";
    //params.push(formName);
    //params.push(display_key);
    //params.push(nme);
    //params.push(display_idn);
    //params.push(userIdn);
    //params.push(coIdn);
    //params.push(coIdn);

    var sql="";

    let conQ = "";
    if(nme != '' && nme != null)
        conQ+= "and p.nme = coalesce('"+nme+"', p.nme) ";

    if(display_idn != '' && display_idn != null)
        conQ+= "and p.display_idn = coalesce("+display_idn+", p.display_idn) ";


    if(userIdn!= '' && userIdn != null){
        sql=" with blck as (select unnest(block_attr) ba from appl_user where user_idn =$1 \n"+
            "union  \n"+
            "select attr ba from product_attr_m where $2 = any(co_allow) and client_settings->> '"+coIdn+"'= 'B'  \n"+
            "and pvt=0 and stt=1 \n"+
            "and attr not in (select unnest(allow_attr) aa from appl_user where user_idn = $3) \n"+
            ") \n"+
            ", pgblck as (select jsonb_array_elements(block_attr -> $4) ba from module_page where form_nme = coalesce($5, 'NN') ) \n"+
            "select array( \n"+
            "select a1.elem from ( \n"+
            "select a.elem, a.nr \n"+
            "from module_page m, page_display p, page_display_attr d, unnest(d.attr) WITH ORDINALITY a(elem, nr) \n"+
            "where m.page_idn = p.page_idn and p.display_idn = d.display_idn \n"+
            "and m.form_nme = coalesce($6, 'NN') and p.stt = 1 and d.stt = 1  \n"+
            "and p.display_key = coalesce($7, '') and d.co_idn = $8 \n"+
            "and coalesce(d.user_idn, $9) = $10  \n"+ conQ +
            ") a1 where 1 = 1  \n"+
            "and not exists (select 1 from blck where blck.ba = a1.elem) \n"+
            "and not exists (select 1 from pgblck where replace(pgblck.ba::text,'\"','') = a1.elem) \n"+
            "order by a1.nr) attr ";

            params.push(userIdn);
            params.push(coIdn);
            params.push(userIdn);
            params.push(userIdn);
            params.push(formName);
            params.push(formName);
            params.push(display_key);
            params.push(coIdn);
            params.push(userIdn);
            params.push(userIdn);

        }else {      
        sql="select a.attr "+
            ", a.display_group, a.display_row "+
            "from module_page m, page_display p, page_display_attr a "+
            "where m.page_idn = p.page_idn and p.display_idn = a.display_idn "+
            "and m.form_nme = coalesce($1, 'NN') "+
            "and p.stt = 1 and a.stt = 1 "+
            "and p.display_key = coalesce($2, '') "+
            "and a.co_idn = $3 "+ conQ 
            
            params.push(formName);
            params.push(display_key);
            params.push(coIdn);
    }
     
    //console.log(sql);
    //console.log(params);
    coreDB.executeTransSql(db, sql, params, fmt,async function (error, result) {
        if (error) {
            outJson["status"] = "FAIL";
            outJson["message"] = "Error In getDisplayAttr Method!";
            callback(null, outJson);
        } else {
            var len = result.rows.length;
            if (len > 0) {
                var attr = result.rows[0].attr || [];
                if (group == 'Y') {
                    let displaygrpResult = await execGetDisplayGrpRow(mparams);
                    if(displaygrpResult.status == 'SUCCESS'){
                        outJson["display_group"] = displaygrpResult.display_group || [];
                        outJson["display_row"] = displaygrpResult.display_row || [];
                        outJson["display_idn"] = displaygrpResult.display_idn || '';
                    }

                }
                if(dbmsDtldata == null)
                     dbmsDtldata = await coreUtil.getCache(prefix+"dbms_"+coIdn,cachedUrl);
                
                if(dbmsDtldata == null){
                        outJson["status"]="FAIL";
                        outJson["message"]="Fail to get DBMS Attribute";
                        callback(null,outJson);
                }else{ 
                    dbmsDtldata = JSON.parse(dbmsDtldata);
                    var show =  dbmsDtldata["show"] || 'OFF';
                    if(show == 'OFF'){
                        if(attr.indexOf("show_id")>-1)
                            attr.splice((attr.indexOf("show_id")), 1);
                    }
                    outJson["attr"] = attr;
                    outJson["status"] = "SUCCESS";
                    outJson["message"] = "SUCCESS";
                }
            } else {
                outJson["attr"] = [];
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
            }
            callback(null, outJson);
        }
    })
}

function execGetDisplayGrpRow(methodParam) {
    return new Promise(function (resolve, reject) {
        getDisplayGrpRow(methodParam,  function (error, result) {
            if (error) {
                reject(error);
            }
            resolve(result);
        });
    });
}

function getDisplayGrpRow( mparams, callback) {
    var coIdn = mparams.coIdn || '';
    var formName = mparams.formName || '';
    var nme = mparams.nme || null;
    var display_key = mparams.display_key;
    var userIdn = mparams.userIdn || null;
    var display_idn = mparams.display_idn || null;
    let db = mparams.db;

    let fmt = {};
    let params = [];
    var outJson = {};
    var sql="";

    let conQ = "";
    params.push(formName);
    params.push(display_key);
    params.push(coIdn);
    let cnt = 3;
    if(nme != '' && nme != null){
        cnt++;
        conQ+= "and p.nme = coalesce($"+cnt+", p.nme) ";
        params.push(nme);
    }
        

    if(display_idn != '' && display_idn != null){
        cnt++;
        conQ+= "and p.display_idn = coalesce($"+cnt+", p.display_idn) ";
        params.push(display_idn);
    }

    if(userIdn != '' && userIdn != null){
        cnt++;
        conQ+= " and coalesce(a.user_idn, $"+cnt+") = $"+cnt;
        params.push(userIdn);
    }
        

    sql="select  "+
        " a.display_group, a.display_row,a.display_idn "+
        "from module_page m, page_display p, page_display_attr a "+
        "where m.page_idn = p.page_idn and p.display_idn = a.display_idn "+
        "and m.form_nme = coalesce($1, 'NN') "+
        "and p.stt = 1 and a.stt = 1  "+
        "and p.display_key = coalesce($2, '') "+
        "and a.co_idn = $3 "+ conQ 
            
        
     
    //console.log(sql);
    //console.log(params);
    coreDB.executeTransSql(db, sql, params, fmt,async function (error, result) {
        if (error) {
            outJson["status"] = "FAIL";
            outJson["message"] = "Error In getDisplayGrpRow Method!";
            callback(null, outJson);
        } else {
            var len = result.rows.length;
            if (len > 0) {
                outJson["display_group"] = result.rows[0].display_group || [];
                outJson["display_row"] = result.rows[0].display_row || [];
                outJson["display_idn"] = result.rows[0].display_idn || '';
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
                callback(null, outJson);
            } else {
                outJson["display_group"]  = [];
                outJson["display_row"] = [];
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
                callback(null, outJson);
            }
        }
    })
}

exports.pageDisplayMdl = function (mparams, callback) {
    var db = mparams.db;
    var coIdn = mparams.coIdn || '';
    var nme = mparams.nme;



    let fmt = {};
    let params = [];
    var outJson = {};
    var sql = "select b.attr from page_display a,page_display_attr b where a.display_idn=b.display_idn " +
        " and b.stt=1 and b.user_idn is null and b.co_idn=$1 and a.nme=$2 ";

    params.push(coIdn);
    params.push(nme);


    coreDB.executeTransSql(db, sql, params, fmt, function (error, result) {
        if (error) {
            outJson["status"] = "FAIL";
            outJson["message"] = "Error In getDisplayAttr Method!";
            callback(null, outJson);
        } else {
            var len = result.rows.length;
            if (len > 0) {
                var attr = result.rows[0].attr || [];
                outJson["attr"] = attr;
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
            } else {
                outJson["attr"] = [];
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
            }
            callback(null, outJson);
        }
    });

}

exports.attrStructureDetails = function (params, cachedUrl, callback) {
    var coIdn = params.coIdn || '';
    var source = params.source || 'df';
     var isPri = params.isPri || 'N';
     let prefix = params.prefix || '';
    var viewList = params.viewList;
    var outJson = {};
    coreUtil.getCache(prefix+"productAttributeM_" + coIdn, cachedUrl).then(productAttributeM => {
        if (productAttributeM == null) {
            outJson["status"] = "FAIL";
            outJson["message"] = "Fail to get Product Attribute";
            callback(null, outJson);
        } else {
            productAttributeM = JSON.parse(productAttributeM);
            coreUtil.getCache(prefix+"productAttributeDtl_" + coIdn, cachedUrl).then(productAttributeDtl => {
                if (productAttributeDtl == null) {
                    outJson["status"] = "FAIL";
                    outJson["message"] = "Fail to get Product Sub Attribute";
                    callback(null, outJson);
                } else {
                    productAttributeDtl = JSON.parse(productAttributeDtl);
                    let attrList = [];
                    let attrDtl = {};
                    let prpList = [];
                    let prpDtl = {};
                    let searchViewlen = viewList.length;
                    for (let i = 0; i < searchViewlen; i++) {
                        attrDtl = {};
                        prpList = [];
                        let attr = viewList[i];
                        let data_typ = productAttributeM[attr + "#T"] || '';
                        let print = productAttributeM[attr] || ''
                        let display = productAttributeM[attr + "#DS"] || ''
                        let web = productAttributeM[attr + "#W"] || ''
                        attrDtl["attr"] = attr;
                        attrDtl["dataType"] = data_typ;

                        if (source == 'web' || source == 'mobile') {
                            attrDtl["print"] = web;
                        } else {
                            attrDtl["print"] = display;
                        }
                        if (data_typ == 'c') {
                            var prpVal = productAttributeDtl[attr + "#V"] || [];
                            var prpDscr = productAttributeDtl[attr + "#D"] || [];
                            var prpDisplay = productAttributeDtl[attr + "#DI"] || [];
                            var prpPrint = productAttributeDtl[attr + "#P"] || [];
                            var prpWeb = productAttributeDtl[attr + "#W"] || [];
                            var prpSort = productAttributeDtl[attr + "#S"] || [];
                            var prpWebYn = productAttributeDtl[attr + "#WYN"] || [];
                            var prpDfYn = productAttributeDtl[attr + "#DYN"] || [];
                            var prpPriYn = productAttributeDtl[attr + "#PYN"] || [];

                            let prpVallen = prpVal.length;
                            // console.log(prpDfYn);
                            for (let j = 0; j < prpVallen; j++) {
                                prpDtl = {}; prpDtl = {}; prpDtl = {};
                                prpDtl = {}; prpDtl = {}; prpDtl = {};
                                prpDtl["val"] = prpVal[j] || '';
                                let webyn = prpWebYn[j] || 0;
                                let dfyn = prpDfYn[j] || 0;
                                let priyn= prpPriYn[j] || 0;
                                if (source == 'web' || source == 'mobile') {
                                    prpDtl["print"] = prpWeb[j] || '';
                                } else {
                                    prpDtl["print"] = prpPrint[j] || '';
                                }
                                prpDtl["sort"] = prpSort[j] || '';
                                if(isPri=='Y'){
                                    if(priyn==1)
                                    prpList.push(prpDtl);

                                }else if(isPri=='A'){
                                    prpList.push(prpDtl);
                                }else if ((webyn == 1 && source == 'web') || (dfyn == 1 && source == 'qs') || (source != 'web' && source != 'qs'))
                                    prpList.push(prpDtl);
                         }
                            attrDtl["prpList"] = prpList;
                        }
                        attrList.push(attrDtl);
                    }
                    outJson["status"] = "SUCCESS";
                    outJson["message"] = "SUCCESS";
                    outJson["attrStructureDtl"] = attrList
                    callback(null, outJson);
                }
            })
        }
    })
}

exports.get_nme=function(methodParam,tpoolconn, callback){
    let nmeIdn = methodParam.nmeIdn;
    let fmt = {};
    let params = [];
    let outJson = {};
    let sql = "select get_nme(nme_idn) nme,COALESCE(attr->>'mobile',mbl) mbl from nme_m where nme_idn= $1 and stt =1 ";
    params.push(nmeIdn);
    coreDB.executeTransSql(tpoolconn, sql, params, fmt, function (error, result) {
        if (error) {
            outJson["name"] = "";
            outJson["mbl"] = "";
            callback(null, outJson);
        } else {
            let len = result.rows.length;
            if (len > 0) {
                outJson["name"] = result.rows[0].nme;
                outJson["mbl"] = result.rows[0].mbl;
            }else{
                outJson["name"] = "";
                outJson["mbl"] = "";
            }
            callback(null, outJson);

        }
     } );

}

exports.getExchangeRate =function (methodParam,tpoolconn, callback) {
    let buyerTermsIdn = methodParam.buyerTermsIdn;
    let coIdn = methodParam.coIdn;
    let outJson={};
   let sql ="select d.xrte from buyer_terms a,gen_currency c,currency_xrt d "+
          "  where a.currency_idn=c.currency_idn and c.currency_idn=d.currency_idn "+
         "  and a.stt=1 and c.stt=1 and d.stt=1  and a.buyer_terms_idn=$1 and d.co_idn= $2";
         coreDB.executeTransSql(tpoolconn, sql, [buyerTermsIdn,coIdn], {}, function (error, result) {
            if (error) {
                outJson["status"] = "FAIL";
                outJson["message"] = "Error In getExchangeRate Method!" + error.message;
                callback(null, outJson);
            } else {
                var len = result.rows.length;
                //console.log(result.rows[0])
                if (len > 0) {
                    outJson["xrte"] = result.rows[0].xrte;
                    outJson["status"] = "SUCCESS";
                    outJson["message"] = "SUCCESS";
                } else {
                    outJson["status"] = "FAIL";
                    outJson["message"] = "xrte not found";
                }
                callback(null, outJson);
            }
        });
}

exports.getCurrentExchangeRate =function (methodParam,tpoolconn, callback) {
    let coIdn = methodParam.coIdn;
    let currencyNme = methodParam.currencyNme || 'INR';
    let outJson={};

   let sql ="select get_xrt($1,$2) xrte";
    coreDB.executeTransSql(tpoolconn, sql, [coIdn,currencyNme], {}, function (error, result) {
        if (error) {
            outJson["status"] = "FAIL";
            outJson["message"] = "Error In getExchangeRate Method!" + error.message;
            callback(null, outJson);
        } else {
            var len = result.rows.length;
            //console.log(result.rows[0])
            if (len > 0) {
                outJson["xrte"] = result.rows[0].xrte;
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
            } else {
                outJson["status"] = "FAIL";
                outJson["message"] = "xrte not found";
            }
            callback(null, outJson);
        }
    });
}

exports.buyerBasicInfoSearch = function (methodParam, callback) {
    let buyerIdn = methodParam.buyerIdn;
    let buyerTermsIdn = methodParam.buyerTermsIdn || null;
    let empIdn = methodParam.empIdn;
    let coIdn = methodParam.coIdn;
    let userIdn = methodParam.userIdn || '';
    let tpoolconn = methodParam.db;
    let fmt = {};
    let params = [];
    let outJson = {};
    let info = {};
    let conQ = '';
    if (userIdn != '') {
        conQ = " , get_eml(nm.nme_idn,$5, 'default') userEmailId ";
    }
    let sql = "select initcap(trim(COALESCE(nm.nme,'')||' / '||COALESCE(nm.person_nme,''))) buyer, \n"+
    "nm.attr ->> 'email' email, get_eml(nm.nme_idn) emailId,nm.nme_idn byridn,COALESCE(nm.emp_idn,CAST(get_client_info($1,'dflt_emp_idn') AS Int)) empidn,\n" +
    "nm.attr ->> 'mobile' mobile,get_nme(COALESCE(nm.emp_idn,CAST(get_client_info($1,'dflt_emp_idn') AS Int))) employee \n" + conQ +
    ",a.buyer_terms_idn,b.terms_idn,b.term,to_char(COALESCE(a.ttl_trm_pct, 0), '90.0') ttl_trm_pct,c.description cur,c.notes, \n" +
    "COALESCE(ext_pct, 0) ext_pct,COALESCE(ext_dis, 0) ext_dis, \n" +
    "CASE aadat1_idn WHEN null THEN '' ELSE get_nme(aadat1_idn) END aadat1,COALESCE(aadat1_pct, 0) aadat1_pct, \n" +
    "CASE aadat2_idn WHEN null THEN '' ELSE get_nme(aadat2_idn) END aadat2,COALESCE(aadat2_pct, 0) aadat2_pct, \n" +
    "CASE brk1_idn WHEN null THEN '' ELSE get_nme(brk1_idn) END brk1,COALESCE(brk1_pct, 0) brk1_pct, \n" +
    "CASE brk2_idn WHEN null THEN '' ELSE get_nme(brk2_idn) END brk2,COALESCE(brk2_pct, 0) brk2_pct, \n" +
    "CASE brk3_idn WHEN null THEN '' ELSE get_nme(brk3_idn) END brk3,COALESCE(brk3_pct, 0) brk3_pct,d.xrte \n" +
    "from nme_m nm,buyer_terms a,terms_m b,gen_currency c,currency_xrt d \n" +
    "where nm.nme_idn=a.nme_idn and \n" +
    "a.terms_idn=b.terms_idn and a.currency_idn=c.currency_idn and c.currency_idn=d.currency_idn \n" +
    "and a.stt=1 and b.stt=1 and c.stt=1 and d.stt = 1 and nm.stt=1 and $1=any(co_allow) and b.co_idn=$2 and d.co_idn=$3 and lower(a.status)='cnf' \n" +
    "and a.buyer_terms_idn=COALESCE($4,a.buyer_terms_idn) and nm.co_idn = b.co_idn ";
    params = [];
    params.push(coIdn);
    params.push(coIdn);
    params.push(coIdn);
    params.push(buyerTermsIdn);

    if (userIdn != '') {
        sql = sql + " and $5=any(user_idn)";
        params.push(userIdn);
    }
    ///console.log(sql)
    //console.log(params)
    coreDB.executeTransSql(tpoolconn, sql, params, fmt, function (error, result) {
        if (error) {
            console.log(error);
            outJson["status"] = "FAIL";
            outJson["message"] = "Error In buyerBasicInfoSearch Method!" + error.message;
            callback(null, outJson);
        } else {
            var len = result.rows.length;
            //console.log(result.rows[0])
            if (len > 0) {
                outJson["info"] = result.rows[0];
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
            } else {
                outJson["status"] = "FAIL";
                outJson["message"] = "buyerBasicInfoSearch not found";
            }
            callback(null, outJson);
        }
    })
}

exports.buyerBasicInfoSearchWithoutTerms = function (methodParam, callback) {
    let coIdn = methodParam.coIdn;
    let userIdn = methodParam.userIdn || '';
    let tpoolconn = methodParam.db;
    let fmt = {};
    let params = [];
    let outJson = {};
    let info = {};
    let conQ = '';
    if (userIdn != '') {
        conQ = " , get_eml(nm.nme_idn,$2, 'default') userEmailId ";
    }
    let sql = "select initcap(trim(COALESCE(nm.nme,'')||' / '||COALESCE(nm.person_nme,''))) buyer, \n"+
    "nm.attr ->> 'email' email, get_eml(nm.nme_idn) emailId,nm.nme_idn byridn,nm.emp_idn empidn,\n" +
    "nm.attr ->> 'mobile' mobile,get_nme(nm.emp_idn) employee \n" + conQ +
    "from nme_m nm,appl_user a \n"+
    "where nm.nme_idn=a.nme_idn  \n"+
    "and a.stt=1 and  nm.stt=1  \n"+
    "and a.co_idn=$1 and nm.co_idn = a.co_idn  \n";	
   	
    params = [];
    params.push(coIdn);

    if (userIdn != '') {
        sql = sql + "  and a.user_idn = $2 ";
        params.push(userIdn);
    }
    ///console.log(sql)
    //console.log(params)
    coreDB.executeTransSql(tpoolconn, sql, params, fmt, function (error, result) {
        if (error) {
            console.log(error);
            outJson["status"] = "FAIL";
            outJson["message"] = "Error In buyerBasicInfoSearchWithoutTerms Method!" + error.message;
            callback(null, outJson);
        } else {
            var len = result.rows.length;
            //console.log(result.rows[0])
            if (len > 0) {
                outJson["info"] = result.rows[0];
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
            } else {
                outJson["status"] = "FAIL";
                outJson["message"] = "buyerBasicInfoSearchWithoutTerms not found";
            }
            callback(null, outJson);
        }
    })
}

exports.nmeAdtionalDetails = function (methodParam, callback) {
    let nmeIdn = methodParam.nme_idn || '';
    let tpoolconn = methodParam.db;
    let attrsList = methodParam.attrsList || '';
    let attrs = methodParam.attrs || '';
    var outJson = {};
    var attrSelectQ = '';
    var attrsSelectQ = '';
    if (attrsList != '') {
        for (let i = 0; i < attrsList.length; i++) {
            var attr = attrsList[i];
            if (attrSelectQ == '')
                attrSelectQ += "a.attr ->> '" + attr + "' " + attr + " ";
            else
                attrSelectQ += ",a.attr ->> '" + attr + "' " + attr + " ";

        }
    }
    if (attrs != '') {
        for (let i = 0; i < attrs.length; i++) {
            var attr = attrs[i];
            if(attrsSelectQ == '' &&  attrSelectQ == '')
                attrsSelectQ += attr;
            else
                attrsSelectQ += "," +attr;
        }
    }
    if(nmeIdn != ''){
        if(attrSelectQ != '' || attrsSelectQ != ''){
            sqlQ = "select get_nme(a.nme_idn) employee," + attrSelectQ + " \n " + attrsSelectQ +
                "  from\n" +
                "nme_m a \n" +
                "where a.stt=1 and nme_idn=$1";
            params = [];
            params.push(nmeIdn);
            //console.log(sqlQ)
            //console.log(params)
            coreDB.executeTransSql(tpoolconn, sqlQ, params, {}, function (error, result) {
                if (error) {
                    console.log(error)
                    outJson["status"] = "FAIL";
                    outJson["message"] = "Fail To Execute Query! " + error.message;
                    callback(null, outJson);
                } else {
                    var len = result.rows.length;
                    var dataDtl = {};
                    if (len != 0) {
                        for (var i = 0; i < len; i++) {
                            var resultRow = result.rows[i];
                            dataDtl["employee"]=resultRow.employee;
                            for (var z = 0; z < attrsList.length; z++) {
                                var attr = attrsList[z];
                                var attrVal = resultRow[attr] || '';
                                dataDtl[attr] = attrVal;
                            }
                            if (attrs != '') {
                                for (var z = 0; z < attrs.length; z++) {
                                    var attr = attrs[z];
                                    var attrVal = resultRow[attr] || '';
                                    dataDtl[attr] = attrVal;
                                }
                            }
                        }
                        outJson["dataDtl"] = dataDtl;
                        outJson["status"] = "SUCCESS";
                        outJson["message"] = "SUCCESS";
                        callback(null, outJson);
                    } else {
                        outJson["status"] = "SUCCESS";
                        outJson["message"] = "Sorry No Result Found";
                        callback(null, outJson);
                    }
                }
            })
    
        } else {
            outJson["status"] = "FAIL";
            outJson["message"] = "Attribute List empty";
            callback(null, outJson);
        }
    } else if(nmeIdn == '') {
        outJson["status"] = "FAIL";
        outJson["message"] = "User Basic Info(NmeIdn) can not be blank";
        callback(null, outJson);
    }  
}

exports.mapTypeWithProcess = function (methodParam, tpoolconn, callback) {
    let grp = methodParam.grp || '';
    let grpList = methodParam.grpList || [];
    let coIdn = methodParam.coIdn || '';
    let flg = methodParam.flg || 0;
    let processIdn = methodParam.processIdn || '';
    let outJson = {};
    let processDtl = {};
    let params = [coIdn];
    let fmt = {};
    if(grp!='')
    grpList.push(grp);

    let grpListLength = grpList.length;

    let query = "SELECT a.process_idn ,a.rt_status, a.nme,a.grp,a.print, config ->> 'flg' flg,config ->> 'srt' srt ," +
        " config ->> 'settings_idn' settings_idn,config ->> 'stt' stt, config ->> 'attr' attr, CASE config ->> 'attr' " +
        " WHEN 'start_date_time' THEN " +
        " CAST(FLOOR(EXTRACT(EPOCH from to_timestamp(config ->> 'val', 'yyyy-mm-dd HH24:mi:ss')) - EXTRACT(EPOCH from (current_timestamp + (interval '5 hours' + interval '30 minutes')) ))*1000 AS TEXT) " +
        " WHEN 'end_date_time' THEN " +
        " CAST(FLOOR(EXTRACT(EPOCH from to_timestamp(config ->> 'val', 'yyyy-mm-dd HH24:mi:ss')) - EXTRACT(EPOCH from (current_timestamp + (interval '5 hours' + interval '30 minutes'))))*1000 AS TEXT) " +
        " ELSE config ->> 'val' END val FROM stock_process a CROSS JOIN jsonb_array_elements(settings -> 'settingsDtl') config " +
        " where 1=1 and config ->> 'flg'='" + flg + "' and config ->> 'stt'='1' and a.stt=1 and co_idn=$1 ";
        
        if(grpListLength > 0)
            query += " and a.grp = ANY(ARRAY['" + grpList.join("','") + "']) ";
        
        if(processIdn != '')
            query += " and a.process_idn = "+processIdn ;

        query +=" order by a.process_idn ";

    //console.log(query);
    //console.log(params);
     
    coreDB.executeTransSql(tpoolconn, query, params, fmt, function (error, result) {
        if (error) {
            outJson["result"] = '';
            outJson["status"] = "FAIL";
            outJson["message"] = "Get mapTypeWithProcess Execute Query!" + error.message;
            callback(null, outJson);
        } else {
            let rowCount = result.rowCount;
            let pProcessIdn = '';
            let processDtl = {};
            let processMap = {};
            if (rowCount > 0) {
                for (let k = 0; k < rowCount; k++) {
                    let resultRow = result.rows[k];
                    let lprocessIdn = resultRow.process_idn;
                    if (pProcessIdn == '')
                        pProcessIdn = lprocessIdn;

                    if (pProcessIdn != lprocessIdn) {
                        let key = processDtl["key"] || '';
                        if (key != '') {

                            processMap[key] = processDtl;
                        }
                        processDtl = {};
                        pProcessIdn = lprocessIdn;
                    }
                    processDtl[resultRow.attr] = resultRow.val;
                    processDtl["process_idn"] = lprocessIdn;
                    processDtl["processNme"] = resultRow.nme;
                    processDtl["print"] = resultRow.print;
                    processDtl["grp"] = resultRow.grp;
                    processDtl["rt_status"] = resultRow.rt_status;
                }
                if (pProcessIdn != '') {
                    let key = processDtl["key"] || '';
                    if (key != '') {
                        processMap[key] = processDtl;
                    }
                }
                outJson["processDetails"] = processDtl;
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
            } else {
                outJson["status"] = "SUCCESS";
                outJson["message"] = "Process Not Available";
                callback(null, outJson);
            } 
            outJson["processDtl"] = processMap;
            callback(null, outJson);
        }
    });
}

exports.getProcessList = function (methodParam, tpoolconn, callback) {
    let applIdn = methodParam.applIdn || '';
    let pvtConfigure = methodParam.pvtConfigure || '';
    let coIdn = methodParam.coIdn || '';
    let group = methodParam.group || [];
    let in_statusYn = methodParam.in_statusYn || 'N';
    let groupingYN = methodParam.groupingYN || 'N';
    let processName = methodParam.processName || '';
    let processsubGrp = methodParam.processsubGrp || [];
    let outJson = {};
    let processDtlLst = [];
    let grouplength = group.length;

    if (applIdn != '' && pvtConfigure != '' && grouplength != 0) {
        let pvt = "pvt = 0";
        if (pvtConfigure == 'SYS')
            pvt = "pvt >= 0";

        let params = [];
        params.push(coIdn);
        let fmt = {};
        let query = "select a.grp,a.process_idn,a.print,in_status , a.nme " +
            "FROM stock_process a " +
            "where a.grp = ANY(ARRAY['" + group.join("','") + "']) and a.co_idn=$1 and a.stt = 1 " ;
        
        let cnt = 1;
        if(processName != '') {
            cnt++;
            query += " and a.nme = $"+cnt;
            params.push(processName);
        } 

        if(processsubGrp.length > 0) {
            query += " and  a.sub_group = ANY(ARRAY['" + processsubGrp.join("','") + "'])";
        }   

        if(groupingYN == 'Y')
            query += " order by a.grp, a.print,a.srt";
        else
            query += " order by a.print,a.srt";

         //console.log(query);
         //console.log(params);
        coreDB.executeTransSql(tpoolconn, query, params, fmt, function (error, result) {
            if (error) {
                console.log(error);
                outJson["result"] = '';
                outJson["status"] = "FAIL";
                outJson["message"] = "Get User List Fail To Execute Query!";
                callback(null, outJson);
            } else {
                let rowCount = result.rowCount;
                if (rowCount > 0) {
                    var prvGrp = '';
                    var processDtlLstGrp = [];
                    var map = {};
                    for (let k = 0; k < rowCount; k++) {
                        let processDtl = result.rows[k];
                        let grp = processDtl.grp;

                        if(prvGrp == '')
                            prvGrp = grp;

                        if(prvGrp != grp){
                            map[prvGrp] = processDtlLstGrp;
                            prvGrp = grp;
                            processDtlLstGrp = [];
                        }

                        let params = {};
                        params["process_idn"] = processDtl.process_idn;
                        params["print"] = processDtl.print;
                        params["name"] = processDtl.nme;
                        if (in_statusYn == 'Y')
                            params["in_status"] = processDtl.in_status || [];
                        processDtlLst.push(params);
                        processDtlLstGrp.push(params);
                    }
                    map[prvGrp] = processDtlLstGrp;

                    outJson["status"] = "SUCCESS";
                    outJson["message"] = "SUCCESS";
                } else {
                    outJson["status"] = "SUCCESS";
                    outJson["message"] = "Process Not Available";
                    callback(null, outJson);
                }
                outJson["processDtlLst"] = processDtlLst;
                outJson["processDtlLstGrp"] = map;
                callback(null, outJson);
            }
        });
    } else if (pvtConfigure == '') {
        outJson["result"] = '';
        outJson["status"] = "FAIL";
        outJson["message"] = "Please Verify pvtConfigure Parameter";
        callback(null, outJson);
    } else if (grouplength == 0) {
        outJson["result"] = '';
        outJson["status"] = "FAIL";
        outJson["message"] = "Please Verify Group Parameter";
        callback(null, outJson);
    } else if (applIdn == '') {
        outJson["result"] = '';
        outJson["status"] = "FAIL";
        outJson["message"] = "Please Verify Application Idn Parameter";
        callback(null, outJson);
    }
}

exports.updateTermsIdnSearchIdn = function (buyerTermsIdn, searchIdn, tpoolconn, callback) {
    let pgfmt = {};
    let pgparams = [];
    var outJson = {};
    var sql = "update stock_search set buyer_terms_idn=$1 where search_id=$2";
    pgparams.push(buyerTermsIdn);
    pgparams.push(searchIdn);
    // console.log(sql);
    // console.log(pgparams);
    coreDB.executeTransSql(tpoolconn, sql, pgparams, pgfmt, function (error, result) {
        if (error) {
            outJson["status"] = "FAIL";
            outJson["message"] = "Fail To Execute Query! " + error.message;
            callback(null, outJson);
        } else {
            //coreDB.doTransCommit(tpoolconn);
            var rowCount = result.rowCount;
            if (rowCount > 0) {
                outJson["message"] = "Search Idn Updated Sucessfully";
                outJson["status"] = "SUCCESS";
            } else {
                outJson["message"] = "Fail To Update Search Id!";
                outJson["status"] = "FAIL";
            }
            callback(null, outJson);
        }
    });
}

exports.getEmployeeList = function (dept, nmeIdn, coIdn, tpoolconn, callback) {
    let fmt = {};
    let params = [];
    let outJson = {};
    let kv = [];
    let map = {};
    map["k"] = "";
    map["v"] = "Sale Executive";
    kv.push(map);
    var sql = "select a.nme_idn,initcap(trim(a.nme)) nme from nme_m a where typ = 'employee' \n" +
        "and a.co_idn=$1 and a.stt=1";
    params.push(coIdn);
    if (dept == 'sales') {
        sql += " and a.nme_idn=$2";
        params.push(nmeIdn);
    } else {
        sql += " and a.attr ->> 'dept'='sales'";
    }
    sql += " order by initcap(trim(a.nme))";
    // console.log(sql);
    // console.log(params);
    coreDB.executeTransSql(tpoolconn, sql, params, fmt, function (error, result) {
        if (error) {
            outJson["status"] = "FAIL";
            outJson["message"] = "Error In getEmployeeList Method!";
            callback(null, outJson);
        } else {
            var len = result.rows.length;
            if (len > 0) {
                for (var i = 0; i < len; i++) {
                    map = {};
                    map["k"] = result.rows[i].nme_idn || "";
                    map["v"] = result.rows[i].nme || "";
                    kv.push(map);
                }
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
            } else {
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
            }
            outJson["employeeList"] = kv;
            callback(null, outJson);
        }
    });
}

exports.getGroupEmployeeList = function (methodParam, tpoolconn, callback) {
    let fmt = {};
    let params = [];
    let outJson = {};
    let kv = [];
    let map = {};
    map["k"] = "";
    map["v"] = "Sale Executive";
    kv.push(map);
    let dept = methodParam.dept;
    let groupEmpList = methodParam.groupEmpList||'';
    let coIdn = methodParam.coIdn;
    let formName = methodParam.formName || '';
    var sql = "select get_nme(a.nme_idn) employeenme,a.nme_idn,initcap(trim(a.nme)) nme from nme_m a where typ = 'employee' \n" +
        "and a.co_idn=$1 and a.stt=1";
    params.push(coIdn);
    if (dept == 'sales' && groupEmpList.length>0) {
        sql += " and a.nme_idn= ANY(ARRAY[" + groupEmpList.join(",") + "])";
    } 

    if (formName == 'stockSearchForm') {
        sql += " and a.attr->> 'dept' = 'sales' ";
    } 
    sql += " order by initcap(trim(a.nme))";
    // console.log(sql);
    // console.log(params);
    coreDB.executeTransSql(tpoolconn, sql, params, fmt, function (error, result) {
        if (error) {
            outJson["status"] = "FAIL";
            outJson["message"] = "Error In getEmployeeList Method!";
            callback(null, outJson);
        } else {
            var len = result.rows.length;
            //console.log(len)
            if (len > 0) {
                for (var i = 0; i < len; i++) {
                    map = {};
                    map["k"] = result.rows[i].nme_idn || "";
                    if(formName == 'analysisReportForm' || formName == 'mixAnalysisReportForm' || formName == 'inwardAnalysisReportForm' || formName == 'mixInwardAnalysisReportForm')
                    map["k"] = result.rows[i].employeenme || "";

                    map["v"] = result.rows[i].nme || "";
                    kv.push(map);
                }
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
            } else {
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
            }
            outJson["employeeList"] = kv;
            callback(null, outJson);
        }
    });
}

exports.getMaxSrt = function (tpoolconn, lov_qry, whereKeys, whereVlus, applIdn, co_idn, callback) {
    let srt = 10;
    var params = [];
    if (lov_qry.indexOf("#COIDN") > -1)
        lov_qry = replaceall("#COIDN", co_idn, lov_qry);
    if (lov_qry.indexOf("#APPIDN") > -1)
        lov_qry = replaceall('#APPIDN', applIdn, lov_qry);

    if (whereKeys != "" && whereVlus != "") {
        var wherekeysArr = whereKeys.split("~");
        var whereVlusArr = whereVlus.split("~");
        var wherekeysArrlen = wherekeysArr.length;
        var whereVlusArrlen = whereVlusArr.length;
        var conQ = "";
        if (wherekeysArrlen == whereVlusArrlen) {
            for (var i = 0; i < wherekeysArrlen; i++) {
                conQ += " and " + wherekeysArr[i] + "=$" + (i + 1);
                params.push(whereVlusArr[i]);
            }
            lov_qry = lov_qry.replace("#WHERE", conQ);
        } else {
            srt = -10;
        }
    }
    if (srt != -10 && lov_qry != '') {
        coreDB.executeTransSql(tpoolconn, lov_qry, params, {}, function (error, result) {
            if (error) {
                callback(null, srt);
            } else {
                var len = result.rows.length;
                if (len > 0) {
                    srt = result.rows[0].srt;
                }
                callback(null, srt);
            }
        });
    } else {
        callback(null, srt);
    }
};

exports.dropTempTable = function (tableName, tpoolconn, callback) {
    let outJson = {};
    let fmt = {};
    let params = [];
    let dropQ = "DROP TABLE IF EXISTS " + tableName;
    //console.log("dropQ",dropQ);
    coreDB.executeTransSql(tpoolconn, dropQ, params, fmt, function (error, result) {
        if (error) {
            outJson["status"] = "FAIL";
            outJson["message"] = "Fail To Update Query!" + error.message;
            console.log(outJson);
            callback(null, outJson);
        } else {
            outJson["status"] = "SUCCESS";
            outJson["message"] = "SUCCESS";
            //console.log(outJson);
            callback(null, outJson);
        }
    });
}

exports.CreateTempTable = function (tableName, tpoolconn, callback) {
    let outJson = {};
    let fmt = {};
    let params = [];
    let dropQ = "create temp table if not exists "+ tableName;
    coreDB.executeTransSql(tpoolconn, dropQ, params, fmt, function (error, result) {
        if (error) {
            outJson["status"] = "FAIL";
            outJson["message"] = "Fail To Update Query!" + error.message;
            console.log(outJson);
            callback(null, outJson);
        } else {
            outJson["status"] = "SUCCESS";
            outJson["message"] = "SUCCESS";
            //console.log(outJson);
            callback(null, outJson);
        }
    });
}

exports.DropCreateTempTableWithStructure = function (methodParam, tpoolconn, callback) {
    let outJson = {};
    let fmt = {};
    let params = [];
    let tableName = methodParam.tableName;
    let createReturnQ = "create temporary table IF NOT EXISTS temp_return_pkts  ( "+
        "process_idn bigint, "+
        "transaction_idn bigint, "+	
        "stock_idn bigint, "+
        "transStatus varchar(20), "+
        "stockStatus varchar(20), "+
        "nxtStatus varchar(20), "+
        "flg smallint, " +
        "remark text )";

    let createIssueReturnQ = "create temporary table IF NOT EXISTS temp_issuereturn_pkts  ( " +
            "stock_idn bigint, " +
            "pkt_code varchar(30),"+
            "transaction_qc_idn bigint, "+
            "qty smallint, " +
            "weight real, " +
            "stock_status varchar(20)," +
            "issval jsonb,"+
            "rtnval jsonb,"+
            "empval jsonb,"+
            "stt smallint,  " +
            "flg varchar(20), " +
            "remark text )";

    let createTransQcQ = "create temporary table IF NOT EXISTS temp_transaction_qc  ( " +
        "stock_idn bigint, " +
        "pkt_code varchar(30),"+
        "stt smallint )";  
    
    let createVerifiedQ = "create temporary table IF NOT EXISTS temp_verified_pkts  ( " +
        "stock_idn bigint, " +
        "qty smallint, " +
        "weight real, " +
        "rte numeric, "+
        "sal_rte numeric, "+
        "quot numeric, "+
        "quot_exh_rte numeric, "+
        "sal_exh_rte numeric, "+
        "stock_status varchar(20)," +
        "attr jsonb, "+
        "transStatus varchar(20), "+
        "flg smallint, " +
        "remarks varchar(30), "+
        "description varchar(50) "+
        " )";

    let createContactSearchQ = "create temporary table IF NOT EXISTS temp_contact_search  ( " +
        "nme_idn bigint, " +
        "stt smallint )";    


    let map = {};
    map["temp_return_pkts"]=createReturnQ;
    map["temp_issuereturn_pkts"]=createIssueReturnQ;
    map["temp_transaction_qc"]=createTransQcQ;
    map["temp_verified_pkts"]=createVerifiedQ;
    map["temp_contact_search"]=createContactSearchQ;

    let createQ = map[tableName];
    let dropQ = "DROP TABLE IF EXISTS " + tableName;
    coreDB.executeTransSql(tpoolconn, dropQ, params, fmt, function (error, result) {
        if (error) {
            outJson["status"] = "FAIL";
            outJson["message"] = "Fail To DROP Table!" + error.message;
            console.log(outJson);
            callback(null, outJson);
        } else {
            ///console.log(createQ)
            coreDB.executeTransSql(tpoolconn, createQ, params, fmt, function (error, result) {
                if (error) {
                    outJson["status"] = "FAIL";
                    outJson["message"] = "Fail To Create Temp Table Query!" + error.message;
                    //console.log(outJson);
                    callback(null, outJson);
                } else {
                    outJson["status"] = "SUCCESS";
                    outJson["message"] = "SUCCESS";
                    //console.log(outJson);
                    callback(null, outJson);
                }
            });
        }
    })
}

exports.getProcessDtl = function (methodParam, tpoolconn, callback) {
    let optionsYn = methodParam.optionsYn || '';
    let buyerTermsIdn = methodParam.buyerTermsIdn || '';

    let source = methodParam.source || '';
    let settingsYn = methodParam.settingsYn || '';
    let attrYn = methodParam.attrYn || '';
    let processIdn = methodParam.processIdn || '';
    let processNme = methodParam.processNme || '';
    let postIssue = methodParam.postIssue || 'pi';
    let prefix = methodParam.prefix || '';
    let outJson = {};
    var cachedUrl = require('qaq-core-util').cachedUrl;
    var applIdn = methodParam.applIdn || '';
    var coIdn = methodParam.coIdn || '';
 
    if(processIdn != '' || processNme != ''){
        //console.log("getProcessDtl");
        coreUtil.getCache(prefix+"productAttributeM_" + coIdn, cachedUrl).then(productAttributeM => {
            if (productAttributeM == null) {
                outJson["status"] = "FAIL";
                outJson["message"] = "Fail to get Product Attribute";
                callback(null, outJson);
            } else {
                productAttributeM = JSON.parse(productAttributeM);
                coreUtil.getCache(prefix+"productAttributeDtl_" + coIdn, cachedUrl).then(productAttributeDtl => {
                    if (productAttributeDtl == null) {
                        outJson["status"] = "FAIL";
                        outJson["message"] = "Fail to get Product Sub Attribute";
                        callback(null, outJson);
                    } else {
                        productAttributeDtl = JSON.parse(productAttributeDtl);
                        coreUtil.getCache(prefix+"attributeMasterDtl_" + coIdn, cachedUrl).then(attributeMasterDtl => {
                            if (attributeMasterDtl == null) {
                                outJson["status"] = "FAIL";
                                outJson["message"] = "Fail to get Application AttributeDtl";
                                callback(null, outJson);
                            } else {
                                attributeMasterDtl = JSON.parse(attributeMasterDtl);
                                coreUtil.getCache(prefix+"attributeMaster", cachedUrl).then(attributeMaster => {
                                    if (attributeMaster == null) {
                                        outJson["status"] = "FAIL";
                                        outJson["message"] = "Fail to get Application Attribute";
                                        callback(null, outJson);
                                    } else {
                                        attributeMaster = JSON.parse(attributeMaster);
                            
                                        let params = [];
                                        let fmt = {};
                                        params.push(coIdn);
                                        let conQ = " and process_idn=$2"
                                        if (processNme != '') {
                                            conQ = " and nme=$2";
                                            params.push(processNme);
                                        } else {
                                            params.push(processIdn);
                                        }
                                        let query = "select nme,mdl,process_idn,process_options,settings,process_attr,in_status,iss_status,out_status,grp from stock_process where co_idn=$1 and stt=1 " + conQ;
                                        //console.log(query);
                                        //console.log(params);
                                        coreDB.executeTransSql(tpoolconn, query, params, fmt, async function (error, result) {
                                            if (error) {
                                                outJson["result"] = '';
                                                outJson["status"] = "FAIL";
                                                outJson["message"] = "Get getProcessDtl To Execute Query!" + error.message;
                                                console.log(outJson);
                                                callback(null, outJson);
                                            } else {
                                                let rowCount = result.rowCount;
                                                if (rowCount > 0) {
                                                    let attrList = [];
                                                    let attrDtl = {};
                                                    let prpList = [];
                                                    let prpDtl = {};

                                                    for (let i = 0; i < rowCount; i++) {
                                                        let resultRow = result.rows[i];
                                                        let process_options = resultRow["process_options"];
                                                        let settings = resultRow["settings"];
                                                        let process_attr = resultRow["process_attr"];
                                                        outJson["process_idn"] = resultRow["process_idn"];
                                                        outJson["processName"] = resultRow["nme"];
                                                        outJson["processMdl"] = resultRow["mdl"];
                                                        outJson["in_status"] = resultRow["in_status"];
                                                        outJson["iss_status"] = resultRow["iss_status"];
                                                        outJson["out_status"] = resultRow["out_status"];
                                                        outJson["grp"] = resultRow["grp"];
                                                        //console.log(optionsYn);
                                                        if (optionsYn == 'y') {
                                                            attrList = [];
                                                            let process_optionsDtl = process_options["process_optionsDtl"] || [];
                                                            let process_optionsDtllength = process_optionsDtl.length;
                                                            for (let o = 0; o < process_optionsDtllength; o++) {
                                                                attrDtl = {};
                                                                let optionsDtl = process_optionsDtl[o];
                                                                let stt = optionsDtl.stt || 0;
                                                                let attr = optionsDtl.attr || '';
                                                                let flg = optionsDtl.flg || '';
                                                                let srt = parseInt(optionsDtl.srt || '10');
                                                                if (stt == 1 && postIssue != flg) {
                                                                    var data_typ = attributeMaster[attr + "#T"] || '';
                                                                    let display = attributeMaster[attr + "#DS"] || '';
                                                                    let web = attributeMaster[attr + "#W"] || '';
                                                                    attrDtl["attr"] = attr;
                                                                    attrDtl["dataType"] = data_typ;
                                                                    attrDtl["flg"] = flg;
                                                                    attrDtl["srt"] = srt;
                                                                    if (source != 'qsol' && source != 'qs') {
                                                                        attrDtl["print"] = web;
                                                                    } else {
                                                                        attrDtl["print"] = display;
                                                                    }
                                                                    if (data_typ == 'c' || data_typ == 'cm') {
                                                                        let prpVal = attributeMasterDtl[attr + "#V"] || [];
                                                                        let prpSort = attributeMasterDtl[attr + "#S"] || [];
                                                                        let prpDisplay = attributeMasterDtl[attr + "#DI"] || [];
                                                                        let prpWeb = attributeMasterDtl[attr + "#W"] || [];
                                                                        let lprpList = [];
                                                                        let prpVallen = prpVal.length;
                                                                        for (let j = 0; j < prpVallen; j++) {
                                                                            prpDtl = {};
                                                                            prpDtl["k"] = prpVal[j] || '';
                                                                            if (source != 'qsol' && source != 'qs') {
                                                                                prpDtl["v"] = prpWeb[j] || '';
                                                                            } else {
                                                                                prpDtl["v"] = prpDisplay[j] || '';
                                                                            }
                                                                            lprpList.push(prpDtl);
                                                                        }
                                                                        attrDtl["prpList"] = lprpList;
                                                                    }  else if (data_typ == 'q') {
                                                                        let prpDtl={};
                                                                        methodParam = {};
                                                                        methodParam["buyerTermsIdn"]=buyerTermsIdn;
                                                                    
                                                                        if(attr=='commission'){
                                                                        prpDtl = await getCommissiondtl(methodParam,tpoolconn);
                                                                        }else if(attr=='charges'){
                                                                            methodParam = {};
                                                                            methodParam["processIdn"]=resultRow["process_idn"];;
                                                                            prpDtl = await getChargesDetails(methodParam,tpoolconn);
                                                                        }else if(attr=='subcompany'){
                                                                            methodParam = {};
                                                                            methodParam["coIdn"]=coIdn;
                                                                            prpDtl = await getSubCompanyDetails(methodParam,tpoolconn);
                                                                        }
                                                                        
                                                                        else{
                                                                            let prpSql =attributeMaster[attr + "#DF"] || '';
                                                                            prpSql=prpSql.replace("#COIDN",coIdn);
                                                                            methodParam = {};
                                                                            methodParam["sql"]=prpSql;
                                                                            let paramLst =[];
                                                                            methodParam["params"]=paramLst
                                                                            //console.log("prpSql",prpSql);
                                                                            prpDtl= await executeQuery(methodParam,tpoolconn);
                                                                        }
                                                                        attrDtl["prpList"]=prpDtl;

                                                                    }
                                                                    attrList.push(attrDtl);
                                                                }
                                                                
                                                            }
                                                            attrList.sort((val1, val2) => {
                                                                return (val1.srt) - (val2.srt);
                                                            });
                                                            outJson["optionList"] = attrList;
                                                    
                                                        }
                                                        if (attrYn == 'y') {
                                                            //console.log(attrYn);
                                                            attrList = [];
                                                            let process_attrDtl = process_attr["process_attrDtl"] || [];
                                                            let process_attrDtlength = process_attrDtl.length;
                                                            //console.log(process_attrDtl);
                                                            for (let o = 0; o < process_attrDtlength; o++) {
                                                                attrDtl = {};
                                                                let processattrDtl = process_attrDtl[o];
                                                                let stt = processattrDtl.stt || 0;
                                                                let attr = processattrDtl.attr || '';
                                                                let flg = processattrDtl.flg || '';
                                                                let default_value = processattrDtl.default_value || '';
                                                                if (stt == 1 ) {
                                                                    var data_typ = productAttributeM[attr + "#T"] || '';
                                                                    let display = productAttributeM[attr + "#DS"] || '';
                                                                    let web = productAttributeM[attr + "#W"] || '';
                                                                    attrDtl["attr"] = attr;
                                                                    attrDtl["dataType"] = data_typ;
                                                                    attrDtl["flg"] = flg;
                                                                    attrDtl["default_value"] = default_value;
                                                                    if (source != 'qsol' && source != 'qs') {
                                                                        attrDtl["print"] = web;
                                                                    } else {
                                                                        attrDtl["print"] = display;
                                                                    }
                                                                    if (data_typ == 'c') {
                                                                        let prpVal = productAttributeDtl[attr + "#V"] || [];
                                                                        let prpSort = productAttributeDtl[attr + "#S"] || [];
                                                                        let prpDisplay = productAttributeDtl[attr + "#P"] || [];
                                                                        let prpWeb = productAttributeDtl[attr + "#W"] || [];

                                                                        let prpVallen = prpVal.length;

                                                                        for (let j = 0; j < prpVallen; j++) {
                                                                            prpDtl = {};
                                                                            prpDtl["val"] = prpVal[j] || '';
                                                                            if (source != 'qsol' && source != 'qs') {
                                                                                prpDtl["print"] = prpWeb[j] || '';
                                                                            } else {
                                                                                prpDtl["print"] = prpDisplay[j] || '';
                                                                            }
                                                                            prpDtl["sort"] = prpSort[j] || '';
                                                                            prpList.push(prpDtl);
                                                                        }
                                                                        attrDtl["prpList"] = prpList;
                                                                    }
                                                                    attrList.push(attrDtl);
                                                                }

                                                            }
                                                            outJson["attrList"] = attrList;
                                                        }
                                                        if (settingsYn == 'y') {
                                                            attrList = [];
                                                            let settingsDtl = settings["settingsDtl"] || [];
                                                            let settingsDtlength = settingsDtl.length;
                                                            for (let o = 0; o < settingsDtlength; o++) {
                                                                attrDtl = {};
                                                                let setDtl = settingsDtl[o];
                                                                let stt = setDtl.stt || 0;
                                                                let attr = setDtl.attr || '';
                                                                let flg = setDtl.flg || '';
                                                                let val = setDtl.val || '';
                                                                if (stt == 1) {
                                                                    let display = attributeMaster[attr + "#DS"] || '';
                                                                    let web = attributeMaster[attr + "#W"] || '';
                                                                    attrDtl["attr"] = attr;
                                                                    attrDtl["val"] = val;
                                                                    attrDtl["flg"] = flg;
                                                                    if (source != 'qsol' && source != 'qs') {
                                                                        attrDtl["print"] = web;
                                                                    } else {
                                                                        attrDtl["print"] = display;
                                                                    }
                                                                    attrList.push(attrDtl);
                                                                }
                                                            }
                                                            outJson["settingList"] = attrList;
                                                        }
                                                    }
                                                    outJson["status"] = "SUCCESS";
                                                    outJson["message"] = "SUCCESS";
                                                    callback(null, outJson);
                                                } else {
                                                    outJson["status"] = "SUCCESS";
                                                    outJson["message"] = "Process Not Available";
                                                    callback(null, outJson);
                                                }

                                            }
                                        });
                                    }
                                });
                            }
                        });
                    }
                });
            }
        });
    } else {
        outJson["status"] = "FAIL";
        outJson["message"] = "Please check Process Idn/Name parameter";
        callback(null, outJson);
    }
}

exports.getIssueProcessDtl = function (methodParam, tpoolconn, callback) {
    let optionsYn = methodParam.optionsYn || '';
    let buyerTermsIdn = methodParam.buyerTermsIdn || '';
    let source = methodParam.source || '';
    let settingsYn = methodParam.settingsYn || '';
    let attrYn = methodParam.attrYn || '';
    let processIdn = methodParam.processIdn || '';
    let processNme = methodParam.processNme || '';
    let postIssue = methodParam.postIssue || 'pi';
    let prefix = methodParam.prefix || '';
    let outJson = {};
    var cachedUrl = require('qaq-core-util').cachedUrl;
    var applIdn = methodParam.applIdn || '';
    var coIdn = methodParam.coIdn || '';
 
    if(processIdn != '' || processNme != ''){
        //console.log("getProcessDtl");
        coreUtil.getCache(prefix+"attributeMaster", cachedUrl).then(attributeMaster => {
            if (attributeMaster == null) {
                outJson["status"] = "FAIL";
                outJson["message"] = "Fail to get Application Attribute";
                callback(null, outJson);
            } else {
                attributeMaster = JSON.parse(attributeMaster);
            
                let params = [];
                let fmt = {};
                params.push(coIdn);
                let conQ = " and process_idn=$2"
                if (processNme != '') {
                    conQ = " and nme=$2";
                    params.push(processNme);
                } else {
                    params.push(processIdn);
                }
                let query = "select nme,mdl,process_idn,process_options,settings,process_attr,in_status,iss_status,out_status,grp from stock_process where co_idn=$1 and stt=1 " + conQ;
                //console.log(query);
                //console.log(params);
                coreDB.executeTransSql(tpoolconn, query, params, fmt, async function (error, result) {
                    if (error) {
                        outJson["result"] = '';
                        outJson["status"] = "FAIL";
                        outJson["message"] = "Get getProcessDtl To Execute Query!" + error.message;
                        console.log(outJson);
                        callback(null, outJson);
                    } else {
                        let rowCount = result.rowCount;
                      
                        if (rowCount > 0) {
                            let attrList = [];
                            let attrDtl = {};
                            let prpList = [];
                            let prpDtl = {};

                            for (let i = 0; i < rowCount; i++) {
                                let resultRow = result.rows[i];
                                let process_options = resultRow["process_options"];
                                let settings = resultRow["settings"];
                                let process_attr = resultRow["process_attr"];
                                outJson["process_idn"] = resultRow["process_idn"];
                                outJson["processName"] = resultRow["nme"];
                                outJson["processMdl"] = resultRow["mdl"];
                                outJson["in_status"] = resultRow["in_status"];
                                outJson["iss_status"] = resultRow["iss_status"];
                                outJson["out_status"] = resultRow["out_status"];
                                outJson["grp"] = resultRow["grp"];
                                //console.log(optionsYn);
                                if (settingsYn == 'y') {
                                    attrList = [];
                                    let settingsDtl = settings["settingsDtl"] || [];
                                    let settingsDtlength = settingsDtl.length;
                                    for (let o = 0; o < settingsDtlength; o++) {
                                        attrDtl = {};
                                        let setDtl = settingsDtl[o];
                                        let stt = setDtl.stt || 0;
                                        let attr = setDtl.attr || '';
                                        let flg = setDtl.flg || '';
                                        let val = setDtl.val || '';
                                        if (stt == 1) {
                                            let display = attributeMaster[attr + "#DS"] || '';
                                            let web = attributeMaster[attr + "#W"] || '';
                                            attrDtl["attr"] = attr;
                                            attrDtl["val"] = val;
                                            attrDtl["flg"] = flg;
                                            if (source != 'qsol' && source != 'qs') {
                                                attrDtl["print"] = web;
                                            } else {
                                                attrDtl["print"] = display;
                                            }
                                            attrList.push(attrDtl);
                                        }
                                    }
                                    outJson["settingList"] = attrList;
                                }
                            }
                           
                            //console.log(outJson);
                            outJson["status"] = "SUCCESS";
                            outJson["message"] = "SUCCESS";
                            callback(null, outJson);
                        } else {
                            outJson["status"] = "SUCCESS";
                            outJson["message"] = "Process Not Available";
                            callback(null, outJson);
                        }

                    }
                });
            }
        });
    } else {
        outJson["status"] = "FAIL";
        outJson["message"] = "Please check Process Idn/Name parameter";
        callback(null, outJson);
    }
}

function getChargesDetails(methodParam, tpoolconn){
    return new Promise(function (resolve, reject) {
   let processIdn =  methodParam.processIdn || '';
   let params =[];
   params.push(processIdn);
   let sql="select nme,display,point_base, discount_charges_idn,settings ->> 'applyby' applyby from discount_charges_m where $1=any(process_idn) ";
   coreDB.executeTransSql(tpoolconn, sql, params, {}, function (error, result) {
    if (error) {
        reject(error);
    }
    resolve(result.rows);

    });
   });
    
}

function getCommissiondtl(methodParam, tpoolconn){
    return new Promise(function (resolve, reject) {
        let commdtl={};
   let buyerTermsIdn = methodParam.buyerTermsIdn || '';
    if(buyerTermsIdn!=''){
        let sql="select aadat1_idn, get_nme(aadat1_idn) aadat1,aadat1_pct,aadat1_paid_yn , "+
          " aadat2_idn,get_nme(aadat2_idn) aadat2,aadat2_pct,aadat2_paid_yn, "+
        " brk1_idn,get_nme(brk1_idn) brk1,brk1_pct,brk1_paid_yn, "+
        " brk2_idn,get_nme(brk2_idn) brk2,brk2_pct,brk2_paid_yn, "+
        "  brk3_idn,get_nme(brk3_idn) brk3,brk3_pct,brk3_paid_yn "+
         " from buyer_terms where buyer_terms_idn =$1" ;
         let params=[];
         params.push(buyerTermsIdn);
         coreDB.executeTransSql(tpoolconn, sql, params, {}, function (error, result) {
            if (error) {
                reject(error);
            }
            let  aadat1_idn=result.rows[0].aadat1_idn || '';
            if(aadat1_idn!=''){
                commdtl["aadat1_idn"]=result.rows[0].aadat1_idn || '';
                commdtl["aadat1"]=result.rows[0].aadat1 || '';
                commdtl["aadat1_pct"]=result.rows[0].aadat1_pct || '0';
                commdtl["aadat1_paid_yn"]=result.rows[0].aadat1_paid_yn || '0';
            }
            let  aadat2_idn=result.rows[0].aadat2_idn || '';
            if(aadat2_idn!=''){
                commdtl["aadat2_idn"]=result.rows[0].aadat2_idn || '';
                commdtl["aadat2"]=result.rows[0].aadat2 || '';
                commdtl["aadat2_pct"]=result.rows[0].aadat2_pct || '0';
                commdtl["aadat2_paid_yn"]=result.rows[0].aadat2_paid_yn || '0';
            }
            let  brk1_idn=result.rows[0].brk1_idn || '';
            //console.log("brk1_idn",brk1_idn);
            if(brk1_idn!=''){
                commdtl["brk1_idn"]=result.rows[0].brk1_idn || '';
                commdtl["brk1"]=result.rows[0].brk1 || '';
                commdtl["brk1_pct"]=result.rows[0].brk1_pct || '0';
                commdtl["brk1_paid_yn"]=result.rows[0].brk1_paid_yn || '0';
            }
            let  brk2_idn=result.rows[0].brk2_idn || '';
            if(brk2_idn!=''){
                commdtl["brk2_idn"]=result.rows[0].brk2_idn || '';
                commdtl["brk2"]=result.rows[0].brk2_idn || '';
                commdtl["brk2_pct"]=result.rows[0].brk2_idn || '0';
                commdtl["brk2_paid_yn"]=result.rows[0].brk2_idn || '0';
            }
            let  brk3_idn=result.rows[0].brk3_idn || '';
            if(brk3_idn!=''){
                commdtl["brk3_idn"]=result.rows[0].brk3_idn || '';
                commdtl["brk3"]=result.rows[0].brk3 || '';
                commdtl["brk3_pct"]=result.rows[0].brk3_pct || '0';
                commdtl["brk3_paid_yn"]=result.rows[0].brk3_paid_yn || '0';
            }

            resolve(commdtl);
         });

    }
    resolve(commdtl);
});

}

exports.getName = function (methodParam, tpoolconn, callback) {
    var nmeIdn = methodParam.nmeIdn;
    var coIdn = methodParam.coIdn;
    let fmt = {};
    let params = [];
    let outJson = {};
    let byrNme = '';
    let name = '';
    var sql = "select a.nme_idn,initcap(trim(coalesce(a.nme,'')||' / '||coalesce(a.person_nme,''))) nme,upper(trim(coalesce(a.nme,''))) byrnme from nme_m a where \n" +
        "a.nme_idn=$1 and a.co_idn=$2 and a.stt=1 \n";
    params.push(nmeIdn);
    params.push(coIdn);
    coreDB.executeTransSql(tpoolconn, sql, params, fmt, function (error, result) {
        if (error) {
            console.log(error);
            outJson["status"] = "FAIL";
            outJson["message"] = "Error In getName Method!";
            callback(null, outJson);
        } else {
            var len = result.rows.length;
            if (len > 0) {
                byrNme = result.rows[0].byrnme || "";
                name = result.rows[0].nme || '';
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
            } else {
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
            }
            outJson["byrNme"] = byrNme;
            outJson["nme"] = name;
            callback(null, outJson);
        }
    });
}

exports.validateFoogleStength = function (methodParam, callback) {
    let outJson = {};
    let foogleStr = methodParam.foogleStr;
    let coIdn = methodParam.coIdn;
    let statusList = methodParam.statusList || [];
    let pktTyp = methodParam.pktTyp;
    let statusListlen = statusList.length;
    let prefix = methodParam.prefix || '';
    let cachedUrl = require('qaq-core-util').cachedUrl;
    let delim = "#";
    let multi = ",";
    let attrType = "";
    let attr = "";
    let attrVal = "";
    if (statusListlen > 0) {
        if (statusList[0].indexOf(",") > -1) {
            statusList = statusList[0].split(",");
        }
    }
    //console.log("statusList",statusList);
    coreUtil.getCache(prefix+"productAttributeM_" + coIdn, cachedUrl).then(productAttributeM => {
        // console.log(productAttributeM);
        if (productAttributeM == null) {
            outJson["status"] = "FAIL";
            outJson["message"] = "Fail to get Product Attribute";
            callback(null, outJson);
        } else {
            productAttributeM = JSON.parse(productAttributeM);
            // console.log(productAttributeM);
            coreUtil.getCache(prefix+"productAttributeDtl_" + coIdn, cachedUrl).then(productAttributeDtl => {
                if (productAttributeDtl == null) {
                    outJson["status"] = "FAIL";
                    outJson["message"] = "Fail to get Product Sub Attribute";
                    callback(null, outJson);
                } else {
                    productAttributeDtl = JSON.parse(productAttributeDtl);
                    // console.log(productAttributeDtl);
                    foogleStr = replaceall(" TO ", "TO", foogleStr);
                    foogleStr = replaceall(" to ", "to", foogleStr);
                    foogleStr = replaceall("TO", "#", foogleStr);
                    foogleStr = replaceall("to", "#", foogleStr);
                    foogleStr = replaceall(" - ", "-", foogleStr);
                    foogleStr = replaceall("--", "-", foogleStr);
                    //foogleStr = replaceall("-", "#", foogleStr);
                    foogleStr = replaceall(" ", " ", foogleStr);
                    foogleStr = replaceall(",", " ", foogleStr);
                    
                    // console.log(foogleStr);
                    let cutVals = [];
                    cutVals.push("EXEXEX");
                    cutVals.push("3X");
                    cutVals.push("3EX");
                    cutVals.push("XXX");
                    cutVals.push("3VG");
                    cutVals.push("3VG+");
                    cutVals.push("exexex");
                    cutVals.push("3x");
                    cutVals.push("3ex");
                    cutVals.push("xxx");
                    cutVals.push("3vg");
                    cutVals.push("3vg+");
                    cutVals.push("2EX");
                    cutVals.push("2ex");
                    for (let i = 0; i < cutVals.length; i++) {
                        let val = cutVals[i];
                        if (foogleStr.indexOf(val) > -1) {
                            if (val == "3X" || val == "3EX" || val == "XXX" || val == "EXEXEX" || val == "3x" || val == "3ex" || val == "xxx" || val == "exexex") {
                                foogleStr = replaceall(val, "ex ex ex", foogleStr);
                            } else if (val == "3VG" || val == "3vg") {
                                foogleStr = replaceall(val, "vg vg vg", foogleStr);
                            } else if (val == "3VG+" || val == "3vg+") {
                                foogleStr = replaceall(val, "ex#vg ex#vg ex#vg", foogleStr);
                            } else if (val == "2EX" || val == "2ex") {
                                foogleStr = replaceall(val, "ex ex", foogleStr);
                            }
                        }
                    }
                    //console.log(foogleStr);
                    let srchView = ["sh", "sz", "co", "pu", "ct", "po", "sy", "loc", "fl", "lab"];
                    let srchViewLength = srchView.length;

                    let foogleStrLst = foogleStr.split(" ");
                    let foogleStrLstlength = foogleStrLst.length;
                    for (let i = 0; i < foogleStrLstlength; i++) {
                        let dattr = foogleStrLst[i];
                        let vals = [];
                        let sorts = [];
                        if (dattr.indexOf(delim) > 0) {
                            vals = dattr.split(delim);
                        } else if (dattr.indexOf(multi) > 0) {
                            vals = dattr.split(multi);
                        } else {
                            vals.push(dattr);
                        }
                        let valslength = vals.length;
                        let found = "n";
                        for (let j = 0; j < srchViewLength; j++) {
                            let mattr = srchView[j]
                            var data_typ = productAttributeM[mattr + "#T"] || '';
                            let opt_val = productAttributeDtl[mattr + "#O"] || [];
                            let prpSort = productAttributeDtl[mattr + "#S"] || [];
                            let opt_vallength = opt_val.length;
                            for (let k = 0; k < valslength; k++) {
                                let val = vals[k];
                                for (let l = 0; l < opt_vallength; l++) {
                                    let opt_valdattr = opt_val[l];
                                    if (opt_valdattr.indexOf(val) > -1) {
                                        sorts.push(prpSort[l]);
                                    }
                                }
                            }
                            if (sorts.length > 0) {
                                srchView.splice(j, 1);
                                j = srchViewLength;
                                srchViewLength = srchView.length;
                                if (attrType == '')
                                    attrType = data_typ
                                else
                                    attrType += "#" + data_typ

                                if (attr == '')
                                    attr = mattr
                                else
                                    attr += "#" + mattr

                                if (attrVal == '')
                                    attrVal = sorts.join("@")
                                else
                                    attrVal += "#" + sorts.join("@")
                                found = "y";
                            }
                        }
                        if (found == 'n') {
                            if (valslength == 2 && vals[0].length < 7) {
                                if (parseFloat(vals[0]) > 0 && parseFloat(vals[1]) > 100) {
                                    let mattr = "rte";
                                    var data_typ = productAttributeM[mattr + "#T"] || '';
                                    if (attrType == '')
                                        attrType = data_typ
                                    else
                                        attrType += "#" + data_typ

                                    if (attr == '')
                                        attr = mattr
                                    else
                                        attr += "#" + mattr

                                    if (attrVal == '')
                                        attrVal = parseFloat(vals[0]) + "@" + parseFloat(vals[1]);
                                    else
                                        attrVal += "#" + parseFloat(vals[0]) + "@" + parseFloat(vals[1]);
                                } else if (parseFloat(vals[0]) > 0 && parseFloat(vals[1]) < 100) {
                                    let mattr = "crtwt";
                                    var data_typ = productAttributeM[mattr + "#T"] || '';
                                    if (attrType == '')
                                        attrType = data_typ
                                    else
                                        attrType += "#" + data_typ

                                    if (attr == '')
                                        attr = mattr
                                    else
                                        attr += "#" + mattr

                                    if (attrVal == '')
                                        attrVal = parseFloat(vals[0]) + "@" + parseFloat(vals[1]);
                                    else
                                        attrVal += "#" + parseFloat(vals[0]) + "@" + parseFloat(vals[1]);
                                } else if (parseFloat(vals[0]) < 0) {
                                    let mattr = "rap_dis";
                                    var data_typ = productAttributeM[mattr + "#T"] || '';
                                    if (attrType == '')
                                        attrType = data_typ
                                    else
                                        attrType += "#" + data_typ

                                    if (attr == '')
                                        attr = mattr
                                    else
                                        attr += "#" + mattr

                                    if (attrVal == '')
                                        attrVal = parseFloat(vals[0]) + "@" + parseFloat(vals[1]);
                                    else
                                        attrVal += "#" + parseFloat(vals[0]) + "@" + parseFloat(vals[1]);
                                }
                            } else {
                                if (vals.length == 1) {
                                    vals = [];
                                    let valsArray = foogleStrLst;
                                    vals = valsArray.filter(function (e) {
                                        return e.replace(/(\r\n|\n|\r)/gm,"");
                                    });
                                    i = foogleStrLstlength;
                                }
                                let mattr = "vnm";
                                var data_typ = productAttributeM[mattr + "#T"] || '';
                                if (attrType == '')
                                    attrType = data_typ
                                else
                                    attrType += "#" + data_typ

                                if (attr == '')
                                    attr = mattr
                                else
                                    attr += "#" + mattr

                                if (attrVal == '')
                                    attrVal = vals.join("@")
                                else
                                    attrVal += "#" + vals.join("@")
                            }
                        }
                    }
                    //console.log(attrType);
                    //console.log(attr);
                    //console.log(attrVal);
                    outJson["attrType"] = attrType;
                    outJson["attr"] = attr;
                    outJson["attrVal"] = attrVal;
                    callback(null, outJson);
                }
            });
        }
    });
}

function searchFromSearchIdn(methodParam, tpoolconn, callback) {
    let searchIdn = methodParam.searchIdn;
    let buyerIdn = methodParam.buyerIdn;
    let coIdn = methodParam.coIdn;
    let fmt = {};
    let params = [];
    let outJson = {};
    let sql = "select request_attr,request_attrval,request_attrtyp,request_status,get_search_dscr(search_id) dscr from stock_search where search_id=$1 and co_idn=$2 ";
    params = [];
    params.push(searchIdn);
    params.push(coIdn);
    // console.log(sql);
    // console.log(params);
    coreDB.executeTransSql(tpoolconn, sql, params, fmt, function (error, result) {
        if (error) {
            outJson["status"] = "FAIL";
            outJson["message"] = "Error In searchFromSearchIdn Method!" + error.message;
            callback(null, outJson);
        } else {
            var len = result.rows.length;
            if (len > 0) {
                let statusList = result.rows[0].request_status || [];
                let attrType = result.rows[0].request_attrtyp || '';
                let attr = result.rows[0].request_attr || '';
                let attrVal = result.rows[0].request_attrval || '';
                let srchDscr = result.rows[0].dscr || '';
                if(statusList.length == 0 && attr !='vnm'){
                    statusList = ["MKAV","MKBD"]; //said by purav sir due to demand search not working
                }
                methodParam["statusList"] = statusList;
                methodParam["attrType"] = attrType;
                methodParam["attr"] = attr;
                methodParam["attrVal"] = attrVal;
                methodParam["coIdn"] = coIdn;
                //console.log("statusList",statusList)
                //console.log("attr",attr)
                if(attr == 'vnm' || statusList.length > 0){
                    let strengthresult = coreUtil.validateCriteriaStrength(methodParam);
                    outJson["where_query_str"] = strengthresult.where_query_str;
                    outJson["inputPacketList"] = strengthresult.inputPacketList;
                    outJson["srchDscr"] = srchDscr;
                    outJson["status"] = "SUCCESS";
                    outJson["message"] = "SUCCESS";
                    callback(null, outJson);
                } else {
                    outJson["status"] = "FAIL";
                    outJson["message"] = "Invalid search";
                    callback(null, outJson);
                }      
            } else {
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
                callback(null, outJson);
            }
        }
    });
}

exports.multiEmailIds = function (methodParam, callback) {
    let nmeIdn = methodParam.nme_idn;
    let typ = methodParam.typ;
    let tpoolconn = methodParam.db;
    let userIdn = methodParam.userIdn || '';
    let source = methodParam.source || '';
    source = source.toLowerCase();

    var outJson = {};
    let params = [];


    //sqlQ = "select a.key, a.value " +
    //    "from nme_m JOIN jsonb_each_text(attr) a ON TRUE " +
    //    "where  nme_idn = $1 and a.key like 'email%' ";

    //if (typ == 'SALEX')
    //    sqlQ += " and typ = 'employee'";

    var sqlQ = "";

    if(userIdn != '' && source != 'qs' && source != 'qsol'){
        sqlQ = "select get_eml($1,$2) email";
        params.push(nmeIdn);
        params.push(userIdn);
    } else {
        sqlQ = "select get_eml($1) email";
        params.push(nmeIdn);
    }
    //console.log(sqlQ)
    //console.log(params)
    coreDB.executeTransSql(tpoolconn, sqlQ, params, {}, function (error, result) {
        if (error) {
            outJson["status"] = "FAIL";
            outJson["message"] = "Fail To Execute Query! " + error.message;
            callback(null, outJson);
        } else {
            var len = result.rows.length;
            if (len != 0) {
                var dataDtl = result.rows[0].email;

                //console.log(dataDtl)
                outJson["dataDtl"] = dataDtl;
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
                callback(null, outJson);
            } else {
                outJson["status"] = "FAIL";
                outJson["message"] = "Sorry No Result Found";
                callback(null, outJson);
            }
        }
    });
}

exports.checkSendMailBuyer = function (methodParam, callback) {
    let nmeIdn = methodParam.nme_idn;
    let typ = methodParam.typ;
    let tpoolconn = methodParam.db;
    let userIdn = methodParam.userIdn || '';
    let source = methodParam.source || '';
    source = source.toLowerCase();

    var outJson = {};
    let params = [];


    var sqlQ = "select get_buyer_info($1, 'demand_mail', 'YES') buyerMailYN";
        params.push(nmeIdn);

    //console.log(sqlQ)
    //console.log(params)
    coreDB.executeTransSql(tpoolconn, sqlQ, params, {}, function (error, result) {
        if (error) {
            outJson["status"] = "FAIL";
            outJson["message"] = "Fail To Execute Query! " + error.message;
            callback(null, outJson);
        } else {
            var len = result.rows.length;
            if (len != 0) {
                var buyerMailYN = result.rows[0].buyermailyn || '';

                //console.log(buyerMailYN)
                outJson["buyerMailYN"] = buyerMailYN;
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
                callback(null, outJson);
            } else {
                outJson["status"] = "FAIL";
                outJson["message"] = "Sorry No Result Found";
                callback(null, outJson);
            }
        }
    });
}

exports.nextTrnsProcessQc = function (methodParam, tpoolconn, callback) {
    let processIdn = methodParam.processIdn;
    let coIdn = methodParam.coIdn;
    let fmt = {};
    let params = [];
    let outJson = {};
    let nextTrnsProcessDtl = {};
    let nextTrnsProcessList = [];
    let sql = "select b.process_idn,b.nme,b.print,b.grp,b.typ\n" +
        "from stock_process a,stock_process b\n" +
        "where\n" +
        "a.process_idn=$1 and a.co_idn=$2 and b.co_idn=$3 and\n" +
        "a.iss_status=any(b.in_status) and a.stt=1  and b.stt=1\n" +
        "order by b.srt";
    params.push(processIdn);
    params.push(coIdn);
    params.push(coIdn);
    //console.log(sql);
    //console.log(params);
    coreDB.executeTransSql(tpoolconn, sql, params, fmt, function (error, result) {
        if (error) {
            outJson["status"] = "FAIL";
            outJson["message"] = "Error In summaryTrns Method!";
            callback(null, outJson);
        } else {
            var len = result.rows.length;
            if (len > 0) {
                for (var i = 0; i < len; i++) {
                    nextTrnsProcessDtl = {};
                    nextTrnsProcessDtl["process_idn"] = result.rows[i].process_idn || "";
                    nextTrnsProcessDtl["nme"] = result.rows[i].nme || "";
                    nextTrnsProcessDtl["print"] = result.rows[i].print || "";
                    nextTrnsProcessDtl["grp"] = result.rows[i].grp || "";
                    nextTrnsProcessDtl["typ"] = result.rows[i].typ || "";
                    nextTrnsProcessList.push(nextTrnsProcessDtl);
                }
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
            } else {
                outJson["status"] = "FAIL";
                outJson["message"] = "Sorry No Result Found";
            }
            outJson["nextTrnsProcessList"] = nextTrnsProcessList;
            callback(null, outJson);
        }
    });
}

exports.nextdistinctTrnsProcessQc = function (methodParam, tpoolconn, callback) {
    let processIdn = methodParam.processIdn || [];
    let mixGroupYN = methodParam.mixGroupYN || 'N';
    let coIdn = methodParam.coIdn;
    let fmt = {};
    let params = [];
    let outJson = {};
    let nextTrnsProcessDtl = {};
    let nextTrnsProcessList = [];
    if (processIdn.length > 0) {
        let sql = "select b.process_idn,b.nme,b.print,b.grp,b.typ\n" +
            "from stock_process a,stock_process b\n" +
            "where a.co_idn =$1 and b.co_idn = $2  and \n" +
            "a.process_idn= ANY(ARRAY[" + processIdn.join(",") + "]) \n" ;
            if(mixGroupYN == 'Y')
                sql += " and b.grp like 'mix%' ";
            else 
                sql += " and b.grp not like 'mix%' ";

            sql +=" and a.iss_status=any(b.in_status) and a.stt=1  and b.stt=1  and b.grp <> 'online' \n" +
            " order by b.srt";

            params.push(coIdn);
            params.push(coIdn);    
        //console.log(sql);
        //console.log(params);
        coreDB.executeTransSql(tpoolconn, sql, params, fmt, function (error, result) {
            if (error) {
                outJson["status"] = "FAIL";
                outJson["message"] = "Error In summaryTrns Method!";
                callback(null, outJson);
            } else {
                var len = result.rows.length;
                if (len > 0) {
                    for (var i = 0; i < len; i++) {
                        nextTrnsProcessDtl = {};
                        nextTrnsProcessDtl["process_idn"] = result.rows[i].process_idn || "";
                        nextTrnsProcessDtl["nme"] = result.rows[i].nme || "";
                        nextTrnsProcessDtl["print"] = result.rows[i].print || "";
                        nextTrnsProcessDtl["grp"] = result.rows[i].grp || "";
                        nextTrnsProcessDtl["typ"] = result.rows[i].typ || "";
                        nextTrnsProcessList.push(nextTrnsProcessDtl);
                    }
                    outJson["status"] = "SUCCESS";
                    outJson["message"] = "SUCCESS";
                } else {
                    outJson["status"] = "FAIL";
                    outJson["message"] = "Sorry No Result Found";
                }
                outJson["nextTrnsProcessList"] = nextTrnsProcessList;
                callback(null, outJson);
            }
        });
    } else {
        outJson["status"] = "FAIL";
        outJson["message"] = "Sorry No Result Found";
        outJson["nextTrnsProcessList"] = nextTrnsProcessList;
        callback(null, outJson);
    }
}

exports.getTransactionTermsList = function (methodParam, tpoolconn, callback) {
    let coIdn = methodParam.coIdn || '';
    let buyerIdn = methodParam.buyerIdn || '';
    let outJson = {};
    let fmt = {};
    let params = [];
    let kv = [];
    let map = {};

    let sql = "select get_terms_desc(buyer_terms_idn) val , buyer_terms_idn , get_xrtmod($2,currency_idn) xrt,aadat2_idn,aadat1_idn,brk1_idn,brk2_idn,brk3_idn,"+
                "CASE aadat1_idn WHEN null THEN '' ELSE get_nme(aadat1_idn) END aadat1, \n"+
                "COALESCE(aadat1_pct, 0) aadat1_pct, \n"+
                "CASE aadat2_idn WHEN null THEN '' ELSE get_nme(aadat2_idn) END aadat2,COALESCE(aadat2_pct, 0) aadat2_pct, \n"+
                "CASE brk1_idn WHEN null THEN '' ELSE get_nme(brk1_idn) END brk1,COALESCE(brk1_pct, 0) brk1_pct, \n"+
                "CASE brk2_idn WHEN null THEN '' ELSE get_nme(brk2_idn) END brk2,COALESCE(brk2_pct, 0) brk2_pct, \n"+
                "CASE brk3_idn WHEN null THEN '' ELSE get_nme(brk3_idn) END brk3,COALESCE(brk3_pct, 0) brk3_pct \n"+
              " from buyer_terms where nme_idn=$1 and stt=1 order by default_yn desc";
     params.push(buyerIdn);
     params.push(coIdn);
    //console.log(sql);
    //console.log(params);
    coreDB.executeTransSql(tpoolconn, sql, params, fmt,async function (error, result) {
        if (error) {
            console.log(error);
            outJson["status"] = "FAIL";
            outJson["message"] = "Error In getTransactionBuyerList Method!" + error.message;
            callback(null, outJson);
        } else {
            var len = result.rows.length;
            if (len > 0) {
                for (let i = 0; i < len; i++) {
                    map = {};
                    let term = result.rows[i].term || "";
                    let cur = result.rows[i].cur || "";
                    let ext_pct = result.rows[i].ext_pct || "";
                    let ext_dis = result.rows[i].ext_dis || "";
                    let buyerTermsIdn =result.rows[i].buyer_terms_idn || "";
                    let xrt =result.rows[i].xrt || "1";
                    map["idn"] = buyerTermsIdn;
                    map["val"] = result.rows[i].val || "";
                    map["xrt"] = xrt;
                    map["aadat1"] = result.rows[i].aadat1;
                    map["aadat1_pct"] = result.rows[i].aadat1_pct;
                    map["aadat1_idn"] = result.rows[i].aadat1_idn;
                    map["aadat2"] = result.rows[i].aadat2;
                    map["aadat2_pct"] = result.rows[i].aadat2_pct;
                    map["aadat2_idn"] = result.rows[i].aadat2_idn;
                    map["brk1"] = result.rows[i].brk1;
                    map["brk1_pct"] = result.rows[i].brk1_pct;
                    map["brk1_idn"] = result.rows[i].brk1_idn;
                    map["brk2"] = result.rows[i].brk2;
                    map["brk2_pct"] = result.rows[i].brk2_pct;
                    map["brk2_idn"] = result.rows[i].brk2_idn;
                    map["brk3"] = result.rows[i].brk3;
                    map["brk3_pct"] = result.rows[i].brk3_pct;
                    map["brk3_idn"] = result.rows[i].brk3_idn;
                    methodParam = {}
                    methodParam["buyerTermsIdn"] = buyerTermsIdn;
                    methodParam["exh_rte"] = xrt;
                    methodParam["buyerIdn"] = buyerIdn;
                    methodParam["coIdn"] = coIdn;
                    let loyalty = await coreUtil.execgetLoyaltyDtl(methodParam,tpoolconn);
                    let lSlab = loyalty.resultDtl;
                    map["loySlab"]=lSlab["loyaltyctg"] || '';
                    kv.push(map);
                }
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
            } else {
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
            }
            outJson["termsList"] = kv;
            callback(null, outJson);
        }
    })
}

function executeQuery(methodParam, tpoolconn) {
    return new Promise(function (resolve, reject) {
        var sql = methodParam.sql;
        var params = methodParam.params;
        
        coreDB.executeTransSql(tpoolconn, sql, params, {}, function (error, result) {
            console.log(error);
            if (error) {
                reject(error);
            }
          
            resolve(result.rows);
        });
    });

}

exports.getGroupCompanyDetails = function (methodParam, tpoolconn,callback) {
    let nmeIdn = methodParam.buyerIdn;
    let coIdn = methodParam.coIdn;
    var outJson = {};
    var resultFinal = {};

    sqlQ = "select ship_grp_idn,buyer_grp_idn,nme_idn "+
    "from nme_m "+
    "where "+
    "nme_idn=$1 and co_idn=$2 and stt=1 ";

    params = [];
    params.push(nmeIdn);
    params.push(coIdn);
    //console.log(sqlQ)
    //console.log(params)
    coreDB.executeTransSql(tpoolconn, sqlQ, params, {},async function (error, result) {
        if (error) {
            outJson["status"] = "FAIL";
            outJson["message"] = "Fail To Execute Query! " + error.message;
            callback(null, outJson);
        } else {
            var len = result.rows.length;
            if (len != 0) {
                var grpIdnList = result.rows[0].buyer_grp_idn;
                var shipGrpIdnList = result.rows[0].ship_grp_idn;
                var byrIdn=result.rows[0].nme_idn;
                grpIdnList.push(byrIdn);
                shipGrpIdnList.push(byrIdn);
                //console.log(grpIdnList);
               // console.log(shipGrpIdnList);
                var grpList = [];
                var shipList = [];
                for(var i=0;i<grpIdnList.length;i++){
                    var buyerIdn = grpIdnList[i];                   
                    var methodParam = {       
                        "buyerIdn":buyerIdn,
                        "coIdn":coIdn
                    }
                    let buyerDtl = await coreUtil.execGetAddressDetails(methodParam, tpoolconn);
                    var dataDtl=buyerDtl.dataDtl||'';
                    if(dataDtl!='')
                    grpList.push(dataDtl);
                }
                for(var i=0;i<shipGrpIdnList.length;i++){
                    var buyerIdn = shipGrpIdnList[i];
                    var methodParam = {       
                        "buyerIdn":buyerIdn,
                        "coIdn":coIdn
                    }
                    let buyerDtl = await coreUtil.execGetAddressDetails(methodParam, tpoolconn);
                    var dataDtl=buyerDtl.dataDtl||'';
                    if(dataDtl!='')
                    shipList.push(buyerDtl.dataDtl);
                }
                resultFinal["GroupDetail"]=grpList;
                resultFinal["ShipmentDetail"]=shipList;
                outJson["result"] = resultFinal;
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
                callback(null, outJson);
            } else {
                outJson["status"] = "SUCCESS";
                outJson["message"] = "Sorry No Result Found";
                callback(null, outJson);
            }
        }
    });               
}

exports.getAddressDetails = async function (methodParam, tpoolconn,callback) {
    let nmeIdn = methodParam.buyerIdn;
    let coIdn = methodParam.coIdn;
    var outJson = {};
    var dataDtl = {};
    var addDtl = {};

    let buyerTermsList = await coreUtil.execTransactionBuyerList(methodParam, tpoolconn);
    //console.log(buyerTermsList);
    addDtl["terms"] = buyerTermsList.termsList;

    sqlQ = "select initcap(trim(COALESCE(nme,'')||' / '||COALESCE(person_nme,''))) buyer,nme_idn byridn, "+
        "config ->> 'address_idn' address_idn,config ->> 'building' building, "+
        "config ->> 'city_nm' city_nm,config ->> 'area' area, config->> 'state_nm' state_nm,"+
        "config ->> 'zip' zip,config ->> 'unit_no' unit_no,config ->> 'landmark' landmark,COALESCE(person_nme,'') person_nme  " +
        ",attr->>'gstin' gstin ,attr->>'panno' panno \n"+
        "from nme_m "+
        "CROSS JOIN jsonb_array_elements(address -> 'addressDtl') config "+
        "where 1=1  "+
        "and  config ->> 'stt'='1' and nme_idn=$1 and co_idn=$2 and stt=1 ";

    params = [];
    params.push(nmeIdn);
    params.push(coIdn);
    //console.log(sqlQ)
    ///console.log(params)
    coreDB.executeTransSql(tpoolconn, sqlQ, params, {}, function (error, result) {
        if (error) {
            outJson["status"] = "FAIL";
            outJson["message"] = "Fail To Execute Query! " + error.message;
            callback(null, outJson);
        } else {
            var len = result.rows.length;  
            var addressList=[];
            if (len != 0) {
                var prvBuyer ='';
                for (var i = 0; i < len; i++) {
                    var resultRow = result.rows[i];
                    var buyer = resultRow.buyer;
                    var byridn = resultRow.byridn;
                    dataDtl["byridn"] = byridn;
                    dataDtl["person_nme"] = resultRow.person_nme;
                    dataDtl["gstin"] = resultRow.gstin || '';
                    dataDtl["panno"] = resultRow.panno || ''; 
                    if(prvBuyer == '')
                        prvBuyer = buyer;

                    if(prvBuyer != buyer){
                        dataDtl["buyer"]=prvBuyer;
                        addDtl["address"]=addressList;
                        dataDtl[byridn]=addDtl;
                        prvBuyer = buyer;
                        addressList=[];
                    }
                    var addressDtl={};
                    addressDtl["address_idn"]= resultRow.address_idn;
                    var building = resultRow.building || '';
                    var city_nm = resultRow.city_nm || '';
                    let state_nm = resultRow.state_nm || '';
                    var area = resultRow.area || '';
                    var zip = resultRow.zip || '';
                    var landmark = resultRow.landmark || '';
                    var unit_no = resultRow.unit_no || '';
                    var address = unit_no +" "+ building +" "+ landmark +" "+area+" "+city_nm+" "+state_nm+" "+zip;
                    address = replaceall("null","",address);
                    addressDtl["address"]=address;
                    //addressDtl["building"]= resultRow.building;
                    //addressDtl["city_nm"]= resultRow.city_nm;
                    //addressDtl["area"]= resultRow.area;
                    //addressDtl["zip"]= resultRow.zip;
                    addressList.push(addressDtl);
                }
                dataDtl["buyer"]=prvBuyer;
                addDtl["address"]=addressList;
                dataDtl[byridn]=addDtl;
                //console.log(dataDtl)
                outJson["dataDtl"] = dataDtl;
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
                callback(null, outJson);
            } else {
                outJson["status"] = "SUCCESS";
                outJson["message"] = "Sorry No Result Found";
                callback(null, outJson);
            }
        }
    });
}

exports.getProcessDetails = function (methodParam, tpoolconn, callback) {
    let coIdn = methodParam.coIdn || '';
    let group = methodParam.group || '';
    let processType = methodParam.processType || '';
    let processName = methodParam.processName || '';
    let outJson = {};
    let processDtlLst = [];

    if (group != '') {
        let params = [group,coIdn];
        let fmt = {};
        let query = "select process_idn,print,in_status,out_status,rt_status from stock_process "+
            "where grp=$1 and co_idn=$2 and stt=1 ";

        let cnt=2;
        if(processType != ''){
            cnt++;
            query += " and typ =$"+cnt;
            params.push(processType);
        }
        if(processName != ''){
            cnt++;
            query += " and nme =$"+cnt;
            params.push(processName);
        }
 
        query += " order by srt";
        // console.log(query);
        // console.log(params);
        coreDB.executeTransSql(tpoolconn, query, params, fmt, function (error, result) {
            if (error) {
                outJson["result"] = '';
                outJson["status"] = "FAIL";
                outJson["message"] = "Get Process Details Fail To Execute Query!";
                callback(null, outJson);
            } else {
                let rowCount = result.rowCount;
                if (rowCount > 0) { 
                    for (let k = 0; k < rowCount; k++) {
                        let processDtl = result.rows[k];
                        let params = {};
                        params["process_idn"] = processDtl.process_idn;
                        params["print"] = processDtl.print; 
                        params["k"] = processDtl.process_idn;
                        params["v"] = processDtl.print;  
                        params["in_status"] = processDtl.in_status || [];
                        params["out_status"] = processDtl.out_status || []; 
                        params["rt_status"] = processDtl.rt_status || '';                    
                        processDtlLst.push(params);
                    }
                    outJson["processList"] = processDtlLst;
                    outJson["status"] = "SUCCESS";
                    outJson["message"] = "SUCCESS";
                    callback(null, outJson);
                } else {
                    outJson["processList"] = processDtlLst;
                    outJson["status"] = "SUCCESS";
                    outJson["message"] = "Process Not Available";
                    callback(null, outJson);
                }
            }
        });
    } else if (group == '') {
        outJson["result"] = '';
        outJson["status"] = "FAIL";
        outJson["message"] = "Please Verify group Parameter";
        callback(null, outJson);
    }
}

exports.getLoyaltyDtl=function(tpoolconn,paramJson,callback) {
    var buyerTermsIdn = paramJson.buyerTermsIdn;
    var coIdn = paramJson.coIdn;
    var buyerIdn = paramJson.buyerIdn;
    var exh_rte = paramJson.exh_rte;
    var vlu = "0";
    let outJson = {};
    let resultFinal={};
    let params = [buyerIdn,buyerIdn,vlu,exh_rte,buyerIdn,coIdn];
    let fmt = {};
    let query = "with loy_v as(\n" + 
    "select g.finalVlu,g.loyaltyCtg, g.loyaltyPct, g.lDiff,g.lMemberDiscount,cast($1 as NUMERIC) nme_idn,g.totalvalue \n" + 
    "from get_loyalty_dtls_vlu($2, $3, $4) g)\n" + 
    "select a.finalVlu,a.loyaltyCtg,a.loyaltyPct,a.lDiff,a.lMemberDiscount, a.totalvalue,\n" + 
    "COALESCE(NULLIF(b.attr ->> 'sale_365', ''),'') sale_365\n" + 
    "from loy_v a,nme_m b\n" + 
    "where\n" + 
    "a.nme_idn=b.nme_idn\n" + 
    "and b.nme_idn=$5 and b.co_idn= $6 and b.stt=1 ";
    //console.log(query);
    //console.log(params);
    coreDB.executeTransSql(tpoolconn,query,params,fmt,function(error,result){
        if(error){
            console.log(error);
            outJson["status"]="FAIL";
            outJson["message"]="Error In getLoyaltyDtl Method!"+error.message;
            console.log(outJson);
            callback(null,outJson);
        }else{
            let len=result.rows.length;
                    //console.log(result);
                     if(len>0){
                        for(let k = 0 ;k<len;k++){
                            let resultRow = result.rows[k]; 
                            //console.log(resultRow);
                            resultFinal["loyaltyctg"] = resultRow.loyaltyctg;
                            resultFinal["loyaltypct"] = resultRow.loyaltypct;
                            resultFinal["ldiff"] = resultRow.ldiff;
                            resultFinal["lmemberdiscount"] = resultRow.lmemberdiscount;
                            resultFinal["365"] = resultRow.totalvalue;
                        } 
                     }else{                
                            resultFinal["loyaltyctg"] = "";
                            resultFinal["loyaltypct"] = "";
                            resultFinal["ldiff"] = "";
                            resultFinal["lmemberdiscount"] = "";
                            resultFinal["365"] = "";
                     }     
                     outJson["resultDtl"]=resultFinal;
                     outJson["status"]="SUCCESS";
                     outJson["message"]="SUCCESS";   
                     callback(null,outJson); 
        }
    });     
}

function getTranEmployee(connection,paramJson,callback){
    var transactionIdn = paramJson.transactionIdn || '';
    var outJson = {};
    if(transactionIdn != ''){  
        var params = [transactionIdn];
        var fmt = {};
        var query = "select emp_idn from transaction_sales  where transaction_sales_idn =$1 ";
        coreDB.executeTransSql(connection,query,params,fmt,function(error,result){
            if(error){
                outJson["result"]='';
                outJson["status"]="FAIL";
                outJson["message"]="Get Emp Idn Fail To Execute Query!";
                callback(null,outJson);
            }else{
                if(result.rowCount > 0){
                    var emp_idn = result.rows[0].emp_idn;
                    outJson["result"]=emp_idn;
                    outJson["status"]="SUCCESS";
                    outJson["message"]="SUCCESS";
                    callback(null,outJson);
                }else{
                    outJson["result"]="";
                    outJson["status"]="FAIL";
                    outJson["message"]="Fail to get empIdn";
                    callback(null,outJson);
                }
            }
        });               
    }else if(transactionIdn == ''){
        outJson["result"]='';
        outJson["status"]="FAIL";
        outJson["message"]="Please Verify Transaction Idn Parameter";
        callback(null,outJson);
    }
}

exports.getAuctionDetails = function (methodParam, tpoolconn, callback) {
    let coIdn = methodParam.coIdn || '';
    let processIdn = methodParam.processIdn || '';
    let outJson = {};

    if (processIdn != '') {
        let params = [processIdn,coIdn];
        let fmt = {};
        let query = "select opt ->> 'val' vals,opt->>'attr' attr from stock_process a "+
            "CROSS JOIN jsonb_array_elements(a.settings -> 'settingsDtl') opt "+
            "where 1=1  and a.process_idn=$1 and a.co_idn =$2 and a.stt=1  and opt ->> 'stt'='1' "+ 
            "and opt ->> 'attr' = 'auction_status' ";
        // console.log(query);
        // console.log(params);
        coreDB.executeTransSql(tpoolconn, query, params, fmt, function (error, result) {
            if (error) {
                outJson["result"] = '';
                outJson["status"] = "FAIL";
                outJson["message"] = "Get Process Details Fail To Execute Query!";
                callback(null, outJson);
            } else {
                let rowCount = result.rowCount;
                if (rowCount > 0) { 
                    let resultRows = result.rows[0];                     
                    outJson[resultRows.attr] = resultRows.vals;

                    outJson["status"] = "SUCCESS";
                    outJson["message"] = "SUCCESS";
                    callback(null, outJson);
                } else {
                    outJson["status"] = "FAIL";
                    outJson["message"] = "AuctionDtl Not Available";
                    callback(null, outJson);
                }
            }
        });
    } else if (processIdn == '') {
        outJson["result"] = '';
        outJson["status"] = "FAIL";
        outJson["message"] = "Please Verify processIdn Parameter";
        callback(null, outJson);
    }
}

exports.getAttrList = function(paramJson,connection,callback) {
    var coIdn = paramJson.coIdn;
    var pvtConfigure = paramJson.pvtConfigure || '';

    let fmt = {};
    let params=[];
    let outJson = {};
    var pvt="pvt = 0";
    if(pvtConfigure=='SYS')
    pvt="pvt >= 0";

    let kv=[];
    let attrList = [];
    let map = {};
    map["k"]="";
    map["v"]="Select Attr";
    kv.push(map);
    var sql="select attr,attr || '(' || print || ')' print "+
            "from product_attr_m where $1 = ANY(co_allow) and stt=1 and "+ pvt +
            "order by attr";
    params.push(coIdn);

     //console.log(sql);
     //console.log(params);
    coreDB.executeTransSql(connection,sql,params,fmt,function(error,result){
        if(error){
            console.log(error);
            outJson["status"]="FAIL";
            outJson["message"]="Error In getAttrList Method!";
            callback(null,outJson);
        }else{
            var len=result.rows.length;
            //console.log("len",len);
            if(len>0){
                for(var i=0;i<len;i++){
                    map = {};
                    let attr = result.rows[i].attr || "";
                    map["k"]=attr;
                    map["v"]=result.rows[i].print || "";
                    kv.push(map);
                    attrList.push(attr);
                }
                outJson["result"]=kv;
                outJson["attr"]=attrList;
                outJson["status"]="SUCCESS";
                outJson["message"]="SUCCESS";
                callback(null,outJson);
            }else{
                outJson["result"]=kv;
                outJson["status"]="FAIL";
                outJson["message"]="Attr data not found";
                callback(null,outJson);
            }
        }
    });
}

exports.getEmpDetails = function(methodParam,tpoolconn, callback) {
    let coIdn = methodParam.coIdn;
    let fmt = {};
    let params = [];
    let outJson = {};

    var sql = "select nme_idn from nme_m where nme='auto' and co_idn=$1 ";
    params.push(coIdn);
    //console.log(sql);
    //console.log(params);
    coreDB.executeTransSql(tpoolconn, sql, params, fmt, async function (error, result) {
        if (error) {
            outJson["status"] = "FAIL";
            outJson["message"] = "Error In getEmpDetails Method!" + error.message;
            callback(null, outJson);
        } else {
            var len = result.rows.length;
            if (len > 0) {
                let nme_idn = result.rows[0].nme_idn;

                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
                outJson["result"] = nme_idn;
                callback(null, outJson);
            } else {
                outJson["status"] = "FAIL";
                outJson["message"] = "Sorry No Result Found";
                callback(null, outJson);
            }
        }
    });
}

exports.getLoyaltyDetails = function (tpoolconn, redirectParam, callback) {
    let coIdn = redirectParam.coIdn;
    let buyerIdn = redirectParam.buyerIdn || '';
    let exh_rte = redirectParam.exh_rte || '';
    let vlu = redirectParam.vlu || 0;

    let outJson = {};
    let resultFinal = {};
    if (buyerIdn != '' && exh_rte != '') {
        let params = [buyerIdn, vlu, exh_rte];
        let fmt = {};
        let query = "select g.finalvlu,g.loyaltyctg, g.loyaltypct, g.ldiff,g.lmemberdiscount from get_loyalty_dtls_vlu($1, $2, $3) g\n";
        //console.log(query);
        //console.log(params);
        coreDB.executeTransSql(tpoolconn, query, params, fmt, function (error, result) {
            if (error) {
                outJson["result"] = resultFinal;
                outJson["status"] = "FAIL";
                outJson["message"] = "Get loadToEditBid Execute Query!" + error.message;
                callback(null, outJson);
            } else {
                let len = result.rows.length;
                //console.log(result);
                if (len > 0) {
                    let resultRow = result.rows[0];
                    //console.log(resultRow);
                    resultFinal["finalvlu"] = resultRow.finalvlu;
                    resultFinal["loyaltyctg"] = resultRow.loyaltyctg;
                    resultFinal["loyaltypct"] = resultRow.loyaltypct;
                    resultFinal["ldiff"] = resultRow.ldiff;
                    resultFinal["lmemberdiscount"] = resultRow.lmemberdiscount;
                } else {
                    resultFinal["finalVlu"] = vlu;
                    resultFinal["loyaltyctg"] = "";
                    resultFinal["loyaltypct"] = "";
                    resultFinal["ldiff"] = "";
                    resultFinal["lmemberdiscount"] = "";
                }
                outJson["result"] = resultFinal;
                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
                callback(null, outJson);
            }
        });
    }else if (buyerIdn == '') {
        outJson["result"] = resultFinal;
        outJson["status"] = "FAIL";
        outJson["message"] = "Please Verify Buyer Idn Can not be blank!";
        callback(null, outJson);
    } else if (exh_rte == '') {
        outJson["result"] = resultFinal;
        outJson["status"] = "FAIL";
        outJson["message"] = "Please Verify Exchange rate Can not be blank!";
        callback(null, outJson);
    }
}

exports.authUser = function(connectionWR,connectionRD, paramJson, callback) {
    var username = paramJson.username || '';
    var password = paramJson.password || '';
    var remoteAddr = paramJson.remoteAddr || '0.0.0.0';
    var browser = paramJson.browser;
    var remoteUsr = paramJson.remoteUsr;
    var coIdn = paramJson.coIdn;
    var source = paramJson.source || 'API';
    var formNme = paramJson.formNme;
    var outJson = {};

    if (username != '' && password != '') {
        var queryUsr = "select " +
            "b.user_idn,b.username,b.category pvtconfigure,b.appl_idn  " +
            "from nme_m a,appl_user b,appl_client c where \n" +
            "a.nme_idn=b.nme_idn \n" +
            "and b.co_idn =c.co_idn and lower(b.username)=lower($1) " +
            "and b.password_hash = crypt(lower($2), password_hash) " +
            "and b.co_idn=$3 and a.co_idn=b.co_idn \n" +
            "and a.stt=1 \n" +
            "and b.stt=1 and c.stt = 1 \n" +
            "order by 1";

        var params = [username, password, coIdn];
        //console.log(queryUsr);
        //console.log(params);
        coreDB.executeTransSql(connectionRD, queryUsr, params, {},async function (error, result) {
            if (error) {
                console.log(error);
                outJson["result"] = '';
                outJson["status"] = "FAIL";
                outJson["message"] = "Get User Detail Fail To Execute Query!";
                callback(null, outJson);
            } else {
                //console.log("authuser result",result);
                if (result.rowCount > 0) {
                    var userDtl = result.rows[0];
                    var params = {};
                    params["user_idn"] = userDtl.user_idn;
                    params["username"] = userDtl.username;               
                    params["remoteAddr"] = remoteAddr;
                    params["browser"] = browser;
                    params["remoteUsr"] = remoteUsr;
                    params["macAddr"] = "00-14-22-01-23-45";
                    params["appl_idn"] = userDtl.appl_idn;
                    params["source"] = source;
                    let pvtconfigure = userDtl.pvtconfigure;
                    let userIdn = userDtl.user_idn;
                    addLoginLogDataDTL(connectionWR, params, function (error, logDetails) {
                        if (error) {
                            //console.log(error);
                            outJson["result"] = '';
                            outJson["status"] = "FAIL";
                            outJson["message"] = "Fail To Add Login Log!";
                            callback(null, outJson);
                        } else {
                            logDetails["pvtconfigure"] = pvtconfigure;
                            logDetails["userIdn"] = userIdn;
                            callback(null, logDetails);
                        }
                    });  
                } else {
                    outJson["result"] = '';
                    outJson["status"] = "FAIL";
                    outJson["message"] = "Please check username/password/coIdn parameter!";
                    callback(null, outJson);
                }
            }
        });
    } else if (username == '') {
        outJson["result"] = '';
        outJson["status"] = "FAIL";
        outJson["message"] = "Please Verify Username Parameter";
        callback(null, outJson);
    } else if (password == '') {
        outJson["result"] = '';
        outJson["status"] = "FAIL";
        outJson["message"] = "Please Verify Password Parameter";
        callback(null, outJson);
    }
}

function addLoginLogDataDTL(connectionWR, paramJson, callback) {
    var remoteAddr = paramJson.remoteAddr || '';
    var remoteUsr = paramJson.remoteUsr || '';
    var browser = paramJson.browser || '';
    var macAddr = paramJson.macAddr || '';
    var username = paramJson.username || '';
    var appl_idn = paramJson.appl_idn || '';
    var source = paramJson.source;
    var usrId = paramJson.user_idn || '';
    let is_otp_verified = 0;
    var outJson = {};
    if (usrId != '') {
        var params = {};                 
        var paramms = [usrId, is_otp_verified, browser, source, remoteUsr, remoteAddr, macAddr, username, appl_idn];
        var fmt = {};
        var insLogQ = " INSERT INTO appl_login_log(\n" +
            " user_idn, is_otp_verified, log_in_ts, stt, user_browser, src, link, ip_addr, mac_addr,created_by,appl_idn)\n" +
            "VALUES ($1, $2,  current_timestamp, 1, $3, $4, $5, CAST($6 AS inet), CAST($7 AS macaddr),$8,$9) RETURNING log_idn ";
        //console.log(paramms) 
        //console.log(insLogQ)
        coreDB.executeTransSql(connectionWR, insLogQ, paramms, fmt, function (error, result) {
            if (error) {
               
                console.log(error);
                outJson["result"] = '';
                outJson["status"] = "FAIL";
                outJson["message"] = "Insert Log Id Fail To Execute Query!";
                callback(null, outJson);
            } else {
                //coreDB.doTransCommit(connectionWR);
                var rowCount = result.rowCount;
                if (rowCount > 0) {
                    let logDtls = result.rows[0];
                    var logId = logDtls["log_idn"];
                    outJson["message"] = "SUCCESS";
                    outJson["status"] = "SUCCESS";
                    outJson["result"] = logId;
                    callback(null, outJson);
                }
            }
        })    
    } else if (usrId == '') {
        outJson["result"] = '';
        outJson["status"] = "FAIL";
        outJson["message"] = "Please Verify User Id Parameter";
        callback(null, outJson);
    }
}

function getSubCompanyDetails(methodParam, tpoolconn){
    return new Promise(function (resolve, reject) {
   let coIdn =  methodParam.coIdn || '';
   let params =[];
   params.push(coIdn);
   let sql="select sub_co_idn k , nme v  from acc_sub_co where co_idn=$1 and stt=1 order by srt";
   coreDB.executeTransSql(tpoolconn, sql, params, {}, function (error, result) {
    if (error) {
        reject(error);
    }
    resolve(result.rows);

    });
   });
    
}

exports.getLoginId = function(connection, paramJson, callback) {
    var username = paramJson.username || '';
    let coIdn  = paramJson.coIdn;
    let outJson = {};
    var resultFinal = {};

    if (username != '') {
        let sql = "select a.appl_idn, b.user_idn,b.co_idn,b.nme_idn,  "+
            "b.category,b.username,a.log_idn "+
            "from appl_login_log a , appl_user b  where  a.user_idn=b.user_idn "+
            "and a.log_in_valid_upto > now()  and a.stt = 1 "+
            "and lower(b.username)=lower($1) and b.co_idn = $2 ";

        let params = [];
        params.push(username);
        params.push(coIdn);
        //console.log(sql);
        //console.log(params);
        coreDB.executeTransSql(connection, sql, params, {}, function (error, result) {
            if (error) {
                console.log("getLoginId", error)
                outJson["status"] = "FAIL";
                outJson["message"] = "Fail To Execute getLoginId Function Query! " + error.message;
                callback(null, outJson);
            } else {
                var rowCount = result.rowCount;
                if (rowCount > 0) {
                    let rows=result.rows[0];
                    resultFinal["co_idn"]=rows.co_idn;
                    resultFinal["username"]=rows.username;
                    resultFinal["user_idn"]=rows.user_idn;
                    resultFinal["nme_idn"]=rows.nme_idn;
                    resultFinal["log_idn"]=rows.log_idn;
                    resultFinal["category"]=rows.category;

                    outJson["result"] = resultFinal;
                    outJson["status"] = "SUCCESS";
                    outJson["message"] = "SUCCESS";
                    callback(null, outJson);
                } else {
                    outJson["status"] = "SUCCESS";
                    outJson["message"] = "Log idn not found!";
                    callback(null, outJson);
                }
            }
        })
    } else if(username == ''){
        outJson["status"] = "FAIL";
        outJson["message"] = "Please Verify username Can not be blank!";
        callback(null, outJson);
    } 
}

function unlock(redirectParam,callback) {
  let password = redirectParam.password || '';
  //console.log("key",ezkey);
  var mykey = crypto.createDecipher(algorithm, ezkey);
  var mystr = mykey.update(password, 'hex', 'utf8')
  mystr += mykey.final('utf8');
  let outJson = {};
  outJson["result"] = mystr;
  callback(null,outJson);
}

exports.getPbbXrte = function(methodParam, tpoolconn,callback) {
    let coIdn = methodParam.coIdn;
    let prefix = methodParam.prefix || '';
    var cachedUrl = require('qaq-core-util').cachedUrl;
    var outJson = {};

    let sqlQ = "select   \n"+
        " CAST(get_client_info($1, 'fixed_exh_rte') as numeric) pbbxrte \n";


    let params = [];
    params.push(coIdn);
    //console.log(sqlQ)
    ///console.log(params)
    coreDB.executeTransSql(tpoolconn, sqlQ, params, {},async function (error, result) {
        if (error) {
            outJson["status"] = "FAIL";
            outJson["message"] = "Fail To Execute Query! " + error.message;
            callback(null, outJson);
        } else {
            var len = result.rows.length;  
            if (len != 0) {
                let dbmsDtldata = await coreUtil.getCache(prefix+"dbms_"+coIdn,cachedUrl);
                
                if(dbmsDtldata == null){
                        outJson["status"]="FAIL";
                        outJson["message"]="Fail to get DBMS Attribute";
                        callback(null,outJson);
                }else{ 
                    dbmsDtldata = JSON.parse(dbmsDtldata);
                    var pbb_currency =  dbmsDtldata["pbb_currency"] || '';
                    let pbbxrte = result.rows[0].pbbxrte || {};  
                    if(pbb_currency == 'USD'){
                        pbbxrte = "1";
                    }

                    outJson["pbb_currency"] = pbb_currency;
                    outJson["result"] = pbbxrte;
                    outJson["status"] = "SUCCESS";
                    outJson["message"] = "SUCCESS";
                    callback(null, outJson);
                }
            } else {
                outJson["status"] = "FAIL";
                outJson["message"] = "Sorry No Result Found";
                callback(null, outJson);
            }
        }
    });
}

exports.getMenuRightsDtl = function(methodParam, tpoolconn,callback) {
    let coIdn = methodParam.coIdn;
    let url = methodParam.url || '';
    let userIdn = methodParam.userIdn || '';
    var outJson = {};

    if(url != '' && userIdn != ''){
        let sqlQ = "select b.* from appl_menu a,user_menu b \n"+
            "where a.menu_idn=b.menu_idn and a.lnk=$1 and $2 = any(a.co_allow) \n"+
            "and b.stt=1 and a.stt=1 and b.user_idn=$3 ";


        let params = [];
        params.push(url);
        params.push(coIdn);
        params.push(userIdn);
        //console.log(sqlQ)
        ///console.log(params)
        coreDB.executeTransSql(tpoolconn, sqlQ, params, {}, function (error, result) {
            if (error) {
                outJson["status"] = "FAIL";
                outJson["message"] = "Fail To Execute Query! " + error.message;
                callback(null, outJson);
            } else {
                var len = result.rows.length;  
                if (len > 0) {
                    outJson["dashbordblock"] = "Y";
                    outJson["status"] = "SUCCESS";
                    outJson["message"] = "SUCCESS";
                    callback(null, outJson);
                } else {
                    outJson["dashbordblock"] = "N";
                    outJson["status"] = "SUCCESS";
                    outJson["message"] = "SUCCESS";
                    callback(null, outJson);
                }
            }
        });
    } else if(url ==''){
        outJson["status"]="FAIL";
        outJson["message"]="Please Verify Url Can not be blank!";
        callback(null,outJson);
    }  else if(userIdn ==''){
        outJson["status"]="FAIL";
        outJson["message"]="Please Verify User Idn Can not be blank!";
        callback(null,outJson);
    }
}

exports.getUserDetails = function(methodParam,tpoolconn, callback) {
    let coIdn = methodParam.coIdn;
    let transactionIdn = methodParam.transactionIdn || '';
    let transaction_web_idn = methodParam.transaction_web_idn || '';
    let fmt = {};
    let params = [];
    let outJson = {};

    var sql = "select au.user_idn from transaction_d_web tdw,appl_user au \n"+
        "where  au.username = tdw.created_by  and au.stt= 1 \n"+
        "and au.co_idn = $1 ";
    
    params.push(coIdn);

    let cnt = 1;
    if(transactionIdn != ''){
        cnt++;
        sql += " and  alc_trns_idn =$"+cnt;
        params.push(transactionIdn);
    }
    if(transaction_web_idn != ''){
        cnt++;
        sql += " and  transaction_web_idn =$"+cnt;
        params.push(transaction_web_idn);
    }
    sql += " limit 1 ";
    //console.log(sql);
    //console.log(params);
    coreDB.executeTransSql(tpoolconn, sql, params, fmt, async function (error, result) {
        if (error) {
            console.log(error);
            outJson["status"] = "FAIL";
            outJson["message"] = "Error In getUserDetails Method!" + error.message;
            callback(null, outJson);
        } else {
            var len = result.rows.length;
            if (len > 0) {
                let user_idn = result.rows[0].user_idn;

                outJson["status"] = "SUCCESS";
                outJson["message"] = "SUCCESS";
                outJson["result"] = user_idn;
                callback(null, outJson);
            } else {
                outJson["status"] = "FAIL";
                outJson["message"] = "Sorry No Result Found";
                callback(null, outJson);
            }
        }
    });
}

exports.getSubComDetails = function(methodParam, tpoolconn,callback){
   let coIdn =  methodParam.coIdn || '';
   let params =[];
   let outJson = {};

   params.push(coIdn);
   let sql="select sub_co_idn k , nme v  from acc_sub_co where co_idn=$1 and stt=1 order by srt";
   coreDB.executeTransSql(tpoolconn, sql, params, {}, function (error, result) {
        if (error) {
            console.log(error);
            outJson["status"] = "FAIL";
            outJson["message"] = "Error In getSubComDetails Method!" + error.message;
            callback(null, outJson);
        } else {
            outJson["status"] = "SUCCESS";
            outJson["message"] = "SUCCESS";
            outJson["result"] = result.rows;
            callback(null, outJson);
        }
    });
}

module.exports.unlock = unlock;
module.exports.getTranEmployee = getTranEmployee;
module.exports.searchFromSearchIdn = searchFromSearchIdn;